// Arabia 1.0
// Script: RR
// Concept: Bubble/RR

// Main entry point for random map script
void main(void)
{
	// Text
	rmSetStatusText("",1.0);

	// Set size
	int playerTiles = 7500;
	int sizel=0;
	int sizew=0;
	if(cNumberNonGaiaPlayers == 2)
	{
		sizel=2.4*sqrt(cNumberNonGaiaPlayers*playerTiles);
		sizew=1.7*sqrt(cNumberNonGaiaPlayers*playerTiles);
	}
	else if(cNumberNonGaiaPlayers < 5)
	{
		sizel=2.4*sqrt(cNumberNonGaiaPlayers*playerTiles)*0.85;
		sizew=1.7*sqrt(cNumberNonGaiaPlayers*playerTiles)*0.85;
	}
	else if(cNumberNonGaiaPlayers < 7)
	{
		sizel=2.4*sqrt(cNumberNonGaiaPlayers*playerTiles)*0.85;
		sizew=1.7*sqrt(cNumberNonGaiaPlayers*playerTiles)*0.975;
	}
	else
	{
		sizel=2.4*sqrt(cNumberNonGaiaPlayers*playerTiles)*0.75;
		sizew=1.7*sqrt(cNumberNonGaiaPlayers*playerTiles)*0.95;
	}
	rmSetMapSize(sizel, sizew);

	// Init map
	rmTerrainInitialize("CliffEgyptianA", 9);
	rmSetLightingSet("Alfheim");

	// Define classes
	int classPlayer=rmDefineClass("player");
	int classPlayerCore=rmDefineClass("player core");
	int classForest=rmDefineClass("forest");
	rmDefineClass("starting settlement");
	rmDefineClass("center");
	rmDefineClass("connections");

	// Define sector vars
	float zCenterStart=0.0;
	float zCenterEnd=0.0;

	if(cNumberNonGaiaPlayers == 2)
	{
		zCenterStart=0.25;
		zCenterEnd=0.75;
	}
	else if(cNumberNonGaiaPlayers < 5)
	{
		zCenterStart=0.27;
		zCenterEnd=0.73;
	}
	else if(cNumberNonGaiaPlayers < 7)
	{
		zCenterStart=0.28;
		zCenterEnd=0.72;
	}
	else
	{
		zCenterStart=0.28;
		zCenterEnd=0.72;
	}

	// Constraints
	// General
	int centerConstraint=rmCreateClassDistanceConstraint("player areas avoid center", rmClassID("center"), 10.0);
	int furtherCenterConstraint=rmCreateClassDistanceConstraint("stuff avoids center", rmClassID("center"), 16.0);
	int dummyCenterConstraint=rmCreateBoxConstraint("dummy goes into center", zCenterStart, 0, zCenterEnd, 1);
	int edgeConstraint=rmCreateBoxConstraint("edge of map", rmXTilesToFraction(4), rmZTilesToFraction(4), 1.0-rmXTilesToFraction(4), 1.0-rmZTilesToFraction(4), 0.01);
	int furtherEdgeConstraint=rmCreateBoxConstraint("further avoid edge of map", rmXTilesToFraction(12), rmZTilesToFraction(12), 1.0-rmXTilesToFraction(12), 1.0-rmZTilesToFraction(12), 0.01);
	int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

	// Player
	int playerConstraint=rmCreateClassDistanceConstraint("bonus Settlement stay away from players", classPlayer, 40.0);

	// Connections
	int avoidConnections=rmCreateClassDistanceConstraint("objects avoid connections", rmClassID("connections"), 5.0);
	int longAvoidConnections=rmCreateClassDistanceConstraint("objects avoid connections by long", rmClassID("connections"), 10.0);
	int connectionEdgeConstraint=rmCreateBoxConstraint("connections avoid edge of map", rmXTilesToFraction(16), rmZTilesToFraction(16), 1.0-rmXTilesToFraction(16), 1.0-rmZTilesToFraction(16));

	// Avoid impassable land
	int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, rmXTilesToFraction(8));
	int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 12.0);

	// Settlement
	int shortAvoidSettlement=rmCreateTypeDistanceConstraint("objects avoid TC by short distance", "AbstractSettlement", 10.0);
	int avoidSettlement=rmCreateTypeDistanceConstraint("objects avoid TC by medium distance", "AbstractSettlement", 20.0);
	int farStartingSettleConstraint=rmCreateClassDistanceConstraint("objects avoid player TCs", rmClassID("starting settlement"), 50.0);
	int shortStartingSettleConstraint=rmCreateClassDistanceConstraint("objects avoid player TCs by short distance", rmClassID("starting settlement"), 20.0);

	// Gold
	int farAvoidGold=rmCreateTypeDistanceConstraint("far avoid gold", "gold", 50.0);
	int avoidGold=rmCreateTypeDistanceConstraint("avoid gold", "gold", 40.0);
	int shortAvoidGold=rmCreateTypeDistanceConstraint("short avoid gold", "gold", 10.0);

	// Food
	int avoidFood=rmCreateTypeDistanceConstraint("avoid other food sources", "food", 20.0);
	int avoidHuntable=rmCreateTypeDistanceConstraint("avoid huntable", "huntable", 32.5);
	int avoidPredator=rmCreateTypeDistanceConstraint("avoid predator", "animalPredator", 40.0);
	int shortAvoidPredator=rmCreateTypeDistanceConstraint("short avoid predator", "animalPredator", 30.0);
	int avoidHerdable=rmCreateTypeDistanceConstraint("avoid herdable", "herdable", 50.0);

	// Forest
	int forestConstraint=rmCreateClassDistanceConstraint("forest v forest", rmClassID("forest"), 20.0);
	int forestSettleConstraint=rmCreateClassDistanceConstraint("forest settle", rmClassID("starting settlement"), 17.0);
	int avoidForest=rmCreateClassDistanceConstraint("avoid forest", rmClassID("forest"), 10.0);

	// Buildings
	int avoidTower=rmCreateTypeDistanceConstraint("towers avoid towers", "tower", 22.5);
	int avoidBuildings=rmCreateTypeDistanceConstraint("avoid buildings", "Building", 17.5);

	// Embellishment
	int avoidGrass=rmCreateTypeDistanceConstraint("avoid bush", "bush", 20.0);
	int avoidRugs=rmCreateTypeDistanceConstraint("avoid rugs", "rugs", 10.0);

	// Text
	rmSetStatusText("",0.9);

	// Define objects
	// Starting TC
	int startingSettlementID=rmCreateObjectDef("starting settlement");
	rmAddObjectDefItem(startingSettlementID, "Settlement Level 1", 1, 0.0);
	rmAddObjectDefToClass(startingSettlementID, rmClassID("starting settlement"));
	rmSetObjectDefMinDistance(startingSettlementID, 0.0);
	rmSetObjectDefMaxDistance(startingSettlementID, 0.0);

	// Towers
	int startingTowerID=rmCreateObjectDef("Starting tower");
	rmAddObjectDefItem(startingTowerID, "tower", 1, 0.0);
	rmSetObjectDefMinDistance(startingTowerID, 20.0);
	rmSetObjectDefMaxDistance(startingTowerID, 28.0);
	rmAddObjectDefConstraint(startingTowerID, avoidTower);
	rmAddObjectDefConstraint(startingTowerID, edgeConstraint);

	// Gold
	int startingGoldID=rmCreateObjectDef("Starting gold");
	rmAddObjectDefItem(startingGoldID, "Gold mine small", 1, 0.0);
	rmSetObjectDefMinDistance(startingGoldID, 20.0);
	rmSetObjectDefMaxDistance(startingGoldID, 20.0);
	rmAddObjectDefConstraint(startingGoldID, avoidAll);
	rmAddObjectDefConstraint(startingGoldID, edgeConstraint);

	// Pigs
	int closeGoatsID=rmCreateObjectDef("close goats");
	rmAddObjectDefItem(closeGoatsID, "pig", 2, 2.0);
	rmSetObjectDefMinDistance(closeGoatsID, 25.0);
	rmSetObjectDefMaxDistance(closeGoatsID, 30.0);
	rmAddObjectDefConstraint(closeGoatsID, avoidAll);
	rmAddObjectDefConstraint(closeGoatsID, edgeConstraint);

	// Berries
	int closeChickensID=rmCreateObjectDef("close Chickens");
	rmAddObjectDefItem(closeChickensID, "berry bush", rmRandInt(7,8), 4.0);
	rmSetObjectDefMinDistance(closeChickensID, 20.0);
	rmSetObjectDefMaxDistance(closeChickensID, 25.0);
	rmAddObjectDefConstraint(closeChickensID, avoidAll);
	rmAddObjectDefConstraint(closeChickensID, shortAvoidGold);
	rmAddObjectDefConstraint(closeChickensID, edgeConstraint);

	// Close hunt
	int closeGazelleID=rmCreateObjectDef("close zebra");
	rmAddObjectDefItem(closeGazelleID, "gazelle", rmRandInt(6,7), 2.0);
	rmSetObjectDefMinDistance(closeGazelleID, 30.0);
	rmSetObjectDefMaxDistance(closeGazelleID, 40.0);
	rmAddObjectDefConstraint(closeGazelleID, avoidAll);
	rmAddObjectDefConstraint(closeGazelleID, furtherCenterConstraint);
	rmAddObjectDefConstraint(closeGazelleID, shortAvoidGold);
	rmAddObjectDefConstraint(closeGazelleID, furtherEdgeConstraint);
	rmAddObjectDefConstraint(closeGazelleID, avoidImpassableLand);

	// Straggler trees
	int stragglerTreeID=rmCreateObjectDef("straggler tree");
	rmAddObjectDefItem(stragglerTreeID, "palm", 1, 0.0);
	rmSetObjectDefMinDistance(stragglerTreeID, 12.0);
	rmSetObjectDefMaxDistance(stragglerTreeID, 15.0);
	rmAddObjectDefConstraint(stragglerTreeID, shortAvoidGold);
	rmAddObjectDefConstraint(stragglerTreeID, edgeConstraint);

	// Objects on player plateau
	// Close gold
	int closeGoldID=rmCreateObjectDef("close gold");
	rmAddObjectDefItem(closeGoldID, "Gold mine", 1, 0.0);
	rmSetObjectDefMinDistance(closeGoldID, 60.0);
	rmSetObjectDefMaxDistance(closeGoldID, 65.0);
	if(cNumberNonGaiaPlayers > 5)
		rmAddObjectDefConstraint(closeGoldID, shortAvoidGold);
	rmAddObjectDefConstraint(closeGoldID, edgeConstraint);
	rmAddObjectDefConstraint(closeGoldID, shortAvoidSettlement);
	rmAddObjectDefConstraint(closeGoldID, furtherCenterConstraint);
	rmAddObjectDefConstraint(closeGoldID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(closeGoldID, avoidAll);
	rmAddObjectDefConstraint(closeGoldID, longAvoidImpassableLand);

	// Medium pigs
	int mediumGoatsID=rmCreateObjectDef("medium goats");
	rmAddObjectDefItem(mediumGoatsID, "pig", 2, 2.0);
	rmSetObjectDefMinDistance(mediumGoatsID, 60.0);
	rmSetObjectDefMaxDistance(mediumGoatsID, 70.0);
	rmAddObjectDefConstraint(mediumGoatsID, furtherCenterConstraint);
	rmAddObjectDefConstraint(mediumGoatsID, avoidAll);
	rmAddObjectDefConstraint(mediumGoatsID, edgeConstraint);

	// Medium predator
	int mediumPredatorID=rmCreateObjectDef("medium predator");
	if(rmRandFloat(0,1)<0.5)
		rmAddObjectDefItem(mediumPredatorID, "lion", 2, 4.0);
	else
		rmAddObjectDefItem(mediumPredatorID, "hyena", 2, 4.0);
	rmSetObjectDefMinDistance(mediumPredatorID, 60.0);
	rmSetObjectDefMaxDistance(mediumPredatorID, 100.0);
	rmAddObjectDefConstraint(mediumPredatorID, furtherCenterConstraint);
	rmAddObjectDefConstraint(mediumPredatorID, avoidAll);
	rmAddObjectDefConstraint(mediumPredatorID, shortAvoidPredator);
	rmAddObjectDefConstraint(mediumPredatorID, edgeConstraint);

	// Medium berries
	int mediumBerriesID=rmCreateObjectDef("medium berries");
	rmAddObjectDefItem(mediumBerriesID, "berry bush", rmRandInt(8,9), 4.0);
	rmSetObjectDefMinDistance(mediumBerriesID, 65.0);
	rmSetObjectDefMaxDistance(mediumBerriesID, 80.0);
	rmAddObjectDefConstraint(mediumBerriesID, furtherCenterConstraint);
	rmAddObjectDefConstraint(mediumBerriesID, avoidConnections);
	rmAddObjectDefConstraint(mediumBerriesID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(mediumBerriesID, shortAvoidGold);
	rmAddObjectDefConstraint(mediumBerriesID, shortAvoidSettlement);
	rmAddObjectDefConstraint(mediumBerriesID, avoidFood);
	rmAddObjectDefConstraint(mediumBerriesID, edgeConstraint);
	rmAddObjectDefConstraint(mediumBerriesID, longAvoidImpassableLand);

	// Far berries
	int farBerriesID=rmCreateObjectDef("far berries");
	rmAddObjectDefItem(farBerriesID, "berry bush", rmRandInt(8,9), 4.0);
	rmSetObjectDefMinDistance(farBerriesID, 90.0);
	rmSetObjectDefMaxDistance(farBerriesID, 105.0);
	rmAddObjectDefConstraint(farBerriesID, avoidConnections);
	rmAddObjectDefConstraint(farBerriesID, furtherCenterConstraint);
	rmAddObjectDefConstraint(farBerriesID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(farBerriesID, shortAvoidGold);
	rmAddObjectDefConstraint(farBerriesID, shortAvoidSettlement);
	rmAddObjectDefConstraint(farBerriesID, avoidFood);
	rmAddObjectDefConstraint(farBerriesID, edgeConstraint);
	rmAddObjectDefConstraint(farBerriesID, avoidImpassableLand);

	// Center stuff
	// Medium gold
	int mediumGoldID=rmCreateObjectDef("medium gold");
	rmAddObjectDefItem(mediumGoldID, "Gold mine", 1, 0.0);
	rmSetObjectDefMinDistance(mediumGoldID, 90.0);
	rmSetObjectDefMaxDistance(mediumGoldID, rmXFractionToMeters(0.25));
	rmAddObjectDefConstraint(mediumGoldID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(mediumGoldID, dummyCenterConstraint);
	rmAddObjectDefConstraint(mediumGoldID, avoidSettlement);
	rmAddObjectDefConstraint(mediumGoldID, avoidAll);
	rmAddObjectDefConstraint(mediumGoldID, avoidGold);
	rmAddObjectDefConstraint(mediumGoldID, edgeConstraint);
	rmAddObjectDefConstraint(mediumGoldID, longAvoidImpassableLand);

	// Far gold
	int farGoldID=rmCreateObjectDef("far gold");
	rmAddObjectDefItem(farGoldID, "Gold mine", 1, 0.0);
	rmSetObjectDefMinDistance(farGoldID, 80.0);
	rmSetObjectDefMaxDistance(farGoldID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(farGoldID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(farGoldID, dummyCenterConstraint);
	rmAddObjectDefConstraint(farGoldID, avoidSettlement);
	rmAddObjectDefConstraint(farGoldID, avoidAll);
	rmAddObjectDefConstraint(farGoldID, farAvoidGold);
	rmAddObjectDefConstraint(farGoldID, edgeConstraint);
	rmAddObjectDefConstraint(farGoldID, longAvoidImpassableLand);

	// Far predator
	int farPredatorID=rmCreateObjectDef("far predator");
	if(rmRandFloat(0,1)<0.5)
		rmAddObjectDefItem(farPredatorID, "lion", 2, 4.0);
	else
		rmAddObjectDefItem(farPredatorID, "hyena", 2, 4.0);
	rmSetObjectDefMinDistance(farPredatorID, 120.0);
	rmSetObjectDefMaxDistance(farPredatorID, rmXFractionToMeters(0.25));
	rmAddObjectDefConstraint(farPredatorID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(farPredatorID, avoidAll);
	rmAddObjectDefConstraint(farPredatorID, avoidPredator);
	rmAddObjectDefConstraint(farPredatorID, edgeConstraint);
	rmAddObjectDefConstraint(farPredatorID, dummyCenterConstraint);

	// Hunt
	int bonusHuntable0ID=rmCreateObjectDef("bonus huntable 0");
	rmAddObjectDefItem(bonusHuntable0ID, "gazelle", rmRandInt(4,5), 4.0);
	rmAddObjectDefItem(bonusHuntable0ID, "zebra", rmRandInt(3,4), 4.0);
	if(cNumberNonGaiaPlayers == 2)
	{
		rmSetObjectDefMinDistance(bonusHuntable0ID, 80.0);
		rmSetObjectDefMaxDistance(bonusHuntable0ID, rmXFractionToMeters(0.225));
	}
	else if(cNumberNonGaiaPlayers < 5)
	{
		rmSetObjectDefMinDistance(bonusHuntable0ID, 80.0);
		rmSetObjectDefMaxDistance(bonusHuntable0ID, rmXFractionToMeters(0.175));
	}
	else
	{
		rmSetObjectDefMinDistance(bonusHuntable0ID, 75.0);
		rmSetObjectDefMaxDistance(bonusHuntable0ID, rmXFractionToMeters(0.15));
	}
	rmAddObjectDefConstraint(bonusHuntable0ID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(bonusHuntable0ID, dummyCenterConstraint);
	rmAddObjectDefConstraint(bonusHuntable0ID, avoidAll);
	rmAddObjectDefConstraint(bonusHuntable0ID, avoidFood);
	rmAddObjectDefConstraint(bonusHuntable0ID, edgeConstraint);
	rmAddObjectDefConstraint(bonusHuntable0ID, longAvoidImpassableLand);

	// More hunt
	int bonusHuntable1ID=rmCreateObjectDef("bonus huntable 1");
	if(rmRandFloat(0,1)<0.5)
		rmAddObjectDefItem(bonusHuntable1ID, "giraffe", rmRandInt(4,5), 4.0);
	else
	{
		rmAddObjectDefItem(bonusHuntable1ID, "giraffe", rmRandInt(2,3), 4.0);
		rmAddObjectDefItem(bonusHuntable1ID, "gazelle", rmRandInt(3,4), 4.0);
	}
	if(cNumberNonGaiaPlayers == 2)
	{
		rmSetObjectDefMinDistance(bonusHuntable1ID, 75.0);
		rmSetObjectDefMaxDistance(bonusHuntable1ID, rmXFractionToMeters(0.225));
	}
	else  if(cNumberNonGaiaPlayers < 5)
	{
		rmSetObjectDefMinDistance(bonusHuntable1ID, 75.0);
		rmSetObjectDefMaxDistance(bonusHuntable1ID, rmXFractionToMeters(0.175));
	}
	else
	{
		rmSetObjectDefMinDistance(bonusHuntable1ID, 75.0);
		rmSetObjectDefMaxDistance(bonusHuntable1ID, rmXFractionToMeters(0.15));
	}
	rmAddObjectDefConstraint(bonusHuntable1ID, avoidHuntable);
	rmAddObjectDefConstraint(bonusHuntable1ID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(bonusHuntable1ID, dummyCenterConstraint);
	rmAddObjectDefConstraint(bonusHuntable1ID, avoidAll);
	rmAddObjectDefConstraint(bonusHuntable1ID, avoidFood);
	rmAddObjectDefConstraint(bonusHuntable1ID, edgeConstraint);
	rmAddObjectDefConstraint(bonusHuntable1ID, longAvoidImpassableLand);

	// Some more hunt
	int bonusHuntable2ID=rmCreateObjectDef("bonus huntable 2");
	rmAddObjectDefItem(bonusHuntable2ID, "elephant", 2, 7.0);
	rmSetObjectDefMinDistance(bonusHuntable2ID, rmXFractionToMeters(0.35));
	rmSetObjectDefMaxDistance(bonusHuntable2ID, rmXFractionToMeters(0.4));
	rmAddObjectDefConstraint(bonusHuntable2ID, avoidHuntable);
	rmAddObjectDefConstraint(bonusHuntable2ID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(bonusHuntable2ID, dummyCenterConstraint);
	rmAddObjectDefConstraint(bonusHuntable2ID, avoidAll);
	rmAddObjectDefConstraint(bonusHuntable2ID, avoidFood);
	rmAddObjectDefConstraint(bonusHuntable2ID, edgeConstraint);
	rmAddObjectDefConstraint(bonusHuntable2ID, longAvoidImpassableLand);

	// Even some more hunt
	int bonusHuntable3ID=rmCreateObjectDef("bonus huntable 3");
	rmAddObjectDefItem(bonusHuntable3ID, "hippo", 3, 6.0);
	rmSetObjectDefMinDistance(bonusHuntable3ID, rmXFractionToMeters(0.3));
	rmSetObjectDefMaxDistance(bonusHuntable3ID, rmXFractionToMeters(0.35));
	rmAddObjectDefConstraint(bonusHuntable3ID, avoidHuntable);
	rmAddObjectDefConstraint(bonusHuntable3ID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(bonusHuntable3ID, dummyCenterConstraint);
	rmAddObjectDefConstraint(bonusHuntable3ID, avoidAll);
	rmAddObjectDefConstraint(bonusHuntable3ID, avoidFood);
	rmAddObjectDefConstraint(bonusHuntable3ID, edgeConstraint);
	rmAddObjectDefConstraint(bonusHuntable3ID, longAvoidImpassableLand);

	// 999
	int bonusHuntable4ID=rmCreateObjectDef("bonus huntable 4");
	rmAddObjectDefItem(bonusHuntable4ID, "baboon", 8, 5.0);
	rmSetObjectDefMinDistance(bonusHuntable4ID, rmXFractionToMeters(0.45));
	rmSetObjectDefMaxDistance(bonusHuntable4ID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(bonusHuntable4ID, avoidHuntable);
	rmAddObjectDefConstraint(bonusHuntable4ID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(bonusHuntable4ID, dummyCenterConstraint);
	rmAddObjectDefConstraint(bonusHuntable4ID, avoidAll);
	rmAddObjectDefConstraint(bonusHuntable4ID, avoidFood);
	rmAddObjectDefConstraint(bonusHuntable4ID, edgeConstraint);
	rmAddObjectDefConstraint(bonusHuntable4ID, longAvoidImpassableLand);

	// Yeah whatever
	int bonusHuntable5ID=rmCreateObjectDef("bonus huntable 5");
	rmAddObjectDefItem(bonusHuntable5ID, "giraffe", rmRandInt(2,3), 4.0);
	rmAddObjectDefItem(bonusHuntable5ID, "gazelle", rmRandInt(3,4), 4.0);
	rmSetObjectDefMinDistance(bonusHuntable5ID, rmXFractionToMeters(0.25));
	rmSetObjectDefMaxDistance(bonusHuntable5ID, rmXFractionToMeters(0.35));
	rmAddObjectDefConstraint(bonusHuntable5ID, avoidHuntable);
	rmAddObjectDefConstraint(bonusHuntable5ID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(bonusHuntable5ID, dummyCenterConstraint);
	rmAddObjectDefConstraint(bonusHuntable5ID, avoidAll);
	rmAddObjectDefConstraint(bonusHuntable5ID, avoidFood);
	rmAddObjectDefConstraint(bonusHuntable5ID, edgeConstraint);
	rmAddObjectDefConstraint(bonusHuntable5ID, longAvoidImpassableLand);

	// Far pigs
	int farGoatsID=rmCreateObjectDef("far goats");
	rmAddObjectDefItem(farGoatsID, "pig", 2, 2.0);
	rmSetObjectDefMinDistance(farGoatsID, rmXFractionToMeters(0.2));
	rmSetObjectDefMaxDistance(farGoatsID, rmXFractionToMeters(0.35));
	rmAddObjectDefConstraint(farGoatsID, dummyCenterConstraint);
	rmAddObjectDefConstraint(farGoatsID, avoidAll);
	rmAddObjectDefConstraint(farGoatsID, edgeConstraint);
	rmAddObjectDefConstraint(farGoatsID, avoidHerdable);
	rmAddObjectDefConstraint(farGoatsID, longAvoidImpassableLand);
	rmAddObjectDefConstraint(farGoatsID, farStartingSettleConstraint);

	// Random Trees
	int randomTreeID=rmCreateObjectDef("random tree");
	rmAddObjectDefItem(randomTreeID, "palm", 1, 0.0);
	rmSetObjectDefMinDistance(randomTreeID, 0.0);
	rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(randomTreeID, rmCreateTypeDistanceConstraint("random tree", "all", 4.0));
	rmAddObjectDefConstraint(randomTreeID, shortAvoidSettlement);
	rmAddObjectDefConstraint(randomTreeID, avoidAll);
	rmAddObjectDefConstraint(randomTreeID, avoidConnections);

	// Relics
	int relic1ID=rmCreateObjectDef("relics");
	rmAddObjectDefItem(relic1ID, "relic", 1, 0.0);
	rmSetObjectDefMinDistance(relic1ID, 60.0);
	rmSetObjectDefMaxDistance(relic1ID, 200.0);
	rmAddObjectDefConstraint(relic1ID, edgeConstraint);
	rmAddObjectDefConstraint(relic1ID, rmCreateTypeDistanceConstraint("relic vs relic 1", "relic", 50.0));
	rmAddObjectDefConstraint(relic1ID, furtherCenterConstraint);
	rmAddObjectDefConstraint(relic1ID, avoidAll);

	// More relics
	int relic2ID=rmCreateObjectDef("more relics");
	rmAddObjectDefItem(relic2ID, "relic", 1, 0.0);
	rmSetObjectDefMinDistance(relic2ID, 100.0);
	rmSetObjectDefMaxDistance(relic2ID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(relic2ID, edgeConstraint);
	rmAddObjectDefConstraint(relic2ID, rmCreateTypeDistanceConstraint("relic vs relic 2", "relic", 50.0));
	rmAddObjectDefConstraint(relic2ID, dummyCenterConstraint);
	rmAddObjectDefConstraint(relic2ID, avoidAll);

	// Birds
	int farhawkID=rmCreateObjectDef("far hawks");
	rmAddObjectDefItem(farhawkID, "vulture", 1, 0.0);
	rmSetObjectDefMinDistance(farhawkID, 0.0);
	rmSetObjectDefMaxDistance(farhawkID, rmXFractionToMeters(0.5));

	// Text
	rmSetStatusText("",0.8);

	// Generic stuff
	// Place Players
	int startPos = 0;
	if(cNumberNonGaiaPlayers == 2)
	{
		startPos = rmRandInt(1,8);
		if(startPos == 1)
		{
			rmPlacePlayer(1, rmRandFloat(0.07,0.09), rmRandFloat(0.15,0.18));
			rmPlacePlayer(2, rmRandFloat(0.91,0.93), rmRandFloat(0.82,0.85));
		}
		else if(startPos == 2)
		{
			rmPlacePlayer(1, rmRandFloat(0.91,0.93), rmRandFloat(0.82,0.85));
			rmPlacePlayer(2, rmRandFloat(0.07,0.09), rmRandFloat(0.15,0.18));
		}
		else if(startPos == 3)
		{
			rmPlacePlayer(1, rmRandFloat(0.07,0.09), rmRandFloat(0.82,0.85));
			rmPlacePlayer(2, rmRandFloat(0.91,0.93), rmRandFloat(0.15,0.18));
		}
		else if(startPos == 4)
		{
			rmPlacePlayer(1, rmRandFloat(0.91,0.93), rmRandFloat(0.15,0.18));
			rmPlacePlayer(2, rmRandFloat(0.07,0.09), rmRandFloat(0.82,0.85));
		}
		else if(startPos == 5)
		{
			rmPlacePlayer(1, rmRandFloat(0.07,0.09), rmRandFloat(0.15,0.18));
			rmPlacePlayer(2, rmRandFloat(0.91,0.93), rmRandFloat(0.15,0.18));
		}
		else if(startPos == 6)
		{
			rmPlacePlayer(1, rmRandFloat(0.91,0.93), rmRandFloat(0.15,0.18));
			rmPlacePlayer(2, rmRandFloat(0.07,0.09), rmRandFloat(0.15,0.18));
		}
		else if(startPos == 7)
		{
			rmPlacePlayer(1, rmRandFloat(0.07,0.09), rmRandFloat(0.82,0.85));
			rmPlacePlayer(2, rmRandFloat(0.91,0.93), rmRandFloat(0.82,0.85));
		}
		else if(startPos == 8)
		{
			rmPlacePlayer(1, rmRandFloat(0.91,0.93), rmRandFloat(0.82,0.85));
			rmPlacePlayer(2, rmRandFloat(0.07,0.09), rmRandFloat(0.82,0.85));
		}
	}
	else if(cNumberTeams < 3)
	{
		if(cNumberNonGaiaPlayers < 5)
	  {
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.14, 0.12, 0.14, 0.58);
			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.86, 0.12, 0.86, 0.58);
		}
	  else if(cNumberNonGaiaPlayers < 7)
	  {
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(rmRandFloat(0.16,0.17), 0.12, rmRandFloat(0.16,0.17), 0.68);
			rmSetPlacementTeam(1);
			rmPlacePlayersLine(rmRandFloat(0.83,0.84), 0.12, rmRandFloat(0.83,0.84), 0.68);
		}
	  else
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.18, 0.12, 0.18, 0.78);
			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.82, 0.12, 0.82, 0.78);
		}
	}
	else
		rmPlacePlayersSquare(0.4, 0.4, rmDegreesToRadians(5.0));
		// Impossible to get a fair placement with 3+ teams

	// Create connections
	int connectionID=rmCreateConnection("connections");
	rmSetConnectionType(connectionID, cConnectAreas, true, 1);
	if(cNumberNonGaiaPlayers == 2)
		rmSetConnectionWidth(connectionID, rmRandInt(28,32), 0);
	else if(cNumberNonGaiaPlayers < 5)
		rmSetConnectionWidth(connectionID, 21, 0);
	else
	  rmSetConnectionWidth(connectionID, 14, 0);
	rmSetConnectionWarnFailure(connectionID, false);
	rmSetConnectionBaseHeight(connectionID, 7.0);
	rmSetConnectionHeightBlend(connectionID, 2.0);
	rmSetConnectionCoherence(connectionID, 1);
	if(startPos < 5)
		rmSetConnectionPositionVariance(connectionID, 25);
	rmSetConnectionSmoothDistance(connectionID, 8);
	rmAddConnectionStartConstraint(connectionID, connectionEdgeConstraint);
	rmAddConnectionEndConstraint(connectionID, connectionEdgeConstraint);
	rmAddConnectionStartConstraint(connectionID, longAvoidConnections);
	rmAddConnectionEndConstraint(connectionID, longAvoidConnections);
	rmAddConnectionToClass(connectionID, rmClassID("connections"));
	rmAddConnectionTerrainReplacement(connectionID, "CliffEgyptianA", "SandA");

	// Create extra connections
	int extraConnectionsID=rmCreateConnection("extra Connections");
	rmSetConnectionType(extraConnectionsID, cConnectAreas, false, 1);
	if(cNumberNonGaiaPlayers == 2)
		rmSetConnectionWidth(extraConnectionsID, rmRandInt(25,28), 0);
	else if(cNumberNonGaiaPlayers < 5)
		rmSetConnectionWidth(extraConnectionsID, 21, 0);
	else
	  rmSetConnectionWidth(extraConnectionsID, 12, 0);
	rmSetConnectionWarnFailure(extraConnectionsID, false);
	rmSetConnectionBaseHeight(extraConnectionsID, 7.0);
	rmSetConnectionHeightBlend(extraConnectionsID, 2.0);
	rmSetConnectionCoherence(extraConnectionsID, 1);
	rmSetConnectionSmoothDistance(extraConnectionsID, 8);
	rmAddConnectionStartConstraint(extraConnectionsID, connectionEdgeConstraint);
	rmAddConnectionEndConstraint(extraConnectionsID, connectionEdgeConstraint);
	rmAddConnectionStartConstraint(extraConnectionsID, longAvoidConnections);
	rmAddConnectionEndConstraint(extraConnectionsID, longAvoidConnections);
	rmAddConnectionToClass(extraConnectionsID, rmClassID("connections"));
	rmAddConnectionTerrainReplacement(extraConnectionsID, "CliffEgyptianA", "SandA");

	// Text
	rmSetStatusText("",0.7);

	// Generate terrain
	// Fake center area
	int fakeCenterID=rmCreateArea("dummy center 1");
	rmSetAreaSize(fakeCenterID, 0.6, 0.6);
	rmSetAreaBaseHeight(fakeCenterID, 0.0);
	rmAddAreaConstraint(fakeCenterID, dummyCenterConstraint);
	rmSetAreaTerrainType(fakeCenterID, "SandA");
	rmAddAreaToClass(fakeCenterID, rmClassID("center"));
	rmSetAreaWarnFailure(fakeCenterID, false);
	rmBuildArea(fakeCenterID);

	// Fake player area 1
	for(i=1; <cNumberPlayers)
	{
		int id=rmCreateArea("Fake area"+i);
		rmSetAreaSize(id, 0.25, 0.25);
		rmSetAreaBaseHeight(id, 9.0);
		rmAddAreaToClass(id, classPlayerCore);
		rmSetAreaLocPlayer(id, i);
	}
	rmBuildAllAreas();

	// Fake player area 2
	for(i=1; <cNumberPlayers)
	{
		id=rmCreateArea("Player core"+i);
		rmSetPlayerArea(i, id);
		rmSetAreaSize(id, 0.25, 0.25);
		rmSetAreaBaseHeight(id, 9.0);
		rmAddAreaToClass(id, classPlayer);
		rmAddAreaConstraint(id, centerConstraint);
		rmSetAreaTerrainType(id, "SandA");
		rmSetAreaLocPlayer(id, i);
		rmSetAreaSmoothDistance(id, 8);
		rmAddConnectionArea(connectionID, id);
		rmSetAreaWarnFailure(id, false);
	}
	rmBuildAllAreas();

	// Text
	rmSetStatusText("",0.6);

	// Starting TC
	rmPlaceObjectDefPerPlayer(startingSettlementID, true);

	// Settlement 1
	if(cNumberNonGaiaPlayers < 5)
		id=rmAddFairLoc("Settlement", false, true, 90, 100, 50, 16);
	else
		{
			id=rmAddFairLoc("Settlement", false, true, 50, 80, 30, 4);
		  rmAddFairLocConstraint(id, shortStartingSettleConstraint);
	  }
	rmAddFairLocConstraint(id, furtherCenterConstraint);

	if(rmPlaceFairLocs())
	{
		id=rmCreateObjectDef("far settlement");
		rmAddObjectDefItem(id, "Settlement", 1, 0.0);
		for(i=1; <cNumberPlayers)
		{
			for(j=0; <rmGetNumberFairLocs(i))
			{
				int settleArea=rmCreateArea("settlement area"+i +j, rmAreaID("Player core"+i));
				rmSetAreaLocation(settleArea, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j));
				rmBuildArea(settleArea);
				rmPlaceObjectDefAtAreaLoc(id, i, settleArea);
				rmAddConnectionArea(extraConnectionsID, settleArea);
			}
		}
	}

	if(cNumberNonGaiaPlayers < 5)
		rmBuildConnection(extraConnectionsID);
	rmResetFairLocs();
	rmBuildConnection(connectionID);

	// Text
	rmSetStatusText("",0.5);

	// Fake center area 2
	fakeCenterID=rmCreateArea("dummy center 2");
	rmSetAreaSize(fakeCenterID, 0.6, 0.6);
	rmSetAreaBaseHeight(fakeCenterID, 0.0);
	rmAddAreaConstraint(fakeCenterID, dummyCenterConstraint);
	rmSetAreaTerrainType(fakeCenterID, "SandA");
	rmAddAreaToClass(fakeCenterID, rmClassID("center"));
	rmSetAreaWarnFailure(fakeCenterID, false);
	rmBuildArea(fakeCenterID);

	// Settlement 2
	id=rmAddFairLoc("Settlement", true, false,  85, 110, 60, 30);
	rmAddFairLocConstraint(id, avoidImpassableLand);
	rmAddFairLocConstraint(id, playerConstraint);

	if(rmPlaceFairLocs())
	{
		id=rmCreateObjectDef("bonus settlement");
		rmAddObjectDefItem(id, "Settlement", 1, 0.0);
		for(i=1; <cNumberPlayers)
		{
			for(j=0; <rmGetNumberFairLocs(i))
			{
				int bonusSettleArea = rmCreateArea("bonus settlement area"+i +j);
				rmSetAreaLocation(bonusSettleArea, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j));
				rmBuildArea(bonusSettleArea);
				rmPlaceObjectDefAtAreaLoc(id, i, bonusSettleArea);
			}
		}
	}

	// Rebuild Center
	int centerID=rmCreateArea("center");
	rmSetAreaSize(centerID, 0.6, 0.6);
	rmAddAreaConstraint(centerID, dummyCenterConstraint);
	rmSetAreaBaseHeight(centerID, 0.0);
	rmSetAreaSmoothDistance(centerID, 0);
	rmSetAreaHeightBlend(centerID, 2);
	rmSetAreaTerrainType(centerID, "SandA");
	rmAddAreaToClass(centerID, rmClassID("center"));
	rmSetAreaWarnFailure(centerID, false);
	rmBuildAllAreas();

	// Build Player Area
	for(i=1; <cNumberPlayers)
	{
		id=rmCreateArea("Player"+i);
		rmSetPlayerArea(i, id);
		rmSetAreaSize(id, 0.25, 0.25);
		rmAddAreaToClass(id, classPlayer);
		rmAddAreaConstraint(id, centerConstraint);
		rmSetAreaTerrainType(id, "SandA");
		rmSetAreaBaseHeight(id, 9);
		rmSetAreaLocPlayer(id, i);
		rmSetAreaSmoothDistance(id, 5);
		rmSetAreaHeightBlend(id, 2);
	  rmSetAreaWarnFailure(id, false);
	}

	 rmBuildAllAreas();

	// Text
	rmSetStatusText("",0.4);

	// Texture embellishment
	for(i=1; <cNumberPlayers*10)
	{
		int id1=rmCreateArea("beautification"+i);
		rmSetAreaSize(id1, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(id1, "EgyptianRoadA");
		rmAddAreaConstraint(id1, avoidImpassableLand);
		rmSetAreaMinBlobs(id1, 1);
		rmSetAreaMaxBlobs(id1, 5);
		rmSetAreaWarnFailure(id1, false);
		rmSetAreaMinBlobDistance(id1, 16.0);
		rmSetAreaMaxBlobDistance(id1, 40.0);
		rmSetAreaCoherence(id1, 0.6);
		rmBuildArea(id1);
	}

	 for(i=1; <cNumberPlayers*12)
	{
		int id2=rmCreateArea("more beautification"+i);
		rmSetAreaSize(id2, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(id2, "SavannahB");
		rmAddAreaConstraint(id2, avoidImpassableLand);
		rmSetAreaMinBlobs(id2, 1);
		rmSetAreaMaxBlobs(id2, 5);
		rmSetAreaWarnFailure(id2, false);
		rmSetAreaMinBlobDistance(id2, 16.0);
		rmSetAreaMaxBlobDistance(id2, 40.0);
		rmSetAreaCoherence(id2, 0.2);
		rmBuildArea(id2);
	}

	for(i=1; <cNumberPlayers*12)
	{
		int id3=rmCreateArea("even more beautification"+i);
		rmSetAreaSize(id3, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(id3, "SavannahA");
		rmAddAreaConstraint(id3, avoidImpassableLand);
		rmSetAreaMinBlobs(id3, 1);
		rmSetAreaMaxBlobs(id3, 5);
		rmSetAreaWarnFailure(id3, false);
		rmSetAreaMinBlobDistance(id3, 16.0);
		rmSetAreaMaxBlobDistance(id3, 40.0);
		rmSetAreaCoherence(id3, 0.2);
		rmBuildArea(id3);
	}

	// Text
	rmSetStatusText("",0.3);

	// Place close stuff
	// Towers
	rmPlaceObjectDefPerPlayer(startingTowerID, true, 4);

	// Straggler trees
	rmPlaceObjectDefPerPlayer(stragglerTreeID, false, rmRandInt(4,7));

	// Gold
	rmPlaceObjectDefPerPlayer(startingGoldID, false);

	// Berries
	rmPlaceObjectDefPerPlayer(closeChickensID, true);

	// Pigs
	rmPlaceObjectDefPerPlayer(closeGoatsID, true);

	// Close hunt
	rmPlaceObjectDefPerPlayer(closeGazelleID, false);

	// Plateau stuff
	// Close gold
	rmPlaceObjectDefPerPlayer(closeGoldID, false);

	// Medium berries
	rmPlaceObjectDefPerPlayer(mediumBerriesID, false);

	// Far berries
	if(cNumberNonGaiaPlayers == 2)
		rmPlaceObjectDefPerPlayer(farBerriesID, false);

	// Medium pigs
	rmPlaceObjectDefPerPlayer(mediumGoatsID, false);

	// Medium predators
	rmPlaceObjectDefPerPlayer(mediumPredatorID, false);

	// Player forest
	int playerForestCount=7*cNumberNonGaiaPlayers;
	int playerFailCount=0;
	for(i=0; <playerForestCount)
	{
		int playerForestID=rmCreateArea("playerForest"+i);
		rmSetAreaSize(playerForestID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));
		rmSetAreaWarnFailure(playerForestID, false);
		rmSetAreaForestType(playerForestID, "palm forest");
		rmAddAreaToClass(playerForestID, classForest);
		rmSetAreaMinBlobs(playerForestID, 1);
		rmSetAreaMaxBlobs(playerForestID, 2);
		rmAddAreaConstraint(playerForestID, furtherCenterConstraint);
		rmAddAreaConstraint(playerForestID, avoidConnections);
		rmAddAreaConstraint(playerForestID, avoidImpassableLand);
		rmAddAreaConstraint(playerForestID, avoidAll);
		rmAddAreaConstraint(playerForestID, forestSettleConstraint);
		rmAddAreaConstraint(playerForestID, forestConstraint);
		rmSetAreaMinBlobDistance(playerForestID, 5.0);
		rmSetAreaMaxBlobDistance(playerForestID, 15.0);
		rmSetAreaCoherence(playerForestID, 0.0);
		if(rmBuildArea(playerForestID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			playerFailCount++;
			if(playerFailCount==3)
				break;
		}
		else
			playerFailCount=0;
	}

	// Text
	rmSetStatusText("",0.2);

	// Center stuff
	// Gold
	rmPlaceObjectDefPerPlayer(mediumGoldID, false, 1);
	rmPlaceObjectDefPerPlayer(farGoldID, false, 2);

	// Huntable
	rmPlaceObjectDefPerPlayer(bonusHuntable0ID, false);
	rmPlaceObjectDefPerPlayer(bonusHuntable1ID, false);
	if(cNumberNonGaiaPlayers == 2)
		rmPlaceObjectDefPerPlayer(bonusHuntable3ID, false);
	if(cNumberNonGaiaPlayers > 4)
		rmPlaceObjectDefPerPlayer(bonusHuntable3ID, false);
	if(rmRandFloat(0,1)<0.75)
		rmPlaceObjectDefPerPlayer(bonusHuntable5ID, false);
	rmPlaceObjectDefPerPlayer(bonusHuntable2ID, false);

	// Center forest
	int centerForestCount=8*cNumberNonGaiaPlayers;
	int centerFailCount=0;
	for(i=0; <centerForestCount)
	{
		int centerForestID=rmCreateArea("centerForest"+i);
		rmSetAreaSize(centerForestID, rmAreaTilesToFraction(60), rmAreaTilesToFraction(80));
		rmSetAreaWarnFailure(centerForestID, false);
		rmSetAreaForestType(centerForestID, "palm forest");
		rmAddAreaToClass(centerForestID, classForest);
		rmSetAreaMinBlobs(centerForestID, 1);
		rmSetAreaMaxBlobs(centerForestID, 2);
		rmAddAreaConstraint(centerForestID, dummyCenterConstraint);
		rmAddAreaConstraint(centerForestID, longAvoidImpassableLand);
		rmAddAreaConstraint(centerForestID, avoidAll);
		rmAddAreaConstraint(centerForestID, forestSettleConstraint);
		rmAddAreaConstraint(centerForestID, forestConstraint);
		rmAddAreaConstraint(centerForestID, avoidBuildings);
		rmSetAreaMinBlobDistance(centerForestID, 16.0);
		rmSetAreaMaxBlobDistance(centerForestID, 20.0);
		rmSetAreaCoherence(centerForestID, 0.0);
		if(rmBuildArea(centerForestID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			centerFailCount++;
			if(centerFailCount==3)
				break;
		}
		else
			centerFailCount=0;
	}

	// Far predators
	rmPlaceObjectDefPerPlayer(farPredatorID, false);
	if(cNumberNonGaiaPlayers == 2)
		rmPlaceObjectDefPerPlayer(bonusHuntable4ID, false);

	// Pigs
	rmPlaceObjectDefPerPlayer(farGoatsID, false);

	// Relics
	if(cNumberNonGaiaPlayers == 2)
		rmPlaceObjectDefPerPlayer(relic1ID, false, 1);
	rmPlaceObjectDefPerPlayer(relic2ID, false, 1);

	// Random trees
	rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);

	// Hawks
	rmPlaceObjectDefPerPlayer(farhawkID, false, 2);

	// Text
	rmSetStatusText("",0.1);

	// Decoration
	int skeletonID=rmCreateObjectDef("dead animal");
	rmAddObjectDefItem(skeletonID, "skeleton animal", 1, 0.0);
	rmSetObjectDefMinDistance(skeletonID, 0.0);
	rmSetObjectDefMaxDistance(skeletonID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(skeletonID, avoidAll);
	rmAddObjectDefConstraint(skeletonID, longAvoidImpassableLand);
	rmPlaceObjectDefAtLoc(skeletonID, 0, 0.5, 0.5, 7*cNumberNonGaiaPlayers);
	/*
	int baboonID=rmCreateObjectDef("pro baboon");
	rmAddObjectDefItem(baboonID, "baboon", 1, 0.0);
	rmSetObjectDefMinDistance(baboonID, 0.0);
	rmSetObjectDefMaxDistance(baboonID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(baboonID, avoidAll);
	rmAddObjectDefConstraint(baboonID, longAvoidImpassableLand);
	rmPlaceObjectDefAtLoc(baboonID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
	*/
	int bushID=rmCreateObjectDef("bush");
	rmAddObjectDefItem(bushID, "bush", 3, 4.0);
	rmSetObjectDefMinDistance(bushID, 0.0);
	rmSetObjectDefMaxDistance(bushID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(bushID, avoidGrass);
	rmAddObjectDefConstraint(bushID, avoidAll);
	rmAddObjectDefConstraint(bushID, avoidImpassableLand);
	rmPlaceObjectDefAtLoc(bushID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);

	int rockID=rmCreateObjectDef("rock small");
	rmAddObjectDefItem(rockID, "rock sandstone small", 1, 0.0);
	rmSetObjectDefMinDistance(rockID, 0.0);
	rmSetObjectDefMaxDistance(rockID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(rockID, avoidAll);
	rmAddObjectDefConstraint(rockID, avoidImpassableLand);
	rmPlaceObjectDefAtLoc(rockID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);

	int signID=rmCreateObjectDef("sings");
	rmAddObjectDefItem(signID, "sign", 1, 0.0);
	rmSetObjectDefMinDistance(signID, 0.0);
	rmSetObjectDefMaxDistance(signID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(signID, avoidAll);
	rmAddObjectDefConstraint(signID, avoidImpassableLand);
	rmPlaceObjectDefAtLoc(signID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);

	if(rmRandFloat(0,1)<0.5)
	{
		int rugsID=rmCreateObjectDef("rugs");
		rmAddObjectDefItem(rugsID, "rugs", rmRandInt(2,3), 3.0);
		rmSetObjectDefMinDistance(rugsID, 0.0);
		rmSetObjectDefMaxDistance(rugsID, 20.0);
		rmAddObjectDefConstraint(rugsID, avoidAll);
		rmAddObjectDefConstraint(rugsID, avoidImpassableLand);
		rmPlaceObjectDefPerPlayer(rugsID, false);

		if(rmRandFloat(0,1)<0.5)
		{
			int moreRugsID=rmCreateObjectDef("more rugs");
			rmAddObjectDefItem(moreRugsID, "rugs", rmRandInt(1,3), 3.0);
			rmSetObjectDefMinDistance(moreRugsID, 10.0);
			rmSetObjectDefMaxDistance(moreRugsID, 20.0);
			rmAddObjectDefConstraint(moreRugsID, avoidAll);
			rmAddObjectDefConstraint(moreRugsID, avoidRugs);
			rmAddObjectDefConstraint(moreRugsID, avoidImpassableLand);
			rmPlaceObjectDefPerPlayer(moreRugsID, false);
		}
	}

	// Text
	rmSetStatusText("",0.01);

	// Notify players
	if(cNumberTeams > 2)
	{
		rmCreateTrigger("team notification");
		rmSetTriggerPriority(5);
		rmSetTriggerActive(true);
		rmAddTriggerCondition("Timer");
		rmAddTriggerEffect("Send Spoofed Chat");
		rmSetTriggerEffectParam("Message", "RebelsRising: This map has not been optimized for 4v4+ and FFA. No balance guaranteed - play at your own risk!", false);
		rmSetTriggerEffectParam("PlayerID", ""+0);
	}
	else if(cNumberNonGaiaPlayers > 6)
	{
		rmCreateTrigger("player notification");
		rmSetTriggerPriority(5);
		rmSetTriggerActive(true);
		rmAddTriggerCondition("Timer");
		rmAddTriggerEffect("Send Spoofed Chat");
		rmSetTriggerEffectParam("Message", "RebelsRising: This map has not been optimized for 4v4+ and FFA. No balance guaranteed - play at your own risk!", false);
		rmSetTriggerEffectParam("PlayerID", ""+0);
	}
}