// 2015 Random Set
// By RR & Bubble
// Version 1.0 @ 14th Feb 2015

// Arabia
void arabia(void)
{
	// Text
	rmSetStatusText("",1.0);

	// Set size
	int playerTiles = 7500;
	int sizel=0;
	int sizew=0;
	if(cNumberNonGaiaPlayers == 2)
	{
		sizel=2.4*sqrt(cNumberNonGaiaPlayers*playerTiles);
		sizew=1.7*sqrt(cNumberNonGaiaPlayers*playerTiles);
	}
	else if(cNumberNonGaiaPlayers < 5)
	{
		sizel=2.4*sqrt(cNumberNonGaiaPlayers*playerTiles)*0.85;
		sizew=1.7*sqrt(cNumberNonGaiaPlayers*playerTiles)*0.85;
	}
	else if(cNumberNonGaiaPlayers < 7)
	{
		sizel=2.4*sqrt(cNumberNonGaiaPlayers*playerTiles)*0.85;
		sizew=1.7*sqrt(cNumberNonGaiaPlayers*playerTiles)*0.975;
	}
	else
	{
		sizel=2.4*sqrt(cNumberNonGaiaPlayers*playerTiles)*0.75;
		sizew=1.7*sqrt(cNumberNonGaiaPlayers*playerTiles)*0.95;
	}
	rmSetMapSize(sizel, sizew);

	// Init map
	rmTerrainInitialize("CliffEgyptianA", 9);
	rmSetLightingSet("Alfheim");

	// Define classes
	int classPlayer=rmDefineClass("player");
	int classPlayerCore=rmDefineClass("player core");
	int classForest=rmDefineClass("forest");
	rmDefineClass("starting settlement");
	rmDefineClass("center");
	rmDefineClass("connections");

	// Define sector vars
	float zCenterStart=0.0;
	float zCenterEnd=0.0;

	if(cNumberNonGaiaPlayers == 2)
	{
		zCenterStart=0.25;
		zCenterEnd=0.75;
	}
	else if(cNumberNonGaiaPlayers < 5)
	{
		zCenterStart=0.27;
		zCenterEnd=0.73;
	}
	else if(cNumberNonGaiaPlayers < 7)
	{
		zCenterStart=0.28;
		zCenterEnd=0.72;
	}
	else
	{
		zCenterStart=0.28;
		zCenterEnd=0.72;
	}

	// Constraints
	// General
	int centerConstraint=rmCreateClassDistanceConstraint("player areas avoid center", rmClassID("center"), 10.0);
	int furtherCenterConstraint=rmCreateClassDistanceConstraint("stuff avoids center", rmClassID("center"), 16.0);
	int dummyCenterConstraint=rmCreateBoxConstraint("dummy goes into center", zCenterStart, 0, zCenterEnd, 1);
	int edgeConstraint=rmCreateBoxConstraint("edge of map", rmXTilesToFraction(4), rmZTilesToFraction(4), 1.0-rmXTilesToFraction(4), 1.0-rmZTilesToFraction(4), 0.01);
	int furtherEdgeConstraint=rmCreateBoxConstraint("further avoid edge of map", rmXTilesToFraction(12), rmZTilesToFraction(12), 1.0-rmXTilesToFraction(12), 1.0-rmZTilesToFraction(12), 0.01);
	int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

	// Player
	int playerConstraint=rmCreateClassDistanceConstraint("bonus Settlement stay away from players", classPlayer, 40.0);

	// Connections
	int avoidConnections=rmCreateClassDistanceConstraint("objects avoid connections", rmClassID("connections"), 5.0);
	int longAvoidConnections=rmCreateClassDistanceConstraint("objects avoid connections by long", rmClassID("connections"), 10.0);
	int connectionEdgeConstraint=rmCreateBoxConstraint("connections avoid edge of map", rmXTilesToFraction(16), rmZTilesToFraction(16), 1.0-rmXTilesToFraction(16), 1.0-rmZTilesToFraction(16));

	// Avoid impassable land
	int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, rmXTilesToFraction(8));
	int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 12.0);

	// Settlement
	int shortAvoidSettlement=rmCreateTypeDistanceConstraint("objects avoid TC by short distance", "AbstractSettlement", 10.0);
	int avoidSettlement=rmCreateTypeDistanceConstraint("objects avoid TC by medium distance", "AbstractSettlement", 20.0);
	int farStartingSettleConstraint=rmCreateClassDistanceConstraint("objects avoid player TCs", rmClassID("starting settlement"), 50.0);
	int shortStartingSettleConstraint=rmCreateClassDistanceConstraint("objects avoid player TCs by short distance", rmClassID("starting settlement"), 20.0);

	// Gold
	int farAvoidGold=rmCreateTypeDistanceConstraint("far avoid gold", "gold", 50.0);
	int avoidGold=rmCreateTypeDistanceConstraint("avoid gold", "gold", 40.0);
	int shortAvoidGold=rmCreateTypeDistanceConstraint("short avoid gold", "gold", 10.0);

	// Food
	int avoidFood=rmCreateTypeDistanceConstraint("avoid other food sources", "food", 20.0);
	int avoidHuntable=rmCreateTypeDistanceConstraint("avoid huntable", "huntable", 32.5);
	int avoidPredator=rmCreateTypeDistanceConstraint("avoid predator", "animalPredator", 40.0);
	int shortAvoidPredator=rmCreateTypeDistanceConstraint("short avoid predator", "animalPredator", 30.0);
	int avoidHerdable=rmCreateTypeDistanceConstraint("avoid herdable", "herdable", 50.0);

	// Forest
	int forestConstraint=rmCreateClassDistanceConstraint("forest v forest", rmClassID("forest"), 20.0);
	int forestSettleConstraint=rmCreateClassDistanceConstraint("forest settle", rmClassID("starting settlement"), 17.0);
	int avoidForest=rmCreateClassDistanceConstraint("avoid forest", rmClassID("forest"), 10.0);

	// Buildings
	int avoidTower=rmCreateTypeDistanceConstraint("towers avoid towers", "tower", 22.5);
	int avoidBuildings=rmCreateTypeDistanceConstraint("avoid buildings", "Building", 17.5);

	// Embellishment
	int avoidGrass=rmCreateTypeDistanceConstraint("avoid bush", "bush", 20.0);
	int avoidRugs=rmCreateTypeDistanceConstraint("avoid rugs", "rugs", 10.0);

	// Text
	rmSetStatusText("",0.9);

	// Define objects
	// Starting TC
	int startingSettlementID=rmCreateObjectDef("starting settlement");
	rmAddObjectDefItem(startingSettlementID, "Settlement Level 1", 1, 0.0);
	rmAddObjectDefToClass(startingSettlementID, rmClassID("starting settlement"));
	rmSetObjectDefMinDistance(startingSettlementID, 0.0);
	rmSetObjectDefMaxDistance(startingSettlementID, 0.0);

	// Towers
	int startingTowerID=rmCreateObjectDef("Starting tower");
	rmAddObjectDefItem(startingTowerID, "tower", 1, 0.0);
	rmSetObjectDefMinDistance(startingTowerID, 20.0);
	rmSetObjectDefMaxDistance(startingTowerID, 28.0);
	rmAddObjectDefConstraint(startingTowerID, avoidTower);
	rmAddObjectDefConstraint(startingTowerID, edgeConstraint);

	// Gold
	int startingGoldID=rmCreateObjectDef("Starting gold");
	rmAddObjectDefItem(startingGoldID, "Gold mine small", 1, 0.0);
	rmSetObjectDefMinDistance(startingGoldID, 20.0);
	rmSetObjectDefMaxDistance(startingGoldID, 20.0);
	rmAddObjectDefConstraint(startingGoldID, avoidAll);
	rmAddObjectDefConstraint(startingGoldID, edgeConstraint);

	// Pigs
	int closeGoatsID=rmCreateObjectDef("close goats");
	rmAddObjectDefItem(closeGoatsID, "pig", 2, 2.0);
	rmSetObjectDefMinDistance(closeGoatsID, 25.0);
	rmSetObjectDefMaxDistance(closeGoatsID, 30.0);
	rmAddObjectDefConstraint(closeGoatsID, avoidAll);
	rmAddObjectDefConstraint(closeGoatsID, edgeConstraint);

	// Berries
	int closeChickensID=rmCreateObjectDef("close Chickens");
	rmAddObjectDefItem(closeChickensID, "berry bush", rmRandInt(7,8), 4.0);
	rmSetObjectDefMinDistance(closeChickensID, 20.0);
	rmSetObjectDefMaxDistance(closeChickensID, 25.0);
	rmAddObjectDefConstraint(closeChickensID, avoidAll);
	rmAddObjectDefConstraint(closeChickensID, shortAvoidGold);
	rmAddObjectDefConstraint(closeChickensID, edgeConstraint);

	// Close hunt
	int closeGazelleID=rmCreateObjectDef("close zebra");
	rmAddObjectDefItem(closeGazelleID, "gazelle", rmRandInt(6,7), 2.0);
	rmSetObjectDefMinDistance(closeGazelleID, 30.0);
	rmSetObjectDefMaxDistance(closeGazelleID, 40.0);
	rmAddObjectDefConstraint(closeGazelleID, avoidAll);
	rmAddObjectDefConstraint(closeGazelleID, furtherCenterConstraint);
	rmAddObjectDefConstraint(closeGazelleID, shortAvoidGold);
	rmAddObjectDefConstraint(closeGazelleID, furtherEdgeConstraint);
	rmAddObjectDefConstraint(closeGazelleID, avoidImpassableLand);

	// Straggler trees
	int stragglerTreeID=rmCreateObjectDef("straggler tree");
	rmAddObjectDefItem(stragglerTreeID, "palm", 1, 0.0);
	rmSetObjectDefMinDistance(stragglerTreeID, 12.0);
	rmSetObjectDefMaxDistance(stragglerTreeID, 15.0);
	rmAddObjectDefConstraint(stragglerTreeID, shortAvoidGold);
	rmAddObjectDefConstraint(stragglerTreeID, edgeConstraint);

	// Objects on player plateau
	// Close gold
	int closeGoldID=rmCreateObjectDef("close gold");
	rmAddObjectDefItem(closeGoldID, "Gold mine", 1, 0.0);
	rmSetObjectDefMinDistance(closeGoldID, 60.0);
	rmSetObjectDefMaxDistance(closeGoldID, 65.0);
	if(cNumberNonGaiaPlayers > 5)
		rmAddObjectDefConstraint(closeGoldID, shortAvoidGold);
	rmAddObjectDefConstraint(closeGoldID, edgeConstraint);
	rmAddObjectDefConstraint(closeGoldID, shortAvoidSettlement);
	rmAddObjectDefConstraint(closeGoldID, furtherCenterConstraint);
	rmAddObjectDefConstraint(closeGoldID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(closeGoldID, avoidAll);
	rmAddObjectDefConstraint(closeGoldID, longAvoidImpassableLand);

	// Medium pigs
	int mediumGoatsID=rmCreateObjectDef("medium goats");
	rmAddObjectDefItem(mediumGoatsID, "pig", 2, 2.0);
	rmSetObjectDefMinDistance(mediumGoatsID, 60.0);
	rmSetObjectDefMaxDistance(mediumGoatsID, 70.0);
	rmAddObjectDefConstraint(mediumGoatsID, furtherCenterConstraint);
	rmAddObjectDefConstraint(mediumGoatsID, avoidAll);
	rmAddObjectDefConstraint(mediumGoatsID, edgeConstraint);

	// Medium predator
	int mediumPredatorID=rmCreateObjectDef("medium predator");
	if(rmRandFloat(0,1)<0.5)
		rmAddObjectDefItem(mediumPredatorID, "lion", 2, 4.0);
	else
		rmAddObjectDefItem(mediumPredatorID, "hyena", 2, 4.0);
	rmSetObjectDefMinDistance(mediumPredatorID, 60.0);
	rmSetObjectDefMaxDistance(mediumPredatorID, 100.0);
	rmAddObjectDefConstraint(mediumPredatorID, furtherCenterConstraint);
	rmAddObjectDefConstraint(mediumPredatorID, avoidAll);
	rmAddObjectDefConstraint(mediumPredatorID, shortAvoidPredator);
	rmAddObjectDefConstraint(mediumPredatorID, edgeConstraint);

	// Medium berries
	int mediumBerriesID=rmCreateObjectDef("medium berries");
	rmAddObjectDefItem(mediumBerriesID, "berry bush", rmRandInt(8,9), 4.0);
	rmSetObjectDefMinDistance(mediumBerriesID, 65.0);
	rmSetObjectDefMaxDistance(mediumBerriesID, 80.0);
	rmAddObjectDefConstraint(mediumBerriesID, furtherCenterConstraint);
	rmAddObjectDefConstraint(mediumBerriesID, avoidConnections);
	rmAddObjectDefConstraint(mediumBerriesID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(mediumBerriesID, shortAvoidGold);
	rmAddObjectDefConstraint(mediumBerriesID, shortAvoidSettlement);
	rmAddObjectDefConstraint(mediumBerriesID, avoidFood);
	rmAddObjectDefConstraint(mediumBerriesID, edgeConstraint);
	rmAddObjectDefConstraint(mediumBerriesID, longAvoidImpassableLand);

	// Far berries
	int farBerriesID=rmCreateObjectDef("far berries");
	rmAddObjectDefItem(farBerriesID, "berry bush", rmRandInt(8,9), 4.0);
	rmSetObjectDefMinDistance(farBerriesID, 90.0);
	rmSetObjectDefMaxDistance(farBerriesID, 105.0);
	rmAddObjectDefConstraint(farBerriesID, avoidConnections);
	rmAddObjectDefConstraint(farBerriesID, furtherCenterConstraint);
	rmAddObjectDefConstraint(farBerriesID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(farBerriesID, shortAvoidGold);
	rmAddObjectDefConstraint(farBerriesID, shortAvoidSettlement);
	rmAddObjectDefConstraint(farBerriesID, avoidFood);
	rmAddObjectDefConstraint(farBerriesID, edgeConstraint);
	rmAddObjectDefConstraint(farBerriesID, avoidImpassableLand);

	// Center stuff
	// Medium gold
	int mediumGoldID=rmCreateObjectDef("medium gold");
	rmAddObjectDefItem(mediumGoldID, "Gold mine", 1, 0.0);
	rmSetObjectDefMinDistance(mediumGoldID, 90.0);
	rmSetObjectDefMaxDistance(mediumGoldID, rmXFractionToMeters(0.25));
	rmAddObjectDefConstraint(mediumGoldID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(mediumGoldID, dummyCenterConstraint);
	rmAddObjectDefConstraint(mediumGoldID, avoidSettlement);
	rmAddObjectDefConstraint(mediumGoldID, avoidAll);
	rmAddObjectDefConstraint(mediumGoldID, avoidGold);
	rmAddObjectDefConstraint(mediumGoldID, edgeConstraint);
	rmAddObjectDefConstraint(mediumGoldID, longAvoidImpassableLand);

	// Far gold
	int farGoldID=rmCreateObjectDef("far gold");
	rmAddObjectDefItem(farGoldID, "Gold mine", 1, 0.0);
	rmSetObjectDefMinDistance(farGoldID, 80.0);
	rmSetObjectDefMaxDistance(farGoldID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(farGoldID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(farGoldID, dummyCenterConstraint);
	rmAddObjectDefConstraint(farGoldID, avoidSettlement);
	rmAddObjectDefConstraint(farGoldID, avoidAll);
	rmAddObjectDefConstraint(farGoldID, farAvoidGold);
	rmAddObjectDefConstraint(farGoldID, edgeConstraint);
	rmAddObjectDefConstraint(farGoldID, longAvoidImpassableLand);

	// Far predator
	int farPredatorID=rmCreateObjectDef("far predator");
	if(rmRandFloat(0,1)<0.5)
		rmAddObjectDefItem(farPredatorID, "lion", 2, 4.0);
	else
		rmAddObjectDefItem(farPredatorID, "hyena", 2, 4.0);
	rmSetObjectDefMinDistance(farPredatorID, 120.0);
	rmSetObjectDefMaxDistance(farPredatorID, rmXFractionToMeters(0.25));
	rmAddObjectDefConstraint(farPredatorID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(farPredatorID, avoidAll);
	rmAddObjectDefConstraint(farPredatorID, avoidPredator);
	rmAddObjectDefConstraint(farPredatorID, edgeConstraint);
	rmAddObjectDefConstraint(farPredatorID, dummyCenterConstraint);

	// Hunt
	int bonusHuntable0ID=rmCreateObjectDef("bonus huntable 0");
	rmAddObjectDefItem(bonusHuntable0ID, "gazelle", rmRandInt(4,5), 4.0);
	rmAddObjectDefItem(bonusHuntable0ID, "zebra", rmRandInt(3,4), 4.0);
	if(cNumberNonGaiaPlayers == 2)
	{
		rmSetObjectDefMinDistance(bonusHuntable0ID, 80.0);
		rmSetObjectDefMaxDistance(bonusHuntable0ID, rmXFractionToMeters(0.225));
	}
	else if(cNumberNonGaiaPlayers < 5)
	{
		rmSetObjectDefMinDistance(bonusHuntable0ID, 80.0);
		rmSetObjectDefMaxDistance(bonusHuntable0ID, rmXFractionToMeters(0.175));
	}
	else
	{
		rmSetObjectDefMinDistance(bonusHuntable0ID, 75.0);
		rmSetObjectDefMaxDistance(bonusHuntable0ID, rmXFractionToMeters(0.15));
	}
	rmAddObjectDefConstraint(bonusHuntable0ID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(bonusHuntable0ID, dummyCenterConstraint);
	rmAddObjectDefConstraint(bonusHuntable0ID, avoidAll);
	rmAddObjectDefConstraint(bonusHuntable0ID, avoidFood);
	rmAddObjectDefConstraint(bonusHuntable0ID, edgeConstraint);
	rmAddObjectDefConstraint(bonusHuntable0ID, longAvoidImpassableLand);

	// More hunt
	int bonusHuntable1ID=rmCreateObjectDef("bonus huntable 1");
	if(rmRandFloat(0,1)<0.5)
		rmAddObjectDefItem(bonusHuntable1ID, "giraffe", rmRandInt(4,5), 4.0);
	else
	{
		rmAddObjectDefItem(bonusHuntable1ID, "giraffe", rmRandInt(2,3), 4.0);
		rmAddObjectDefItem(bonusHuntable1ID, "gazelle", rmRandInt(3,4), 4.0);
	}
	if(cNumberNonGaiaPlayers == 2)
	{
		rmSetObjectDefMinDistance(bonusHuntable1ID, 75.0);
		rmSetObjectDefMaxDistance(bonusHuntable1ID, rmXFractionToMeters(0.225));
	}
	else  if(cNumberNonGaiaPlayers < 5)
	{
		rmSetObjectDefMinDistance(bonusHuntable1ID, 75.0);
		rmSetObjectDefMaxDistance(bonusHuntable1ID, rmXFractionToMeters(0.175));
	}
	else
	{
		rmSetObjectDefMinDistance(bonusHuntable1ID, 75.0);
		rmSetObjectDefMaxDistance(bonusHuntable1ID, rmXFractionToMeters(0.15));
	}
	rmAddObjectDefConstraint(bonusHuntable1ID, avoidHuntable);
	rmAddObjectDefConstraint(bonusHuntable1ID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(bonusHuntable1ID, dummyCenterConstraint);
	rmAddObjectDefConstraint(bonusHuntable1ID, avoidAll);
	rmAddObjectDefConstraint(bonusHuntable1ID, avoidFood);
	rmAddObjectDefConstraint(bonusHuntable1ID, edgeConstraint);
	rmAddObjectDefConstraint(bonusHuntable1ID, longAvoidImpassableLand);

	// Some more hunt
	int bonusHuntable2ID=rmCreateObjectDef("bonus huntable 2");
	rmAddObjectDefItem(bonusHuntable2ID, "elephant", 2, 7.0);
	rmSetObjectDefMinDistance(bonusHuntable2ID, rmXFractionToMeters(0.35));
	rmSetObjectDefMaxDistance(bonusHuntable2ID, rmXFractionToMeters(0.4));
	rmAddObjectDefConstraint(bonusHuntable2ID, avoidHuntable);
	rmAddObjectDefConstraint(bonusHuntable2ID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(bonusHuntable2ID, dummyCenterConstraint);
	rmAddObjectDefConstraint(bonusHuntable2ID, avoidAll);
	rmAddObjectDefConstraint(bonusHuntable2ID, avoidFood);
	rmAddObjectDefConstraint(bonusHuntable2ID, edgeConstraint);
	rmAddObjectDefConstraint(bonusHuntable2ID, longAvoidImpassableLand);

	// Even some more hunt
	int bonusHuntable3ID=rmCreateObjectDef("bonus huntable 3");
	rmAddObjectDefItem(bonusHuntable3ID, "hippo", 3, 6.0);
	rmSetObjectDefMinDistance(bonusHuntable3ID, rmXFractionToMeters(0.3));
	rmSetObjectDefMaxDistance(bonusHuntable3ID, rmXFractionToMeters(0.35));
	rmAddObjectDefConstraint(bonusHuntable3ID, avoidHuntable);
	rmAddObjectDefConstraint(bonusHuntable3ID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(bonusHuntable3ID, dummyCenterConstraint);
	rmAddObjectDefConstraint(bonusHuntable3ID, avoidAll);
	rmAddObjectDefConstraint(bonusHuntable3ID, avoidFood);
	rmAddObjectDefConstraint(bonusHuntable3ID, edgeConstraint);
	rmAddObjectDefConstraint(bonusHuntable3ID, longAvoidImpassableLand);

	// 999
	int bonusHuntable4ID=rmCreateObjectDef("bonus huntable 4");
	rmAddObjectDefItem(bonusHuntable4ID, "baboon", 8, 5.0);
	rmSetObjectDefMinDistance(bonusHuntable4ID, rmXFractionToMeters(0.45));
	rmSetObjectDefMaxDistance(bonusHuntable4ID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(bonusHuntable4ID, avoidHuntable);
	rmAddObjectDefConstraint(bonusHuntable4ID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(bonusHuntable4ID, dummyCenterConstraint);
	rmAddObjectDefConstraint(bonusHuntable4ID, avoidAll);
	rmAddObjectDefConstraint(bonusHuntable4ID, avoidFood);
	rmAddObjectDefConstraint(bonusHuntable4ID, edgeConstraint);
	rmAddObjectDefConstraint(bonusHuntable4ID, longAvoidImpassableLand);

	// Yeah whatever
	int bonusHuntable5ID=rmCreateObjectDef("bonus huntable 5");
	rmAddObjectDefItem(bonusHuntable5ID, "giraffe", rmRandInt(2,3), 4.0);
	rmAddObjectDefItem(bonusHuntable5ID, "gazelle", rmRandInt(3,4), 4.0);
	rmSetObjectDefMinDistance(bonusHuntable5ID, rmXFractionToMeters(0.25));
	rmSetObjectDefMaxDistance(bonusHuntable5ID, rmXFractionToMeters(0.35));
	rmAddObjectDefConstraint(bonusHuntable5ID, avoidHuntable);
	rmAddObjectDefConstraint(bonusHuntable5ID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(bonusHuntable5ID, dummyCenterConstraint);
	rmAddObjectDefConstraint(bonusHuntable5ID, avoidAll);
	rmAddObjectDefConstraint(bonusHuntable5ID, avoidFood);
	rmAddObjectDefConstraint(bonusHuntable5ID, edgeConstraint);
	rmAddObjectDefConstraint(bonusHuntable5ID, longAvoidImpassableLand);

	// Far pigs
	int farGoatsID=rmCreateObjectDef("far goats");
	rmAddObjectDefItem(farGoatsID, "pig", 2, 2.0);
	rmSetObjectDefMinDistance(farGoatsID, rmXFractionToMeters(0.2));
	rmSetObjectDefMaxDistance(farGoatsID, rmXFractionToMeters(0.35));
	rmAddObjectDefConstraint(farGoatsID, dummyCenterConstraint);
	rmAddObjectDefConstraint(farGoatsID, avoidAll);
	rmAddObjectDefConstraint(farGoatsID, edgeConstraint);
	rmAddObjectDefConstraint(farGoatsID, avoidHerdable);
	rmAddObjectDefConstraint(farGoatsID, longAvoidImpassableLand);
	rmAddObjectDefConstraint(farGoatsID, farStartingSettleConstraint);

	// Random Trees
	int randomTreeID=rmCreateObjectDef("random tree");
	rmAddObjectDefItem(randomTreeID, "palm", 1, 0.0);
	rmSetObjectDefMinDistance(randomTreeID, 0.0);
	rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(randomTreeID, rmCreateTypeDistanceConstraint("random tree", "all", 4.0));
	rmAddObjectDefConstraint(randomTreeID, shortAvoidSettlement);
	rmAddObjectDefConstraint(randomTreeID, avoidAll);
	rmAddObjectDefConstraint(randomTreeID, avoidConnections);

	// Relics
	int relic1ID=rmCreateObjectDef("relics");
	rmAddObjectDefItem(relic1ID, "relic", 1, 0.0);
	rmSetObjectDefMinDistance(relic1ID, 60.0);
	rmSetObjectDefMaxDistance(relic1ID, 200.0);
	rmAddObjectDefConstraint(relic1ID, edgeConstraint);
	rmAddObjectDefConstraint(relic1ID, rmCreateTypeDistanceConstraint("relic vs relic 1", "relic", 50.0));
	rmAddObjectDefConstraint(relic1ID, furtherCenterConstraint);
	rmAddObjectDefConstraint(relic1ID, avoidAll);

	// More relics
	int relic2ID=rmCreateObjectDef("more relics");
	rmAddObjectDefItem(relic2ID, "relic", 1, 0.0);
	rmSetObjectDefMinDistance(relic2ID, 100.0);
	rmSetObjectDefMaxDistance(relic2ID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(relic2ID, edgeConstraint);
	rmAddObjectDefConstraint(relic2ID, rmCreateTypeDistanceConstraint("relic vs relic 2", "relic", 50.0));
	rmAddObjectDefConstraint(relic2ID, dummyCenterConstraint);
	rmAddObjectDefConstraint(relic2ID, avoidAll);

	// Birds
	int farhawkID=rmCreateObjectDef("far hawks");
	rmAddObjectDefItem(farhawkID, "vulture", 1, 0.0);
	rmSetObjectDefMinDistance(farhawkID, 0.0);
	rmSetObjectDefMaxDistance(farhawkID, rmXFractionToMeters(0.5));

	// Text
	rmSetStatusText("",0.8);

	// Generic stuff
	// Place Players
	int startPos = 0;
	if(cNumberNonGaiaPlayers == 2)
	{
		startPos = rmRandInt(1,8);
		if(startPos == 1)
		{
			rmPlacePlayer(1, rmRandFloat(0.07,0.09), rmRandFloat(0.15,0.18));
			rmPlacePlayer(2, rmRandFloat(0.91,0.93), rmRandFloat(0.82,0.85));
		}
		else if(startPos == 2)
		{
			rmPlacePlayer(1, rmRandFloat(0.91,0.93), rmRandFloat(0.82,0.85));
			rmPlacePlayer(2, rmRandFloat(0.07,0.09), rmRandFloat(0.15,0.18));
		}
		else if(startPos == 3)
		{
			rmPlacePlayer(1, rmRandFloat(0.07,0.09), rmRandFloat(0.82,0.85));
			rmPlacePlayer(2, rmRandFloat(0.91,0.93), rmRandFloat(0.15,0.18));
		}
		else if(startPos == 4)
		{
			rmPlacePlayer(1, rmRandFloat(0.91,0.93), rmRandFloat(0.15,0.18));
			rmPlacePlayer(2, rmRandFloat(0.07,0.09), rmRandFloat(0.82,0.85));
		}
		else if(startPos == 5)
		{
			rmPlacePlayer(1, rmRandFloat(0.07,0.09), rmRandFloat(0.15,0.18));
			rmPlacePlayer(2, rmRandFloat(0.91,0.93), rmRandFloat(0.15,0.18));
		}
		else if(startPos == 6)
		{
			rmPlacePlayer(1, rmRandFloat(0.91,0.93), rmRandFloat(0.15,0.18));
			rmPlacePlayer(2, rmRandFloat(0.07,0.09), rmRandFloat(0.15,0.18));
		}
		else if(startPos == 7)
		{
			rmPlacePlayer(1, rmRandFloat(0.07,0.09), rmRandFloat(0.82,0.85));
			rmPlacePlayer(2, rmRandFloat(0.91,0.93), rmRandFloat(0.82,0.85));
		}
		else if(startPos == 8)
		{
			rmPlacePlayer(1, rmRandFloat(0.91,0.93), rmRandFloat(0.82,0.85));
			rmPlacePlayer(2, rmRandFloat(0.07,0.09), rmRandFloat(0.82,0.85));
		}
	}
	else if(cNumberTeams < 3)
	{
		if(cNumberNonGaiaPlayers < 5)
	  {
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.14, 0.12, 0.14, 0.58);
			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.86, 0.12, 0.86, 0.58);
		}
	  else if(cNumberNonGaiaPlayers < 7)
	  {
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(rmRandFloat(0.16,0.17), 0.12, rmRandFloat(0.16,0.17), 0.68);
			rmSetPlacementTeam(1);
			rmPlacePlayersLine(rmRandFloat(0.83,0.84), 0.12, rmRandFloat(0.83,0.84), 0.68);
		}
	  else
		{
			rmSetPlacementTeam(0);
			rmPlacePlayersLine(0.18, 0.12, 0.18, 0.78);
			rmSetPlacementTeam(1);
			rmPlacePlayersLine(0.82, 0.12, 0.82, 0.78);
		}
	}
	else
		rmPlacePlayersSquare(0.4, 0.4, rmDegreesToRadians(5.0));
		// Impossible to get a fair placement with 3+ teams

	// Create connections
	int connectionID=rmCreateConnection("connections");
	rmSetConnectionType(connectionID, cConnectAreas, true, 1);
	if(cNumberNonGaiaPlayers == 2)
		rmSetConnectionWidth(connectionID, rmRandInt(28,32), 0);
	else if(cNumberNonGaiaPlayers < 5)
		rmSetConnectionWidth(connectionID, 21, 0);
	else
	  rmSetConnectionWidth(connectionID, 14, 0);
	rmSetConnectionWarnFailure(connectionID, false);
	rmSetConnectionBaseHeight(connectionID, 7.0);
	rmSetConnectionHeightBlend(connectionID, 2.0);
	rmSetConnectionCoherence(connectionID, 1);
	if(startPos < 5)
		rmSetConnectionPositionVariance(connectionID, 25);
	rmSetConnectionSmoothDistance(connectionID, 8);
	rmAddConnectionStartConstraint(connectionID, connectionEdgeConstraint);
	rmAddConnectionEndConstraint(connectionID, connectionEdgeConstraint);
	rmAddConnectionStartConstraint(connectionID, longAvoidConnections);
	rmAddConnectionEndConstraint(connectionID, longAvoidConnections);
	rmAddConnectionToClass(connectionID, rmClassID("connections"));
	rmAddConnectionTerrainReplacement(connectionID, "CliffEgyptianA", "SandA");

	// Create extra connections
	int extraConnectionsID=rmCreateConnection("extra Connections");
	rmSetConnectionType(extraConnectionsID, cConnectAreas, false, 1);
	if(cNumberNonGaiaPlayers == 2)
		rmSetConnectionWidth(extraConnectionsID, rmRandInt(25,28), 0);
	else if(cNumberNonGaiaPlayers < 5)
		rmSetConnectionWidth(extraConnectionsID, 21, 0);
	else
	  rmSetConnectionWidth(extraConnectionsID, 12, 0);
	rmSetConnectionWarnFailure(extraConnectionsID, false);
	rmSetConnectionBaseHeight(extraConnectionsID, 7.0);
	rmSetConnectionHeightBlend(extraConnectionsID, 2.0);
	rmSetConnectionCoherence(extraConnectionsID, 1);
	rmSetConnectionSmoothDistance(extraConnectionsID, 8);
	rmAddConnectionStartConstraint(extraConnectionsID, connectionEdgeConstraint);
	rmAddConnectionEndConstraint(extraConnectionsID, connectionEdgeConstraint);
	rmAddConnectionStartConstraint(extraConnectionsID, longAvoidConnections);
	rmAddConnectionEndConstraint(extraConnectionsID, longAvoidConnections);
	rmAddConnectionToClass(extraConnectionsID, rmClassID("connections"));
	rmAddConnectionTerrainReplacement(extraConnectionsID, "CliffEgyptianA", "SandA");

	// Text
	rmSetStatusText("",0.7);

	// Generate terrain
	// Fake center area
	int fakeCenterID=rmCreateArea("dummy center 1");
	rmSetAreaSize(fakeCenterID, 0.6, 0.6);
	rmSetAreaBaseHeight(fakeCenterID, 0.0);
	rmAddAreaConstraint(fakeCenterID, dummyCenterConstraint);
	rmSetAreaTerrainType(fakeCenterID, "SandA");
	rmAddAreaToClass(fakeCenterID, rmClassID("center"));
	rmSetAreaWarnFailure(fakeCenterID, false);
	rmBuildArea(fakeCenterID);

	// Fake player area 1
	for(i=1; <cNumberPlayers)
	{
		int id=rmCreateArea("Fake area"+i);
		rmSetAreaSize(id, 0.25, 0.25);
		rmSetAreaBaseHeight(id, 9.0);
		rmAddAreaToClass(id, classPlayerCore);
		rmSetAreaLocPlayer(id, i);
	}
	rmBuildAllAreas();

	// Fake player area 2
	for(i=1; <cNumberPlayers)
	{
		id=rmCreateArea("Player core"+i);
		rmSetPlayerArea(i, id);
		rmSetAreaSize(id, 0.25, 0.25);
		rmSetAreaBaseHeight(id, 9.0);
		rmAddAreaToClass(id, classPlayer);
		rmAddAreaConstraint(id, centerConstraint);
		rmSetAreaTerrainType(id, "SandA");
		rmSetAreaLocPlayer(id, i);
		rmSetAreaSmoothDistance(id, 8);
		rmAddConnectionArea(connectionID, id);
		rmSetAreaWarnFailure(id, false);
	}
	rmBuildAllAreas();

	// Text
	rmSetStatusText("",0.6);

	// Starting TC
	rmPlaceObjectDefPerPlayer(startingSettlementID, true);

	// Settlement 1
	if(cNumberNonGaiaPlayers < 5)
		id=rmAddFairLoc("Settlement", false, true, 90, 100, 50, 16);
	else
		{
			id=rmAddFairLoc("Settlement", false, true, 50, 80, 30, 4);
		  rmAddFairLocConstraint(id, shortStartingSettleConstraint);
	  }
	rmAddFairLocConstraint(id, furtherCenterConstraint);

	if(rmPlaceFairLocs())
	{
		id=rmCreateObjectDef("far settlement");
		rmAddObjectDefItem(id, "Settlement", 1, 0.0);
		for(i=1; <cNumberPlayers)
		{
			for(j=0; <rmGetNumberFairLocs(i))
			{
				int settleArea=rmCreateArea("settlement area"+i +j, rmAreaID("Player core"+i));
				rmSetAreaLocation(settleArea, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j));
				rmBuildArea(settleArea);
				rmPlaceObjectDefAtAreaLoc(id, i, settleArea);
				rmAddConnectionArea(extraConnectionsID, settleArea);
			}
		}
	}

	if(cNumberNonGaiaPlayers < 5)
		rmBuildConnection(extraConnectionsID);
	rmResetFairLocs();
	rmBuildConnection(connectionID);

	// Text
	rmSetStatusText("",0.5);

	// Fake center area 2
	fakeCenterID=rmCreateArea("dummy center 2");
	rmSetAreaSize(fakeCenterID, 0.6, 0.6);
	rmSetAreaBaseHeight(fakeCenterID, 0.0);
	rmAddAreaConstraint(fakeCenterID, dummyCenterConstraint);
	rmSetAreaTerrainType(fakeCenterID, "SandA");
	rmAddAreaToClass(fakeCenterID, rmClassID("center"));
	rmSetAreaWarnFailure(fakeCenterID, false);
	rmBuildArea(fakeCenterID);

	// Settlement 2
	id=rmAddFairLoc("Settlement", true, false,  85, 110, 60, 30);
	rmAddFairLocConstraint(id, avoidImpassableLand);
	rmAddFairLocConstraint(id, playerConstraint);

	if(rmPlaceFairLocs())
	{
		id=rmCreateObjectDef("bonus settlement");
		rmAddObjectDefItem(id, "Settlement", 1, 0.0);
		for(i=1; <cNumberPlayers)
		{
			for(j=0; <rmGetNumberFairLocs(i))
			{
				int bonusSettleArea = rmCreateArea("bonus settlement area"+i +j);
				rmSetAreaLocation(bonusSettleArea, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j));
				rmBuildArea(bonusSettleArea);
				rmPlaceObjectDefAtAreaLoc(id, i, bonusSettleArea);
			}
		}
	}

	// Rebuild Center
	int centerID=rmCreateArea("center");
	rmSetAreaSize(centerID, 0.6, 0.6);
	rmAddAreaConstraint(centerID, dummyCenterConstraint);
	rmSetAreaBaseHeight(centerID, 0.0);
	rmSetAreaSmoothDistance(centerID, 0);
	rmSetAreaHeightBlend(centerID, 2);
	rmSetAreaTerrainType(centerID, "SandA");
	rmAddAreaToClass(centerID, rmClassID("center"));
	rmSetAreaWarnFailure(centerID, false);
	rmBuildAllAreas();

	// Build Player Area
	for(i=1; <cNumberPlayers)
	{
		id=rmCreateArea("Player"+i);
		rmSetPlayerArea(i, id);
		rmSetAreaSize(id, 0.25, 0.25);
		rmAddAreaToClass(id, classPlayer);
		rmAddAreaConstraint(id, centerConstraint);
		rmSetAreaTerrainType(id, "SandA");
		rmSetAreaBaseHeight(id, 9);
		rmSetAreaLocPlayer(id, i);
		rmSetAreaSmoothDistance(id, 5);
		rmSetAreaHeightBlend(id, 2);
	  rmSetAreaWarnFailure(id, false);
	}

	 rmBuildAllAreas();

	// Text
	rmSetStatusText("",0.4);

	// Texture embellishment
	for(i=1; <cNumberPlayers*10)
	{
		int id1=rmCreateArea("beautification"+i);
		rmSetAreaSize(id1, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(id1, "EgyptianRoadA");
		rmAddAreaConstraint(id1, avoidImpassableLand);
		rmSetAreaMinBlobs(id1, 1);
		rmSetAreaMaxBlobs(id1, 5);
		rmSetAreaWarnFailure(id1, false);
		rmSetAreaMinBlobDistance(id1, 16.0);
		rmSetAreaMaxBlobDistance(id1, 40.0);
		rmSetAreaCoherence(id1, 0.6);
		rmBuildArea(id1);
	}

	 for(i=1; <cNumberPlayers*12)
	{
		int id2=rmCreateArea("more beautification"+i);
		rmSetAreaSize(id2, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(id2, "SavannahB");
		rmAddAreaConstraint(id2, avoidImpassableLand);
		rmSetAreaMinBlobs(id2, 1);
		rmSetAreaMaxBlobs(id2, 5);
		rmSetAreaWarnFailure(id2, false);
		rmSetAreaMinBlobDistance(id2, 16.0);
		rmSetAreaMaxBlobDistance(id2, 40.0);
		rmSetAreaCoherence(id2, 0.2);
		rmBuildArea(id2);
	}

	for(i=1; <cNumberPlayers*12)
	{
		int id3=rmCreateArea("even more beautification"+i);
		rmSetAreaSize(id3, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(id3, "SavannahA");
		rmAddAreaConstraint(id3, avoidImpassableLand);
		rmSetAreaMinBlobs(id3, 1);
		rmSetAreaMaxBlobs(id3, 5);
		rmSetAreaWarnFailure(id3, false);
		rmSetAreaMinBlobDistance(id3, 16.0);
		rmSetAreaMaxBlobDistance(id3, 40.0);
		rmSetAreaCoherence(id3, 0.2);
		rmBuildArea(id3);
	}

	// Text
	rmSetStatusText("",0.3);

	// Place close stuff
	// Towers
	rmPlaceObjectDefPerPlayer(startingTowerID, true, 4);

	// Straggler trees
	rmPlaceObjectDefPerPlayer(stragglerTreeID, false, rmRandInt(4,7));

	// Gold
	rmPlaceObjectDefPerPlayer(startingGoldID, false);

	// Berries
	rmPlaceObjectDefPerPlayer(closeChickensID, true);

	// Pigs
	rmPlaceObjectDefPerPlayer(closeGoatsID, true);

	// Close hunt
	rmPlaceObjectDefPerPlayer(closeGazelleID, false);

	// Plateau stuff
	// Close gold
	rmPlaceObjectDefPerPlayer(closeGoldID, false);

	// Medium berries
	rmPlaceObjectDefPerPlayer(mediumBerriesID, false);

	// Far berries
	if(cNumberNonGaiaPlayers == 2)
		rmPlaceObjectDefPerPlayer(farBerriesID, false);

	// Medium pigs
	rmPlaceObjectDefPerPlayer(mediumGoatsID, false);

	// Medium predators
	rmPlaceObjectDefPerPlayer(mediumPredatorID, false);

	// Player forest
	int playerForestCount=7*cNumberNonGaiaPlayers;
	int playerFailCount=0;
	for(i=0; <playerForestCount)
	{
		int playerForestID=rmCreateArea("playerForest"+i);
		rmSetAreaSize(playerForestID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));
		rmSetAreaWarnFailure(playerForestID, false);
		rmSetAreaForestType(playerForestID, "palm forest");
		rmAddAreaToClass(playerForestID, classForest);
		rmSetAreaMinBlobs(playerForestID, 1);
		rmSetAreaMaxBlobs(playerForestID, 2);
		rmAddAreaConstraint(playerForestID, furtherCenterConstraint);
		rmAddAreaConstraint(playerForestID, avoidConnections);
		rmAddAreaConstraint(playerForestID, avoidImpassableLand);
		rmAddAreaConstraint(playerForestID, avoidAll);
		rmAddAreaConstraint(playerForestID, forestSettleConstraint);
		rmAddAreaConstraint(playerForestID, forestConstraint);
		rmSetAreaMinBlobDistance(playerForestID, 5.0);
		rmSetAreaMaxBlobDistance(playerForestID, 15.0);
		rmSetAreaCoherence(playerForestID, 0.0);
		if(rmBuildArea(playerForestID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			playerFailCount++;
			if(playerFailCount==3)
				break;
		}
		else
			playerFailCount=0;
	}

	// Text
	rmSetStatusText("",0.2);

	// Center stuff
	// Gold
	rmPlaceObjectDefPerPlayer(mediumGoldID, false, 1);
	rmPlaceObjectDefPerPlayer(farGoldID, false, 2);

	// Huntable
	rmPlaceObjectDefPerPlayer(bonusHuntable0ID, false);
	rmPlaceObjectDefPerPlayer(bonusHuntable1ID, false);
	if(cNumberNonGaiaPlayers == 2)
		rmPlaceObjectDefPerPlayer(bonusHuntable3ID, false);
	if(cNumberNonGaiaPlayers > 4)
		rmPlaceObjectDefPerPlayer(bonusHuntable3ID, false);
	if(rmRandFloat(0,1)<0.75)
		rmPlaceObjectDefPerPlayer(bonusHuntable5ID, false);
	rmPlaceObjectDefPerPlayer(bonusHuntable2ID, false);

	// Center forest
	int centerForestCount=8*cNumberNonGaiaPlayers;
	int centerFailCount=0;
	for(i=0; <centerForestCount)
	{
		int centerForestID=rmCreateArea("centerForest"+i);
		rmSetAreaSize(centerForestID, rmAreaTilesToFraction(60), rmAreaTilesToFraction(80));
		rmSetAreaWarnFailure(centerForestID, false);
		rmSetAreaForestType(centerForestID, "palm forest");
		rmAddAreaToClass(centerForestID, classForest);
		rmSetAreaMinBlobs(centerForestID, 1);
		rmSetAreaMaxBlobs(centerForestID, 2);
		rmAddAreaConstraint(centerForestID, dummyCenterConstraint);
		rmAddAreaConstraint(centerForestID, longAvoidImpassableLand);
		rmAddAreaConstraint(centerForestID, avoidAll);
		rmAddAreaConstraint(centerForestID, forestSettleConstraint);
		rmAddAreaConstraint(centerForestID, forestConstraint);
		rmAddAreaConstraint(centerForestID, avoidBuildings);
		rmSetAreaMinBlobDistance(centerForestID, 16.0);
		rmSetAreaMaxBlobDistance(centerForestID, 20.0);
		rmSetAreaCoherence(centerForestID, 0.0);
		if(rmBuildArea(centerForestID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			centerFailCount++;
			if(centerFailCount==3)
				break;
		}
		else
			centerFailCount=0;
	}

	// Far predators
	rmPlaceObjectDefPerPlayer(farPredatorID, false);
	if(cNumberNonGaiaPlayers == 2)
		rmPlaceObjectDefPerPlayer(bonusHuntable4ID, false);

	// Pigs
	rmPlaceObjectDefPerPlayer(farGoatsID, false);

	// Relics
	if(cNumberNonGaiaPlayers == 2)
		rmPlaceObjectDefPerPlayer(relic1ID, false, 1);
	rmPlaceObjectDefPerPlayer(relic2ID, false, 1);

	// Random trees
	rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);

	// Hawks
	rmPlaceObjectDefPerPlayer(farhawkID, false, 2);

	// Text
	rmSetStatusText("",0.1);

	// Decoration
	int skeletonID=rmCreateObjectDef("dead animal");
	rmAddObjectDefItem(skeletonID, "skeleton animal", 1, 0.0);
	rmSetObjectDefMinDistance(skeletonID, 0.0);
	rmSetObjectDefMaxDistance(skeletonID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(skeletonID, avoidAll);
	rmAddObjectDefConstraint(skeletonID, longAvoidImpassableLand);
	rmPlaceObjectDefAtLoc(skeletonID, 0, 0.5, 0.5, 7*cNumberNonGaiaPlayers);
	/*
	int baboonID=rmCreateObjectDef("pro baboon");
	rmAddObjectDefItem(baboonID, "baboon", 1, 0.0);
	rmSetObjectDefMinDistance(baboonID, 0.0);
	rmSetObjectDefMaxDistance(baboonID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(baboonID, avoidAll);
	rmAddObjectDefConstraint(baboonID, longAvoidImpassableLand);
	rmPlaceObjectDefAtLoc(baboonID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
	*/
	int bushID=rmCreateObjectDef("bush");
	rmAddObjectDefItem(bushID, "bush", 3, 4.0);
	rmSetObjectDefMinDistance(bushID, 0.0);
	rmSetObjectDefMaxDistance(bushID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(bushID, avoidGrass);
	rmAddObjectDefConstraint(bushID, avoidAll);
	rmAddObjectDefConstraint(bushID, avoidImpassableLand);
	rmPlaceObjectDefAtLoc(bushID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);

	int rockID=rmCreateObjectDef("rock small");
	rmAddObjectDefItem(rockID, "rock sandstone small", 1, 0.0);
	rmSetObjectDefMinDistance(rockID, 0.0);
	rmSetObjectDefMaxDistance(rockID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(rockID, avoidAll);
	rmAddObjectDefConstraint(rockID, avoidImpassableLand);
	rmPlaceObjectDefAtLoc(rockID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);

	int signID=rmCreateObjectDef("sings");
	rmAddObjectDefItem(signID, "sign", 1, 0.0);
	rmSetObjectDefMinDistance(signID, 0.0);
	rmSetObjectDefMaxDistance(signID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(signID, avoidAll);
	rmAddObjectDefConstraint(signID, avoidImpassableLand);
	rmPlaceObjectDefAtLoc(signID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);

	if(rmRandFloat(0,1)<0.5)
	{
		int rugsID=rmCreateObjectDef("rugs");
		rmAddObjectDefItem(rugsID, "rugs", rmRandInt(2,3), 3.0);
		rmSetObjectDefMinDistance(rugsID, 0.0);
		rmSetObjectDefMaxDistance(rugsID, 20.0);
		rmAddObjectDefConstraint(rugsID, avoidAll);
		rmAddObjectDefConstraint(rugsID, avoidImpassableLand);
		rmPlaceObjectDefPerPlayer(rugsID, false);

		if(rmRandFloat(0,1)<0.5)
		{
			int moreRugsID=rmCreateObjectDef("more rugs");
			rmAddObjectDefItem(moreRugsID, "rugs", rmRandInt(1,3), 3.0);
			rmSetObjectDefMinDistance(moreRugsID, 10.0);
			rmSetObjectDefMaxDistance(moreRugsID, 20.0);
			rmAddObjectDefConstraint(moreRugsID, avoidAll);
			rmAddObjectDefConstraint(moreRugsID, avoidRugs);
			rmAddObjectDefConstraint(moreRugsID, avoidImpassableLand);
			rmPlaceObjectDefPerPlayer(moreRugsID, false);
		}
	}

	// Text
	rmSetStatusText("",0.01);

	// Notify players
	if(cNumberTeams > 2)
	{
		rmCreateTrigger("team notification");
		rmSetTriggerPriority(5);
		rmSetTriggerActive(true);
		rmAddTriggerCondition("Timer");
		rmAddTriggerEffect("Send Spoofed Chat");
		rmSetTriggerEffectParam("Message", "RebelsRising: This map has not been optimized for 4v4+ and FFA. No balance guaranteed - play at your own risk!", false);
		rmSetTriggerEffectParam("PlayerID", ""+0);
	}
	else if(cNumberNonGaiaPlayers > 6)
	{
		rmCreateTrigger("player notification");
		rmSetTriggerPriority(5);
		rmSetTriggerActive(true);
		rmAddTriggerCondition("Timer");
		rmAddTriggerEffect("Send Spoofed Chat");
		rmSetTriggerEffectParam("Message", "RebelsRising: This map has not been optimized for 4v4+ and FFA. No balance guaranteed - play at your own risk!", false);
		rmSetTriggerEffectParam("PlayerID", ""+0);
	}
}

// Blue Lagoon
void bluelagoon(void)
{
	// Text
	rmSetStatusText("",1.0);

	// Set size
	int playerTiles=7500;
	int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles/0.9);
	rmSetMapSize(size, size);
	rmEchoInfo("Map size="+size+"m x "+size+"m");

	// Init map
	rmSetSeaLevel(-1.0);
	rmTerrainInitialize("SandA", 0.0);
	// rmSetLightingSet("Default");

	// Define clssses
	int classCliff=rmDefineClass("cliff");
	int classPond=rmDefineClass("pond");
	int classPlayer=rmDefineClass("player");
	int classForest=rmDefineClass("forest");
	rmDefineClass("starting settlement");

	// Constraints
	// General
	int farEdgeConstraint=rmCreateBoxConstraint("far edge constraint", rmXTilesToFraction(12), rmZTilesToFraction(12), 1.0-rmXTilesToFraction(12), 1.0-rmZTilesToFraction(12));
	int edgeConstraint=rmCreateBoxConstraint("edge constraint", rmXTilesToFraction(8), rmZTilesToFraction(8), 1.0-rmXTilesToFraction(8), 1.0-rmZTilesToFraction(8));
	int shortEdgeConstraint=rmCreateBoxConstraint("short edge constraint", rmXTilesToFraction(4), rmZTilesToFraction(4), 1.0-rmXTilesToFraction(4), 1.0-rmZTilesToFraction(4));
	int shortAvoidAll=rmCreateTypeDistanceConstraint("short avoid all", "all", 8.0);
	int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 1.0);

	// Terrain
	int farCliffConstraint=rmCreateClassDistanceConstraint("long avoid cliff", rmClassID("cliff"), 25.0);
	int mediumCliffConstraint=rmCreateClassDistanceConstraint("medium avoid cliff", rmClassID("cliff"), 10.0);
	int shortCliffConstraint=rmCreateClassDistanceConstraint("short avoid cliff", rmClassID("cliff"), 5.0);
	int cliffPlayerConstraint=rmCreateClassDistanceConstraint("cliffs stay away from players", classPlayer, 5.0);
	int cliffEdgeConstraint=rmCreateBoxConstraint("cliffs avoid edge of the map", rmXTilesToFraction(32), rmZTilesToFraction(32), 1.0-rmXTilesToFraction(32), 1.0-rmZTilesToFraction(32));
	int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "land", false, 4.0);
	int pondConstraint=rmCreateClassDistanceConstraint("pond vs. pond", rmClassID("pond"), 25.0);
	int mediumPondConstraint=rmCreateClassDistanceConstraint("medium pond constraint", rmClassID("pond"), 8.0);
	int shortPondConstraint=rmCreateClassDistanceConstraint("short pond constraint", rmClassID("pond"), 3.0);

	// Settlements
	int startingSettleConstraint=rmCreateClassDistanceConstraint("avoid starting settlement", rmClassID("starting settlement"), 30.0);
	int shortStartingSettleConstraint=rmCreateClassDistanceConstraint("short avoid starting settlement", rmClassID("starting settlement"), 10.0);
	int avoidSettlement=rmCreateTypeDistanceConstraint("avoid TCs", "AbstractSettlement", 50.0);
	int shortAvoidSettlement=rmCreateTypeDistanceConstraint("short avoid TCs", "AbstractSettlement", 20.0);
	int mediumAvoidSettlement=rmCreateTypeDistanceConstraint("medium avoid TCs", "AbstractSettlement", 45.0); // For ponds, try to lower value without having missing tcs.

	// Gold
	int shortAvoidGold=rmCreateTypeDistanceConstraint("short avoid gold", "gold", 8.0);
	int avoidGold=rmCreateTypeDistanceConstraint("avoid gold", "gold", 30.0);
	int farAvoidGold=rmCreateTypeDistanceConstraint("far avoid gold", "gold", 45.0);

	// Food
	int avoidHunt=rmCreateTypeDistanceConstraint("avoid huntable", "huntable", 35.0);
	int shortAvoidFood=rmCreateTypeDistanceConstraint("short avoid huntable", "food", 8.0);
	int avoidHerdable=rmCreateTypeDistanceConstraint("avoid herdable", "herdable", 40.0);
	int avoidPredator=rmCreateTypeDistanceConstraint("avoid predator", "animalPredator", 40.0);

	// Wood
	int shortForestConstraint=rmCreateClassDistanceConstraint("short avoid forest", rmClassID("forest"), 5.0);
	int mediumForestConstraint=rmCreateClassDistanceConstraint("medium avoid forest", rmClassID("forest"), 12.5);
	int farForestConstraint=rmCreateClassDistanceConstraint("far avoid forest", rmClassID("forest"), 20.0);
	int forestSettleConstraint=rmCreateClassDistanceConstraint("forest settle", rmClassID("starting settlement"), 20.0);

	// Buildings
	int avoidBuildings=rmCreateTypeDistanceConstraint("avoid buildings", "Building", 15.0);
	int avoidTower=rmCreateTypeDistanceConstraint("avoid tower", "tower", 25.0);
	int shortAvoidTower=rmCreateTypeDistanceConstraint("short avoid tower", "tower", 10.0);

	// Text
	rmSetStatusText("",0.9);

	// Define objects
	// Starting settlement
	int startingSettlementID=rmCreateObjectDef("Starting settlement");
	rmAddObjectDefItem(startingSettlementID, "Settlement Level 1", 1, 0.0);
	rmAddObjectDefToClass(startingSettlementID, rmClassID("starting settlement"));
	rmSetObjectDefMinDistance(startingSettlementID, 0.0);
	rmSetObjectDefMaxDistance(startingSettlementID, 0.0);

	// Towers
	int startingTowerID=rmCreateObjectDef("starting tower");
	rmAddObjectDefItem(startingTowerID, "tower", 1, 0.0);
	rmSetObjectDefMinDistance(startingTowerID, 22.0);
	rmSetObjectDefMaxDistance(startingTowerID, 24.0);
	rmAddObjectDefConstraint(startingTowerID, avoidTower);

	// Gold
	int startingGoldID=rmCreateObjectDef("starting gold");
	rmAddObjectDefItem(startingGoldID, "Gold mine small", 1, 0.0);
	rmSetObjectDefMinDistance(startingGoldID, 20.0);
	rmSetObjectDefMaxDistance(startingGoldID, 25.0);
	rmAddObjectDefConstraint(startingGoldID, shortAvoidAll);
	rmAddObjectDefConstraint(startingGoldID, shortAvoidTower);

	// Hunt
	int startingGiraffeID=rmCreateObjectDef("starting giraffes");
	rmAddObjectDefItem(startingGiraffeID, "Giraffe", 4, 3.0);
	rmSetObjectDefMinDistance(startingGiraffeID, 27.5);
	rmSetObjectDefMaxDistance(startingGiraffeID, 27.5);
	rmAddObjectDefConstraint(startingGiraffeID, shortAvoidAll);

	// Berries
	int startingFoodID=rmCreateObjectDef("close food");
	rmAddObjectDefItem(startingFoodID, "berry bush", rmRandInt(5,7), 4.0);
	rmSetObjectDefMinDistance(startingFoodID, 20.0);
	rmSetObjectDefMaxDistance(startingFoodID, 25.0);
	rmAddObjectDefConstraint(startingFoodID, shortAvoidAll);
	rmAddObjectDefConstraint(startingFoodID, shortAvoidGold);

	// Pigs
	int startingPigsID=rmCreateObjectDef("close pigs");
	rmAddObjectDefItem(startingPigsID, "pig", 3, 2.0);
	rmSetObjectDefMinDistance(startingPigsID, 25.0);
	rmSetObjectDefMaxDistance(startingPigsID, 30.0);
	rmAddObjectDefConstraint(startingPigsID, shortAvoidAll);

	// Straggler trees
	int stragglerTreeID=rmCreateObjectDef("straggler tree");
	rmAddObjectDefItem(stragglerTreeID, "savannah tree", 1, 0.0);
	rmSetObjectDefMinDistance(stragglerTreeID, 12.0);
	rmSetObjectDefMaxDistance(stragglerTreeID, 20.0);
	rmAddObjectDefConstraint(stragglerTreeID, shortAvoidGold);
	rmAddObjectDefConstraint(stragglerTreeID, shortAvoidAll);

	// Medium objects
	// Medium gold
	int mediumGoldID=rmCreateObjectDef("medium gold");
	rmAddObjectDefItem(mediumGoldID, "Gold mine", 1, 0.0);
	rmSetObjectDefMinDistance(mediumGoldID, 50.0);
	rmSetObjectDefMaxDistance(mediumGoldID, 65.0);
	rmAddObjectDefConstraint(mediumGoldID, shortAvoidSettlement);
	rmAddObjectDefConstraint(mediumGoldID, edgeConstraint);
	rmAddObjectDefConstraint(mediumGoldID, mediumCliffConstraint);
	rmAddObjectDefConstraint(mediumGoldID, avoidGold);
	rmAddObjectDefConstraint(mediumGoldID, mediumPondConstraint);

	// Medium zebras
	int mediumZebraID=rmCreateObjectDef("medium zebras");
	rmAddObjectDefItem(mediumZebraID, "zebra", rmRandInt(4,5), 3.0);
	rmSetObjectDefMinDistance(mediumZebraID, 55.0);
	rmSetObjectDefMaxDistance(mediumZebraID, 65.0);
	rmAddObjectDefConstraint(mediumZebraID, shortAvoidAll);
	rmAddObjectDefConstraint(mediumZebraID, edgeConstraint);
	rmAddObjectDefConstraint(mediumZebraID, avoidHunt);
	rmAddObjectDefConstraint(mediumZebraID, shortCliffConstraint);
	rmAddObjectDefConstraint(mediumZebraID, startingSettleConstraint);
	rmAddObjectDefConstraint(mediumZebraID, shortPondConstraint);

	// Medium elephants
	int mediumElephantID=rmCreateObjectDef("medium elephants");
	rmAddObjectDefItem(mediumElephantID, "elephant", 2, 3.0);
	rmSetObjectDefMinDistance(mediumElephantID, 60.0);
	rmSetObjectDefMaxDistance(mediumElephantID, 70.0);
	rmAddObjectDefConstraint(mediumElephantID, shortAvoidAll);
	rmAddObjectDefConstraint(mediumElephantID, edgeConstraint);
	rmAddObjectDefConstraint(mediumElephantID, avoidHunt);
	rmAddObjectDefConstraint(mediumElephantID, shortCliffConstraint);
	rmAddObjectDefConstraint(mediumElephantID, startingSettleConstraint);
	rmAddObjectDefConstraint(mediumElephantID, shortPondConstraint);

	// Medium pigs
	int mediumPigsID=rmCreateObjectDef("medium pigs");
	rmAddObjectDefItem(mediumPigsID, "pig", 2, 2.0);
	rmSetObjectDefMinDistance(mediumPigsID, 55.0);
	rmSetObjectDefMaxDistance(mediumPigsID, 65.0);
	rmAddObjectDefConstraint(mediumPigsID, avoidHerdable);
	rmAddObjectDefConstraint(mediumPigsID, shortAvoidAll);
	rmAddObjectDefConstraint(mediumPigsID, edgeConstraint);
	rmAddObjectDefConstraint(mediumPigsID, shortCliffConstraint);
	rmAddObjectDefConstraint(mediumPigsID, shortPondConstraint);

	// Predators
	int predatorID=rmCreateObjectDef("predator");
	rmAddObjectDefItem(predatorID, "hyena", 3, 4.0);
	rmSetObjectDefMinDistance(predatorID, 70.0);
	rmSetObjectDefMaxDistance(predatorID, 70.0);
	rmAddObjectDefConstraint(predatorID, shortAvoidAll);
	rmAddObjectDefConstraint(predatorID, edgeConstraint);
	rmAddObjectDefConstraint(predatorID, avoidPredator);
	rmAddObjectDefConstraint(predatorID, shortCliffConstraint);
	rmAddObjectDefConstraint(predatorID, playerConstraint);
	rmAddObjectDefConstraint(predatorID, shortPondConstraint);

	// Far objects
	// Far gold
	int farGoldID=rmCreateObjectDef("far gold");
	rmAddObjectDefItem(farGoldID, "Gold mine", 1, 0.0);
	rmSetObjectDefMinDistance(farGoldID, 60.0);
	rmSetObjectDefMaxDistance(farGoldID, 100.0);
	rmAddObjectDefConstraint(farGoldID, edgeConstraint);
	rmAddObjectDefConstraint(farGoldID, farAvoidGold);
	rmAddObjectDefConstraint(farGoldID, shortAvoidSettlement);
	rmAddObjectDefConstraint(farGoldID, mediumCliffConstraint);
	rmAddObjectDefConstraint(farGoldID, startingSettleConstraint);
	rmAddObjectDefConstraint(farGoldID, shortPondConstraint);

	// Far zebras
	int farZebraID=rmCreateObjectDef("far zebras");
	rmAddObjectDefItem(farZebraID, "zebra", rmRandInt(5,6), 3.0);
	rmSetObjectDefMinDistance(farZebraID, 70.0);
	rmSetObjectDefMaxDistance(farZebraID, 80.0);
	rmAddObjectDefConstraint(farZebraID, shortAvoidAll);
	rmAddObjectDefConstraint(farZebraID, edgeConstraint);
	rmAddObjectDefConstraint(farZebraID, avoidHunt);
	rmAddObjectDefConstraint(farZebraID, shortCliffConstraint);
	rmAddObjectDefConstraint(farZebraID, startingSettleConstraint);
	rmAddObjectDefConstraint(farZebraID, shortPondConstraint);

	// Far elephants
	int farElephantID=rmCreateObjectDef("far elephants");
	rmAddObjectDefItem(farElephantID, "elephant", 2, 3.0);
	rmSetObjectDefMinDistance(farElephantID, 70.0);
	rmSetObjectDefMaxDistance(farElephantID, 100.0);
	rmAddObjectDefConstraint(farElephantID, shortAvoidAll);
	rmAddObjectDefConstraint(farElephantID, edgeConstraint);
	rmAddObjectDefConstraint(farElephantID, avoidHunt);
	rmAddObjectDefConstraint(farElephantID, shortCliffConstraint);
	rmAddObjectDefConstraint(farElephantID, startingSettleConstraint);
	rmAddObjectDefConstraint(farElephantID, shortPondConstraint);

	// Random Trees
	int randomTreeID=rmCreateObjectDef("random tree");
	rmAddObjectDefItem(randomTreeID, "savannah tree", 1, 0.0);
	rmSetObjectDefMinDistance(randomTreeID, 0.0);
	rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(randomTreeID, rmCreateTypeDistanceConstraint("random tree", "all", 4.0));
	rmAddObjectDefConstraint(randomTreeID, shortAvoidAll);
	rmAddObjectDefConstraint(randomTreeID, shortCliffConstraint);
	rmAddObjectDefConstraint(randomTreeID, shortStartingSettleConstraint);

	// Relics
	int relicID=rmCreateObjectDef("relics");
	rmAddObjectDefItem(relicID, "relic", 1, 0.0);
	rmSetObjectDefMinDistance(relicID, 70.0);
	rmSetObjectDefMaxDistance(relicID, rmXFractionToMeters(0.3));
	rmAddObjectDefConstraint(relicID, rmCreateTypeDistanceConstraint("relic vs relic", "relic", 50.0));
	rmAddObjectDefConstraint(relicID, shortAvoidAll);
	rmAddObjectDefConstraint(relicID, shortCliffConstraint);
	rmAddObjectDefConstraint(relicID, edgeConstraint);
	rmAddObjectDefConstraint(relicID, startingSettleConstraint);

	// Birds
	int farhawkID=rmCreateObjectDef("far hawks");
	rmAddObjectDefItem(farhawkID, "vulture", 1, 0.0);
	rmSetObjectDefMinDistance(farhawkID, 0.0);
	rmSetObjectDefMaxDistance(farhawkID, rmXFractionToMeters(0.5));

	// Text
	rmSetStatusText("",0.8);

	// Player placement
	rmSetTeamSpacingModifier(0.9);
	rmPlacePlayersCircular(0.39, 0.39, rmDegreesToRadians(5.0));

	// Set up player areas
	float playerFraction=rmAreaTilesToFraction(1400);
	for(i=1; <cNumberPlayers)
	{
		int id=rmCreateArea("Player"+i);
		rmSetPlayerArea(i, id);
		rmSetAreaSize(id, playerFraction, playerFraction);
		rmAddAreaToClass(id, classPlayer);
		rmSetAreaTerrainType(id, "GrassDirt50");
		rmAddAreaTerrainLayer(id, "GrassDirt75", 6, 10);
		rmSetAreaWarnFailure(id, false);
		rmSetAreaCoherence(id, 0.6);
		rmSetAreaLocPlayer(id, i);
	}

	rmBuildAllAreas();

	// Text
	rmSetStatusText("",0.7);

	// Place settlements
	rmPlaceObjectDefPerPlayer(startingSettlementID, true);
	int placementInt=0;

	// Settlement 1
	if(cNumberNonGaiaPlayers < 3)
		id=rmAddFairLoc("Settlement", false, true, 60, 80, 40, 16);
	else if(cNumberNonGaiaPlayers < 5)
	{
		if(rmRandFloat(0,1)<0.67)

			id=rmAddFairLoc("Settlement", false, true, 60, 85, 40, 16);
		else
		{
			id=rmAddFairLoc("Settlement", false, false, 60, 85, 40, 16);
			placementInt=1;
		}
	}
	else
		id=rmAddFairLoc("Settlement", false, true, 60, 85, 40, 16);

	if(rmPlaceFairLocs())
	{
		id=rmCreateObjectDef("close settlement");
		rmAddObjectDefItem(id, "Settlement", 1, 0.0);
		for(i=1; <cNumberPlayers)
		{
			for(j=0; <rmGetNumberFairLocs(i))
			{
				int settleArea = rmCreateArea("close settlement area"+i +j, rmAreaID("Player"+i));
				rmSetAreaLocation(settleArea, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j));
				rmBuildArea(settleArea);
				rmPlaceObjectDefAtAreaLoc(id, i, settleArea);
			}
		}
	}

	rmResetFairLocs();

	// Text
	rmSetStatusText("",0.6);

	// Settlement 2
	if(cNumberNonGaiaPlayers < 3)
		id=rmAddFairLoc("Settlement", true, false, 75, 80, 50, 50);
	else if(cNumberNonGaiaPlayers < 5)
	{
		if(placementInt==0)
		{
			if(rmRandFloat(0,1)<0.5)
				id=rmAddFairLoc("Settlement", true, false,  75, 90, 70, 40);
			else
				id=rmAddFairLoc("Settlement", true, true,  75, 85, 70, 100);
		}
		else
			id=rmAddFairLoc("Settlement", true, true,  75, 90, 70, 100);
	}
	else
	{
		if(rmRandFloat(0,1)<0.5)
			id=rmAddFairLoc("Settlement", true, false,  75, 90, 70, 100);
		else
			id=rmAddFairLoc("Settlement", true, true,  75, 90, 70, 120);
	}
	rmAddFairLocConstraint(id, startingSettleConstraint);
	rmAddFairLocConstraint(id, avoidSettlement);

	if(rmPlaceFairLocs())
	{
		id=rmCreateObjectDef("far settlement");
		rmAddObjectDefItem(id, "Settlement", 1, 0.0);
		for(i=1; <cNumberPlayers)
		{
			for(j=0; <rmGetNumberFairLocs(i))
			{
				int farSettleArea = rmCreateArea("far settlement area"+i +j, rmAreaID("Player"+i));
				rmSetAreaLocation(farSettleArea, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j));
				rmBuildArea(farSettleArea);
				rmPlaceObjectDefAtAreaLoc(id, i, farSettleArea);
			}
		}
	}

	// Text
	rmSetStatusText("",0.5);

	// Ponds
	int numTries=150;
	int placeCount=0;
	for(i=0; <numTries)
	{
		int smallPondID=rmCreateArea("small pond"+i);
		rmSetAreaSize(smallPondID, rmAreaTilesToFraction(400), rmAreaTilesToFraction(400));
		if(cNumberNonGaiaPlayers==2)
			rmSetAreaLocation(smallPondID, rmRandFloat(0.25, 0.75), rmRandFloat(0.25, 0.75));
		else
			rmSetAreaLocation(smallPondID, rmRandFloat(0.15, 0.85), rmRandFloat(0.15, 0.85));
		rmSetAreaWaterType(smallPondID, "Egyptian Nile");
		rmSetAreaCoherence(smallPondID, 1.0);
		rmSetAreaMinBlobs(smallPondID, 1);
		rmSetAreaMaxBlobs(smallPondID, 1);
		rmAddAreaConstraint(smallPondID, pondConstraint);
		rmAddAreaConstraint(smallPondID, playerConstraint);
		rmAddAreaConstraint(smallPondID, mediumAvoidSettlement);
		rmSetAreaWarnFailure(smallPondID, false);
		rmAddAreaToClass(smallPondID, classPond);

		if(rmBuildArea(smallPondID)==true)
		{
			placeCount++;
			if(placeCount>2+1.5*cNumberNonGaiaPlayers)
				break;
		}
	}

	// Text
	rmSetStatusText("",0.4);

	// Texture embellishment
	for(i=1; <cNumberPlayers*25)
	{
		int id1=rmCreateArea("beautification"+i);
		rmSetAreaSize(id1, rmAreaTilesToFraction(75), rmAreaTilesToFraction(150));
		rmSetAreaTerrainType(id1, "GrassDirt75");
		rmAddAreaConstraint(id1, shortAvoidImpassableLand);
		rmSetAreaMinBlobs(id1, 1);
		rmSetAreaMaxBlobs(id1, 5);
		rmSetAreaWarnFailure(id1, false);
		rmSetAreaMinBlobDistance(id1, 30.0);
		rmSetAreaMaxBlobDistance(id1, 40.0);
		rmSetAreaCoherence(id1, 0.6);
		rmBuildArea(id1);
	}

	// Text
	rmSetStatusText("",0.3);

	// Cliffs
	numTries=40;
	placeCount=0;
	for(i=0; <numTries)
	{
		int cliffID=rmCreateArea("cliff"+i);
		rmSetAreaWarnFailure(cliffID, false);
		rmSetAreaSize(cliffID, rmAreaTilesToFraction(200), rmAreaTilesToFraction(220));
		rmSetAreaCliffType(cliffID, "Egyptian");
		rmSetAreaCliffEdge(cliffID, 2, 0.25, 0.0, 1.0, 1);
		rmSetAreaCliffPainting(cliffID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliffID, 4, 0.0, 1.0);
		rmSetAreaCoherence(cliffID, 1.0);
		rmSetAreaHeightBlend(cliffID, 1.0);
		rmAddAreaToClass(cliffID, classCliff);
		rmAddAreaConstraint(cliffID, mediumPondConstraint);
		rmAddAreaConstraint(cliffID, shortEdgeConstraint);
		rmAddAreaConstraint(cliffID, avoidBuildings);
		rmAddAreaConstraint(cliffID, farCliffConstraint);
		rmAddAreaConstraint(cliffID, shortAvoidSettlement);
		rmAddAreaConstraint(cliffID, playerConstraint);

		if(rmBuildArea(cliffID)==true)
		{
			placeCount++;
			if(placeCount>3.5*cNumberNonGaiaPlayers)
				break;
		}
	}

	// Text
	rmSetStatusText("",0.2);

	// Place close objects
	// Towers
	rmPlaceObjectDefPerPlayer(startingTowerID, true, 4);

	// Gold
	rmPlaceObjectDefPerPlayer(startingGoldID, false);

	// Hunt
	rmPlaceObjectDefPerPlayer(startingGiraffeID, false);

	// Berries
	rmPlaceObjectDefPerPlayer(startingFoodID, false);

	// Pigs
	rmPlaceObjectDefPerPlayer(startingPigsID, true);

	// Straggler trees
	rmPlaceObjectDefPerPlayer(stragglerTreeID, false, rmRandInt(4,6));

	// Medium objects
	// Gold
	if(cNumberNonGaiaPlayers < 3)
		rmPlaceObjectDefPerPlayer(mediumGoldID, false, 2);
	else
		rmPlaceObjectDefPerPlayer(mediumGoldID, false);

	// Medium hunt
	rmPlaceObjectDefPerPlayer(mediumZebraID, false);
	rmPlaceObjectDefPerPlayer(mediumElephantID, false);

	// Medium pigs
	rmPlaceObjectDefPerPlayer(mediumPigsID, false);

	// Predators
	rmPlaceObjectDefPerPlayer(predatorID, false);

	// Far objects
	// Gold
	if(cNumberNonGaiaPlayers < 3)
		rmPlaceObjectDefPerPlayer(farGoldID, false, 2);
	else if(cNumberNonGaiaPlayers < 5)
		rmPlaceObjectDefPerPlayer(farGoldID, false, 3);
	else
		rmPlaceObjectDefPerPlayer(farGoldID, false, 2);

	// Far hunt
	rmPlaceObjectDefPerPlayer(farZebraID, false);
	rmPlaceObjectDefPerPlayer(farElephantID, false);

	// Relics
	rmPlaceObjectDefPerPlayer(relicID, false);

	// Random trees
	rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);

	// Hawks
	rmPlaceObjectDefPerPlayer(farhawkID, false, 2);

	// Text
	rmSetStatusText("",0.1);

	// Forest
	int failCount=0;
	numTries=12*cNumberNonGaiaPlayers;
	for(i=0; <numTries)
	{
		int forestID=rmCreateArea("forest"+i);
		rmSetAreaSize(forestID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(80));
		rmSetAreaWarnFailure(forestID, false);
		rmSetAreaForestType(forestID, "savannah forest");
		rmAddAreaConstraint(forestID, forestSettleConstraint);
		rmAddAreaConstraint(forestID, shortAvoidAll);
		rmAddAreaConstraint(forestID, farForestConstraint);
		rmAddAreaConstraint(forestID, mediumCliffConstraint);
		rmAddAreaConstraint(forestID, shortPondConstraint);
		rmAddAreaToClass(forestID, classForest);

		rmSetAreaMinBlobs(forestID, 3);
		rmSetAreaMaxBlobs(forestID, 5);
		rmSetAreaMinBlobDistance(forestID, 20.0);
		rmSetAreaMaxBlobDistance(forestID, 30.0);
		rmSetAreaCoherence(forestID, 0.0);

		if(rmBuildArea(forestID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
	}

	// Text
	rmSetStatusText("",0.01);

	// Notify players
	if(cNumberTeams > 2)
	{
		rmCreateTrigger("team notification");
		rmSetTriggerPriority(5);
		rmSetTriggerActive(true);
		rmAddTriggerCondition("Timer");
		rmAddTriggerEffect("Send Spoofed Chat");
		rmSetTriggerEffectParam("Message", "RebelsRising: This map has not been optimized for 4v4+ and FFA. No balance guaranteed - play at your own risk!", false);
		rmSetTriggerEffectParam("PlayerID", ""+0);
	}
	else if(cNumberNonGaiaPlayers > 6)
	{
		rmCreateTrigger("player notification");
		rmSetTriggerPriority(5);
		rmSetTriggerActive(true);
		rmAddTriggerCondition("Timer");
		rmAddTriggerEffect("Send Spoofed Chat");
		rmSetTriggerEffectParam("Message", "RebelsRising: This map has not been optimized for 4v4+ and FFA. No balance guaranteed - play at your own risk!", false);
		rmSetTriggerEffectParam("PlayerID", ""+0);
	}
}

void frozenwastes(void)
{
	// Text
	rmSetStatusText("",1.0);

	// Set size
	int playerTiles = 10200-300*cNumberNonGaiaPlayers;
	int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles/0.9);
	rmEchoInfo("Map size="+size+"m x "+size+"m");
	rmSetMapSize(size, size);

	// Init map.
	rmTerrainInitialize("IceA");
	rmSetLightingSet("Alfheim");

	// Define classes
	int classForest=rmDefineClass("forest");
	rmDefineClass("starting settlement");
	rmDefineClass("smallCenter");

	// Generic stuff
	// Build continent
	int centerID=rmCreateArea("center");
	rmSetAreaSize(centerID, 0.525, 0.525);
	rmSetAreaLocation(centerID, 0.5, 0.5);
	if(cNumberNonGaiaPlayers < 5)
		rmSetAreaCoherence(centerID, 0.0);
	else
		rmSetAreaCoherence(centerID, 0.4);
	rmSetAreaBaseHeight(centerID, 2.0);
	rmSetAreaTerrainType(centerID, "SnowA");
	rmSetAreaSmoothDistance(centerID, 30);
	rmSetAreaHeightBlend(centerID, 2);
	rmAddAreaConstraint(centerID, rmCreateBoxConstraint("center borders", rmXTilesToFraction(10), rmZTilesToFraction(10), 1.0-rmXTilesToFraction(10), 1.0-rmZTilesToFraction(10), 0.01));
	rmBuildArea(centerID);

	// Build small center
	int smallCenterID=rmCreateArea("small center");
	rmSetAreaSize(smallCenterID, 0.11, 0.11);
	rmSetAreaLocation(smallCenterID, 0.5, 0.5);
	rmSetAreaCoherence(smallCenterID, 1.0);
	rmSetAreaTerrainType(smallCenterID, "SnowA");
	rmSetAreaSmoothDistance(smallCenterID, 30);
	rmAddAreaToClass(centerID, rmClassID("smallCenter"));
	rmBuildArea(smallCenterID);

	// Text
	rmSetStatusText("",0.9);

	// Constraints
	// General
	int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 7.5);
	int shortAvoidAll=rmCreateTypeDistanceConstraint("short avoid all", "all", 3.0);
	int edgeMaxConstraint=rmCreateEdgeMaxDistanceConstraint("stay close to ice", rmAreaID("center"), 12.5);
	int mediumEdgeMaxConstraint=rmCreateEdgeMaxDistanceConstraint("stay quite close to ice", rmAreaID("center"), 25.0);
	int edgeMinConstraint=rmCreateEdgeDistanceConstraint("stay away from ice", rmAreaID("center"), 5.0);
	int mediumEdgeMinConstraint=rmCreateEdgeDistanceConstraint("stay a bit away from ice", rmAreaID("center"), 17.5);
	int farEdgeMinConstraint=rmCreateEdgeDistanceConstraint("stay far away from ice", rmAreaID("center"), 50.0);
	int edgeConstraint=rmCreateAreaConstraint("stay on main area", rmAreaID("center"));
	int stayOnCenter=rmCreateAreaConstraint("stay on center", rmAreaID("small center"));
	int avoidCenter=rmCreateAreaDistanceConstraint("avoid small center", rmAreaID("small center"), 5.0);
	int centerEdgeConstraint=rmCreateEdgeMaxDistanceConstraint("stay quite close to center", rmAreaID("small center"), 15.0);

	// Settlement
	int shortAvoidSettlement=rmCreateTypeDistanceConstraint("objects avoid TC by short distance", "AbstractSettlement", 10.0);
	int avoidSettlement=rmCreateTypeDistanceConstraint("objects avoid TC by medium distance", "AbstractSettlement", 20.0);
	int farAvoidSettlement=rmCreateTypeDistanceConstraint("objects avoid TC by great distance", "AbstractSettlement", 45.0);
	int farStartingSettleConstraint=rmCreateClassDistanceConstraint("objects avoid player TCs", rmClassID("starting settlement"), 50.0);

	// Gold
	int avoidGold=rmCreateTypeDistanceConstraint("avoid gold", "gold", 15.0);
	int farAvoidGold=rmCreateTypeDistanceConstraint("far avoid gold", "gold", 40.0);
	int mediumAvoidGold=rmCreateTypeDistanceConstraint("medium avoid gold", "gold", 30.0);
	int shortAvoidGold=rmCreateTypeDistanceConstraint("short avoid gold", "gold", 10.0);

	// Food
	int avoidHunt=rmCreateTypeDistanceConstraint("avoid huntable", "huntable", 40.0);
	int mediumAvoidHunt=rmCreateTypeDistanceConstraint("medium avoid huntable", "huntable", 22.5);
	int avoidFood=rmCreateTypeDistanceConstraint("avoid other food sources", "food", 15.0);
	int avoidPredator=rmCreateTypeDistanceConstraint("avoid predator", "animalPredator", 60.0);
	int goatConstraint=rmCreateAreaDistanceConstraint("goats avoid main", rmAreaID("center"), 5.0);
	int avoidHerdable=rmCreateTypeDistanceConstraint("avoid herdable", "herdable", 55.0);
	int goatEdgeConstraint=rmCreateBoxConstraint("goats avoid edges", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);

	// Forest
	int forestConstraint=rmCreateClassDistanceConstraint("forest v forest", rmClassID("forest"), 25);
	int forestSettleConstraint=rmCreateClassDistanceConstraint("forest settle", rmClassID("starting settlement"), 16.0);

	// Buildings
	int avoidTower=rmCreateTypeDistanceConstraint("towers avoid towers", "tower", 25.0);
	int avoidBuildings=rmCreateTypeDistanceConstraint("avoid buildings", "Building", 15.0);

	// Text
	rmSetStatusText("",0.8);

	// Define objects
	// Starting TC
	int startingSettlementID=rmCreateObjectDef("starting settlement");
	rmAddObjectDefItem(startingSettlementID, "Settlement Level 1", 1, 0.0);
	rmAddObjectDefToClass(startingSettlementID, rmClassID("starting settlement"));
	rmSetObjectDefMinDistance(startingSettlementID, 0.0);
	rmSetObjectDefMaxDistance(startingSettlementID, 0.0);

	// Towers
	int startingTowerID=rmCreateObjectDef("starting tower");
	rmAddObjectDefItem(startingTowerID, "tower", 1, 0.0);
	rmSetObjectDefMinDistance(startingTowerID, 22.0);
	rmSetObjectDefMaxDistance(startingTowerID, 26.0);
	rmAddObjectDefConstraint(startingTowerID, avoidTower);

	// Gold
	int startingGoldID=rmCreateObjectDef("starting gold");
	rmAddObjectDefItem(startingGoldID, "Gold mine small", 1, 0.0);
	rmSetObjectDefMinDistance(startingGoldID, 20.0);
	rmSetObjectDefMaxDistance(startingGoldID, 25.0);
	rmAddObjectDefConstraint(startingGoldID, avoidAll);
	rmAddObjectDefConstraint(startingGoldID, avoidGold);
	rmAddObjectDefConstraint(startingGoldID, mediumEdgeMaxConstraint);
	rmAddObjectDefConstraint(startingGoldID, mediumEdgeMinConstraint);
	rmAddObjectDefConstraint(startingGoldID, edgeMinConstraint);

	// Starting Hunt
	int closeHuntID=rmCreateObjectDef("starting hunt");
	rmAddObjectDefItem(closeHuntID, "caribou", rmRandInt(4,5), 3.0);
	rmSetObjectDefMinDistance(closeHuntID, 20.0);
	rmSetObjectDefMaxDistance(closeHuntID, 25.0);
	rmAddObjectDefConstraint(closeHuntID, avoidAll);
	rmAddObjectDefConstraint(closeHuntID, edgeMinConstraint);
	rmAddObjectDefConstraint(closeHuntID, edgeConstraint);

	// Goats
	int closeGoatsID=rmCreateObjectDef("close goats");
	rmAddObjectDefItem(closeGoatsID, "goat", 2, 2.0);
	rmSetObjectDefMinDistance(closeGoatsID, 25.0);
	rmSetObjectDefMaxDistance(closeGoatsID, 30.0);
	rmAddObjectDefConstraint(closeGoatsID, shortAvoidAll);

	// Berries
	int closeChickensID=rmCreateObjectDef("close Chickens");
	rmAddObjectDefItem(closeChickensID, "berry bush", rmRandInt(7,8), 4.0);
	rmSetObjectDefMinDistance(closeChickensID, 20.0);
	rmSetObjectDefMaxDistance(closeChickensID, 25.0);
	rmAddObjectDefConstraint(closeChickensID, avoidAll);
	rmAddObjectDefConstraint(closeChickensID, edgeMinConstraint);
	rmAddObjectDefConstraint(closeChickensID, edgeConstraint);

	// Straggler trees
	int stragglerTreeID=rmCreateObjectDef("straggler tree");
	rmAddObjectDefItem(stragglerTreeID, "pine snow", 1, 0.0);
	rmSetObjectDefMinDistance(stragglerTreeID, 12.0);
	rmSetObjectDefMaxDistance(stragglerTreeID, 15.0);
	rmAddObjectDefConstraint(stragglerTreeID, shortAvoidGold);
	rmAddObjectDefConstraint(stragglerTreeID, shortAvoidAll);

	// Medium object
	// Berries
	int mediumBerriesID=rmCreateObjectDef("medium berries");
	rmAddObjectDefItem(mediumBerriesID, "berry bush", rmRandInt(7,8), 4.0);
	rmSetObjectDefMinDistance(mediumBerriesID, 60.0);
	rmSetObjectDefMaxDistance(mediumBerriesID, 90.0);
	rmAddObjectDefConstraint(mediumBerriesID, avoidAll);
	rmAddObjectDefConstraint(mediumBerriesID, avoidFood);
	rmAddObjectDefConstraint(mediumBerriesID, edgeConstraint);
	rmAddObjectDefConstraint(mediumBerriesID, edgeMinConstraint);
	rmAddObjectDefConstraint(mediumBerriesID, avoidCenter);

	// Predators
	int mediumPredatorID=rmCreateObjectDef("medium predator");
	rmAddObjectDefItem(mediumPredatorID, "polar bear", rmRandInt(1,2), 4.0);
	rmSetObjectDefMinDistance(mediumPredatorID, 65.0);
	rmSetObjectDefMaxDistance(mediumPredatorID, rmXFractionToMeters(0.25));
	rmAddObjectDefConstraint(mediumPredatorID, shortAvoidAll);
	rmAddObjectDefConstraint(mediumPredatorID, avoidPredator);
	rmAddObjectDefConstraint(mediumPredatorID, edgeConstraint);

	// Hunt
	int mediumHuntID=rmCreateObjectDef("far hunt");
	if(rmRandFloat(0,1)<0.5)
		rmAddObjectDefItem(mediumHuntID, "caribou", rmRandInt(6,7), 3.0);
	else
		rmAddObjectDefItem(mediumHuntID, "elk", rmRandInt(6,7), 3.0);
	rmSetObjectDefMinDistance(mediumHuntID, 50.0);
	rmSetObjectDefMaxDistance(mediumHuntID, 70.0);
	rmAddObjectDefConstraint(mediumHuntID, shortAvoidGold);
	rmAddObjectDefConstraint(mediumHuntID, edgeMinConstraint);
	rmAddObjectDefConstraint(mediumHuntID, edgeConstraint);
	rmAddObjectDefConstraint(mediumHuntID, avoidCenter);

	// Far objects
	// Center hunt
	int centerHuntID=rmCreateObjectDef("center hunt");
	rmAddObjectDefItem(centerHuntID, "walrus", rmRandInt(4,5), 3.0);
	rmSetObjectDefMinDistance(centerHuntID, 60.0);
	rmSetObjectDefMaxDistance(centerHuntID, rmXFractionToMeters(0.225));
	rmAddObjectDefConstraint(centerHuntID, stayOnCenter);
	rmAddObjectDefConstraint(centerHuntID, mediumAvoidHunt);
	rmAddObjectDefConstraint(centerHuntID, centerEdgeConstraint);

	// Bonus hunt
	int bonusHuntID=rmCreateObjectDef("bonus hunt");
	rmAddObjectDefItem(bonusHuntID, "walrus", rmRandInt(4,5), 3.0);
	rmSetObjectDefMinDistance(bonusHuntID, 15.0);
	rmSetObjectDefMaxDistance(bonusHuntID, 30.0);
	rmAddObjectDefConstraint(bonusHuntID, stayOnCenter);
	rmAddObjectDefConstraint(bonusHuntID, shortAvoidAll);
	rmAddObjectDefConstraint(bonusHuntID, avoidFood);

	// Goats
	int goatID=rmCreateObjectDef("goats");
	rmAddObjectDefItem(goatID, "goat", 2, 2.0);
	rmSetObjectDefMinDistance(goatID, 50.0);
	rmSetObjectDefMaxDistance(goatID, rmXFractionToMeters(0.6));
	rmAddObjectDefConstraint(goatID, avoidAll);
	rmAddObjectDefConstraint(goatID, goatConstraint);
	rmAddObjectDefConstraint(goatID, avoidHerdable);
	rmAddObjectDefConstraint(goatID, goatEdgeConstraint);

	// Predators
	int farPredatorID=rmCreateObjectDef("far predator");
	rmAddObjectDefItem(farPredatorID, "polar bear", rmRandInt(1,2), 4.0);
	rmSetObjectDefMinDistance(farPredatorID, 75.0);
	rmSetObjectDefMaxDistance(farPredatorID, rmXFractionToMeters(0.35));
	rmAddObjectDefConstraint(farPredatorID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(farPredatorID, shortAvoidAll);
	rmAddObjectDefConstraint(farPredatorID, avoidPredator);
	rmAddObjectDefConstraint(farPredatorID, edgeConstraint);

	// Random Trees
	int randomTreeID=rmCreateObjectDef("random tree");
	rmAddObjectDefItem(randomTreeID, "pine snow", 1, 0.0);
	rmSetObjectDefMinDistance(randomTreeID, 0.0);
	rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(randomTreeID, rmCreateTypeDistanceConstraint("random tree", "all", 4.0));
	rmAddObjectDefConstraint(randomTreeID, shortAvoidSettlement);
	rmAddObjectDefConstraint(randomTreeID, avoidAll);
	rmAddObjectDefConstraint(randomTreeID, edgeConstraint);

	// Relics
	int relicID=rmCreateObjectDef("relics");
	rmAddObjectDefItem(relicID, "relic", 1, 0.0);
	rmSetObjectDefMinDistance(relicID, 70.0);
	rmSetObjectDefMaxDistance(relicID, 90.0);
	rmAddObjectDefConstraint(relicID, edgeConstraint);
	rmAddObjectDefConstraint(relicID, rmCreateTypeDistanceConstraint("relic vs relic", "relic", 50.0));
	rmAddObjectDefConstraint(relicID, avoidAll);

	// Birds
	int farhawkID=rmCreateObjectDef("far hawks");
	rmAddObjectDefItem(farhawkID, "vulture", 1, 0.0);
	rmSetObjectDefMinDistance(farhawkID, 0.0);
	rmSetObjectDefMaxDistance(farhawkID, rmXFractionToMeters(0.5));

	// Text
	rmSetStatusText("",0.7);

	// Place Players
	int startPos = rmRandInt(1,4);
	if(cNumberNonGaiaPlayers == 2)
	{
		if(startPos == 1)
		{
			rmPlacePlayer(1, rmRandFloat(0.23,0.24), rmRandFloat(0.23,0.24));
			rmPlacePlayer(2, rmRandFloat(0.76,0.77), rmRandFloat(0.76,0.77));
		}
	  else if(startPos == 2)
		{
			rmPlacePlayer(1, rmRandFloat(0.73,0.74), rmRandFloat(0.73,0.74));
			rmPlacePlayer(2, rmRandFloat(0.26,0.27), rmRandFloat(0.26,0.27));
		}
	  else if(startPos == 3)
		{
			rmPlacePlayer(1, rmRandFloat(0.73,0.74), rmRandFloat(0.26,0.27));
			rmPlacePlayer(2, rmRandFloat(0.26,0.27), rmRandFloat(0.73,0.74));
		}
	  else if(startPos == 4)
		{
			rmPlacePlayer(1, rmRandFloat(0.26,0.27), rmRandFloat(0.73,0.74));
			rmPlacePlayer(2, rmRandFloat(0.73,0.74), rmRandFloat(0.26,0.27));
		}
	}
	else if(cNumberTeams < 3)
	{
		rmSetTeamSpacingModifier(0.9);
		if(cNumberNonGaiaPlayers < 5)
			rmPlacePlayersCircular(0.35, 0.35, rmDegreesToRadians(5.0));
		else
			rmPlacePlayersCircular(0.34, 0.34, rmDegreesToRadians(5.0));
	}
	else
	{
		rmSetTeamSpacingModifier(0.9);
		rmPlacePlayersCircular(0.35, 0.35, rmDegreesToRadians(5.0));
	}


	// Text
	rmSetStatusText("",0.6);

	// Set up player areas.
	float playerFraction=rmAreaTilesToFraction(1000);
	for(i=1; <cNumberPlayers)
	{
		int id=rmCreateArea("Player"+i);
		rmSetPlayerArea(i, id);
		rmSetAreaSize(id, 1.0*playerFraction, 1.0*playerFraction);
		rmSetAreaCoherence(id, 0.85);
		rmSetAreaLocPlayer(id, i);
		rmSetAreaSmoothDistance(id, 10);
		rmSetAreaTerrainType(id, "SnowA");
	}

	rmBuildAllAreas();

	// Starting TC
	rmPlaceObjectDefPerPlayer(startingSettlementID, true);

	// Fair gold
	if(cNumberNonGaiaPlayers < 5)
	{
		id=rmAddFairLoc("first gold", false, true, 75, 90, 20, 10);
		rmAddFairLocConstraint(id, edgeMinConstraint);
		rmAddFairLocConstraint(id, edgeMaxConstraint);
		rmAddFairLocConstraint(id, edgeConstraint);
		rmAddFairLocConstraint(id, avoidGold);
	}
	if(cNumberNonGaiaPlayers == 2)
		id=rmAddFairLoc("second gold", true, false, 100, 105, 40, 10);
	else if(cNumberNonGaiaPlayers < 5)
		id=rmAddFairLoc("second gold", true, false, 60, 70, 40, 10);
	else
	{
		id=rmAddFairLoc("second gold", true, false, 60, 70, 70, 10);
		rmAddFairLocConstraint(id, farStartingSettleConstraint);
	}
	rmAddFairLocConstraint(id, edgeMinConstraint);
	rmAddFairLocConstraint(id, edgeMaxConstraint);
	rmAddFairLocConstraint(id, edgeConstraint);
	rmAddFairLocConstraint(id, avoidGold);
	if(cNumberNonGaiaPlayers == 2)
		id=rmAddFairLoc("third gold", true, false, 115, 125, 40, 10);
	else if(cNumberNonGaiaPlayers < 5)
		id=rmAddFairLoc("third gold", true, false, 100, 105, 40, 10);
	else
	{
		id=rmAddFairLoc("third gold", true, false, 100, 105, 70, 10);
		rmAddFairLocConstraint(id, farStartingSettleConstraint);
	}
	rmAddFairLocConstraint(id, edgeMinConstraint);
	rmAddFairLocConstraint(id, edgeMaxConstraint);
	rmAddFairLocConstraint(id, edgeConstraint);
	rmAddFairLocConstraint(id, farAvoidGold);

	if(rmPlaceFairLocs())
	{
		id=rmCreateObjectDef("fair gold");
		rmAddObjectDefItem(id, "Gold mine", 1, 0.0);
		for(i=1; <cNumberPlayers)
		{
			for(j=0; <rmGetNumberFairLocs(i))
			{
				int firstGoldArea = rmCreateArea("fair gold area"+i +j);
				rmSetAreaLocation(firstGoldArea, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j));
				rmBuildArea(firstGoldArea);
				rmPlaceObjectDefAtAreaLoc(id, i, firstGoldArea);
			}
		}
	}

	rmResetFairLocs();

	// Text
	rmSetStatusText("",0.5);

	// Settlement 1
	if(cNumberNonGaiaPlayers == 2)
		id=rmAddFairLoc("Settlement", false, true, 60, 65, 50, 65);
	else
		id=rmAddFairLoc("Settlement", false, true, 70, 80, 40, 40);
	rmAddFairLocConstraint(id, mediumAvoidGold);

	if(rmPlaceFairLocs())
	{
		id=rmCreateObjectDef("settlement 1");
		rmAddObjectDefItem(id, "Settlement", 1, 0.0);
		for(i=1; <cNumberPlayers)
		{
			for(j=0; <rmGetNumberFairLocs(i))
				rmPlaceObjectDefAtLoc(id, i, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j), 1);
		}
	}

	rmResetFairLocs();

	// Settlement 2
	if(cNumberNonGaiaPlayers == 2)
	{
		if(rmRandFloat(0,1)<0.85)
			id=rmAddFairLoc("Settlement", true, false, 75, 80, 50, 70);
		else
			id=rmAddFairLoc("Settlement", false, true, 65, 70, 50, 55);
			rmAddFairLocConstraint(id, farAvoidSettlement);
	}
	else if(cNumberNonGaiaPlayers < 5)
	{
		id=rmAddFairLoc("Settlement", true, true, 80, 85, 60, 10);
		rmAddFairLocConstraint(id, farAvoidSettlement);
	}
	else
	{
		if(rmRandFloat(0,1)<0.33)
			id=rmAddFairLoc("Settlement", true, false, 80, 95, 60, 10);
		else
			id=rmAddFairLoc("Settlement", true, true, 80, 90, 60, 10);
		rmAddFairLocConstraint(id, farAvoidSettlement);
		rmAddFairLocConstraint(id, farEdgeMinConstraint);
	}
	rmAddFairLocConstraint(id, avoidGold);

	if(rmPlaceFairLocs())
	{
		id=rmCreateObjectDef("bonus settlement");
		rmAddObjectDefItem(id, "Settlement", 1, 0.0);
		for(i=1; <cNumberPlayers)
		{
			for(j=0; <rmGetNumberFairLocs(i))
			{
				int bonusSettleArea = rmCreateArea("bonus settlement area"+i +j);
				rmSetAreaLocation(bonusSettleArea, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j));
				rmBuildArea(bonusSettleArea);
				rmPlaceObjectDefAtAreaLoc(id, i, bonusSettleArea);
			}
		}
	}

	// Text
	rmSetStatusText("",0.4);

	// Slight Elevation
	int numTries=8*cNumberNonGaiaPlayers;
	int failCount=0;
	for(i=0; <numTries)
	{
		int elevID=rmCreateArea("elev"+i);
		rmSetAreaSize(elevID, rmAreaTilesToFraction(15), rmAreaTilesToFraction(80));
		rmSetAreaWarnFailure(elevID, false);
		rmAddAreaConstraint(elevID, avoidBuildings);
		rmAddAreaConstraint(elevID, edgeConstraint);
		rmSetAreaBaseHeight(elevID, rmRandFloat(4.0, 7.0));
		rmSetAreaHeightBlend(elevID, 2);
		rmSetAreaMinBlobs(elevID, 1);
		rmSetAreaMaxBlobs(elevID, 5);
		rmSetAreaMinBlobDistance(elevID, 16.0);
		rmSetAreaMaxBlobDistance(elevID, 40.0);
		rmSetAreaCoherence(elevID, 0.0);

		if(rmBuildArea(elevID)==false)
		{
			// Stop trying once we fail 6 times in a row.
			failCount++;
			if(failCount==6)
				break;
		}
		else
			failCount=0;
	}

	// Texture embellishment
	for(i=1; <cNumberPlayers*15)
	{
		int id1=rmCreateArea("beautification"+i);
		rmSetAreaSize(id1, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(id1, "SnowB");
		rmAddAreaConstraint(id1, edgeConstraint);
		rmSetAreaMinBlobs(id1, 1);
		rmSetAreaMaxBlobs(id1, 5);
		rmSetAreaWarnFailure(id1, false);
		rmSetAreaMinBlobDistance(id1, 16.0);
		rmSetAreaMaxBlobDistance(id1, 40.0);
		rmSetAreaCoherence(id1, 0.6);
		rmBuildArea(id1);
	}

	 for(i=1; <cNumberPlayers*10)
	{
		int id2=rmCreateArea("more beautification"+i);
		rmSetAreaSize(id2, rmAreaTilesToFraction(60), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(id2, "SnowSand25");
		rmAddAreaConstraint(id2, edgeConstraint);
		rmSetAreaMinBlobs(id2, 1);
		rmSetAreaMaxBlobs(id2, 5);
		rmSetAreaWarnFailure(id2, false);
		rmSetAreaMinBlobDistance(id2, 16.0);
		rmSetAreaMaxBlobDistance(id2, 40.0);
		rmSetAreaCoherence(id2, 0.4);
		rmBuildArea(id2);
	}

	// Text
	rmSetStatusText("",0.3);

	// Place close objects
	// Starting gold
	rmPlaceObjectDefPerPlayer(startingGoldID, false, 2);

	// Towers
	rmPlaceObjectDefPerPlayer(startingTowerID, true, 4);

	// Close hunt
	rmPlaceObjectDefPerPlayer(closeHuntID, false);

	// Starting berries
	rmPlaceObjectDefPerPlayer(closeChickensID, false);

	// Medium objects
	// Hunt
	rmPlaceObjectDefPerPlayer(mediumHuntID, false);

	// Berries
	rmPlaceObjectDefPerPlayer(mediumBerriesID, false);

	// Far objects
	// Center hunt
	if(cNumberNonGaiaPlayers == 2)
		rmPlaceObjectDefPerPlayer(centerHuntID, false, rmRandInt(1,2));
	else
	{
		rmPlaceObjectDefPerPlayer(centerHuntID, false, 1);
		rmPlaceObjectDefAtLoc(bonusHuntID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);
	}

	// Goats
	rmPlaceObjectDefPerPlayer(goatID, false, rmRandInt(5,7));

	// Starting goats
	// Placed after the other goats to bypass avoidHerdable
	rmPlaceObjectDefPerPlayer(closeGoatsID, true);

	// Text
	rmSetStatusText("",0.2);

	// Forest
	int forestCount=13*cNumberNonGaiaPlayers;
	failCount=0;
	for(i=0; <forestCount)
	{
		int forestID=rmCreateArea("forest"+i);
		rmSetAreaSize(forestID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));
		rmSetAreaWarnFailure(forestID, false);
		rmSetAreaForestType(forestID, "snow pine forest");
		rmAddAreaToClass(forestID, classForest);
		rmSetAreaMinBlobs(forestID, 1);
		rmSetAreaMaxBlobs(forestID, 3);
		rmAddAreaConstraint(forestID, edgeMinConstraint);
		rmAddAreaConstraint(forestID, edgeConstraint);
		rmAddAreaConstraint(forestID, avoidAll);
		rmAddAreaConstraint(forestID, forestSettleConstraint);
		rmAddAreaConstraint(forestID, forestConstraint);
		rmAddAreaConstraint(forestID, avoidBuildings);
		rmSetAreaMinBlobDistance(forestID, 16.0);
		rmSetAreaMaxBlobDistance(forestID, 40.0);
		rmSetAreaCoherence(forestID, 0.0);
		if(rmBuildArea(forestID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
	}

	// Other stuff
	// Straggler trees
	rmPlaceObjectDefPerPlayer(stragglerTreeID, false, rmRandInt(4,7));

	// Predators
	rmPlaceObjectDefPerPlayer(mediumPredatorID, false);
	rmPlaceObjectDefPerPlayer(farPredatorID, false);

	// Relics
	rmPlaceObjectDefPerPlayer(relicID, false, 1);

	// Random trees
	rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);

	// Hawks
	rmPlaceObjectDefPerPlayer(farhawkID, false, 2);

	// Text
	rmSetStatusText("",0.1);

	// Embellishment
	int rock1ID=rmCreateObjectDef("rock 1 group");
	rmAddObjectDefItem(rock1ID, "rock granite sprite", 1, 2.0);
	rmSetObjectDefMinDistance(rock1ID, 0.0);
	rmSetObjectDefMaxDistance(rock1ID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(rock1ID, avoidAll);
	rmAddObjectDefConstraint(rock1ID, edgeConstraint);
	rmPlaceObjectDefAtLoc(rock1ID, 0, 0.5, 0.5, 12*cNumberNonGaiaPlayers);

	int rock2ID=rmCreateObjectDef("rock 2 group");
	rmAddObjectDefItem(rock2ID, "rock granite small", 1, 2.0);
	rmSetObjectDefMinDistance(rock2ID, 0.0);
	rmSetObjectDefMaxDistance(rock2ID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(rock2ID, avoidAll);
	rmAddObjectDefConstraint(rock2ID, edgeConstraint);
	rmPlaceObjectDefAtLoc(rock2ID, 0, 0.5, 0.5, 7*cNumberNonGaiaPlayers);

	int runeID=rmCreateObjectDef("runestone");
	rmAddObjectDefItem(runeID, "runestone", 1, 0.0);
	rmSetObjectDefMinDistance(runeID, 0.0);
	rmSetObjectDefMaxDistance(runeID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(runeID, avoidAll);
	rmAddObjectDefConstraint(runeID, edgeConstraint);
	rmAddObjectDefConstraint(runeID, avoidBuildings);
	rmPlaceObjectDefAtLoc(runeID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);

	int driftID=rmCreateObjectDef("snow drift");
	rmAddObjectDefItem(driftID, "snow drift", 1, 0.0);
	rmSetObjectDefMinDistance(driftID, 0.0);
	rmSetObjectDefMaxDistance(driftID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(driftID, avoidAll);
	rmAddObjectDefConstraint(driftID, edgeConstraint);
	rmAddObjectDefConstraint(driftID, rmCreateTypeDistanceConstraint("drift vs drift", "snow drift", 25.0));
	rmPlaceObjectDefAtLoc(driftID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);

	// Text
	rmSetStatusText("", 0.01);

	// Notify players
	if(cNumberTeams > 2)
	{
		rmCreateTrigger("team notification");
		rmSetTriggerPriority(5);
		rmSetTriggerActive(true);
		rmAddTriggerCondition("Timer");
		rmAddTriggerEffect("Send Spoofed Chat");
		rmSetTriggerEffectParam("Message", "RebelsRising: This map has not been optimized for 4v4+ and FFA. No balance guaranteed - play at your own risk!", false);
		rmSetTriggerEffectParam("PlayerID", ""+0);
	}
	else if(cNumberNonGaiaPlayers > 6)
	{
		rmCreateTrigger("player notification");
		rmSetTriggerPriority(5);
		rmSetTriggerActive(true);
		rmAddTriggerCondition("Timer");
		rmAddTriggerEffect("Send Spoofed Chat");
		rmSetTriggerEffectParam("Message", "RebelsRising: This map has not been optimized for 4v4+ and FFA. No balance guaranteed - play at your own risk!", false);
		rmSetTriggerEffectParam("PlayerID", ""+0);
	}
}

// Nile Delta
void niledelta(void)
{
	// Text
	rmSetStatusText("",1.0);

	// Set size
	int playerTiles=9000;
	int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles/0.9);
	int skew=rmRandInt(1,2);
	if(cNumberNonGaiaPlayers < 5)
	{
		rmSetMapSize(size, size);
		rmEchoInfo("Map size="+size+"m x "+size+"m");
	}
	else
	{
		skew=1;
		rmSetMapSize(size, size*1.1);
		rmEchoInfo("Map size="+size+"m x "+size*1.1+"m");
	}

	// Set up default water
	rmSetSeaLevel(1.0);
	rmSetSeaType("Egyptian Nile Shallow");

	// Init map
	rmTerrainInitialize("water");
	// rmSetLightingSet("Default");

	// Define Classes
	int classLand=rmDefineClass("land");
	int classOcean=rmDefineClass("ocean");
	int classPlayer=rmDefineClass("player");
	int classBonusHuntable=rmDefineClass("bonus huntable");
	int classForest=rmDefineClass("forest");
	rmDefineClass("starting settlement");
	rmDefineClass("center line");

	// Constraints
	// General
	int divisionConstraint=0;
	if(skew==1)
		divisionConstraint=rmCreateBoxConstraint("divide map", 0.45, 0.0, 0.55, 1.0, 0.01);
	else
		divisionConstraint=rmCreateBoxConstraint("divide map", 0.0, 0.45, 1.0, 0.55, 0.01);
	int edgeConstraint=rmCreateBoxConstraint("avoid edges", rmXTilesToFraction(4), rmZTilesToFraction(4), 1.0-rmXTilesToFraction(4), 1.0-rmZTilesToFraction(4), 0.01);
	int mediumEdgeConstraint=rmCreateBoxConstraint("medium avoid edges", rmXTilesToFraction(8), rmZTilesToFraction(8), 1.0-rmXTilesToFraction(8), 1.0-rmZTilesToFraction(8), 0.01);
	int longEdgeConstraint=rmCreateBoxConstraint("long avoid edges", rmXTilesToFraction(12), rmZTilesToFraction(12), 1.0-rmXTilesToFraction(12), 1.0-rmZTilesToFraction(12), 0.01);
	int shortAvoidAll=rmCreateTypeDistanceConstraint("short avoid all", "all", 3.0);
	int mediumAvoidAll=rmCreateTypeDistanceConstraint("medium avoid all", "all", 8.0);
	int tinyCenterLineConstraint=rmCreateClassDistanceConstraint("stay a tiny bit away from center line", rmClassID("center line"), 1.0);
	int shortCenterLineConstraint=rmCreateClassDistanceConstraint("stay a bit away from center line", rmClassID("center line"), 15.0);
	int mediumCenterLineConstraint=rmCreateClassDistanceConstraint("stay away from center line", rmClassID("center line"), 20.0);
	int farCenterLineConstraint=rmCreateClassDistanceConstraint("stay far away from center line", rmClassID("center line"), 50.0);

	// Terrain
	int oceanConstraint=0;
	int smallOceanConstraint=0;
	if(skew==1)
	{
		if(cNumberNonGaiaPlayers < 3)
			oceanConstraint=rmCreateBoxConstraint("limit ocean", 0.0, 0.48, 1.0, 1.0, 0.01);
		else if(cNumberNonGaiaPlayers < 5)
		{
			oceanConstraint=rmCreateBoxConstraint("limit ocean", 0.0, 0.54, 1.0, 1.0, 0.01);
			smallOceanConstraint=rmCreateBoxConstraint("limit small ocean", 0.0, 0.0, 1.0, 0.22, 0.01);
		}
		else
		{
			oceanConstraint=rmCreateBoxConstraint("limit ocean", 0.0, 0.54, 1.0, 1.0, 0.01);
			smallOceanConstraint=rmCreateBoxConstraint("limit small ocean", 0.0, 0.0, 1.0, 0.18, 0.01);
		}
	}
	else
	{
		if(cNumberNonGaiaPlayers < 3)
			oceanConstraint=rmCreateBoxConstraint("limit ocean", 0.48, 0.0, 1.0, 1.0, 0.01);
		else if(cNumberNonGaiaPlayers < 5)
		{
			oceanConstraint=rmCreateBoxConstraint("limit ocean", 0.54, 0.0, 1.0, 1.0, 0.01);
			smallOceanConstraint=rmCreateBoxConstraint("limit small ocean", 0.0, 0.0, 0.22, 1.0, 0.01);
		}
		else
		{
			oceanConstraint=rmCreateBoxConstraint("limit ocean", 0.54, 0.0, 1.0, 1.0, 0.01);
			smallOceanConstraint=rmCreateBoxConstraint("limit small ocean", 0.0, 0.0, 0.18, 1.0, 0.01);
		}
	}
	int oceanAvoidsLand=rmCreateClassDistanceConstraint("oceans avoid land", classLand, 1.0);
	int farAvoidOcean=rmCreateClassDistanceConstraint("avoid ocean by far", classOcean, 25.0);
	int mediumAvoidOcean=rmCreateClassDistanceConstraint("avoid ocean a bit", classOcean, 15.0);
	int shortAvoidOcean=rmCreateClassDistanceConstraint("avoid ocean by a tiny bit", classOcean, 7.5);
	int nearShore=rmCreateTerrainMaxDistanceConstraint("near shore", "water", true, 8.0);

	// Shallows
	int shallowConstraintSW=0;
	int shallowConstraintNE=0;
	if(skew==1)
	{
		shallowConstraintSW=rmCreateBoxConstraint("SW avoids shallows", 0.0, 0.0, 0.47, 1.0, 0.01);
		shallowConstraintNE=rmCreateBoxConstraint("NE avoids shallows", 0.53, 0.0, 1.0, 1.0, 0.01);
	}
	else
	{
		shallowConstraintSW=rmCreateBoxConstraint("SE avoids shallows", 0.0, 0.0, 1.0, 0.47, 0.01);
		shallowConstraintNE=rmCreateBoxConstraint("NW avoids shallows", 0.0, 0.53, 1.0, 1.0, 0.01);
	}

	// Settlements
	int startingSettleConstraint=rmCreateClassDistanceConstraint("avoid starting settlement", rmClassID("starting settlement"), 30.0);
	int avoidSettlement=rmCreateTypeDistanceConstraint("objects avoid TC", "AbstractSettlement", 10.0);
	int settlementVsSettlement=rmCreateTypeDistanceConstraint("TCs avoid TCs", "AbstractSettlement", 25.0);
	int settlementAvoidsOcean=rmCreateClassDistanceConstraint("settlements avoid ocean by far", classOcean, 35.0);

	// Gold
	int shortAvoidGold=rmCreateTypeDistanceConstraint("short avoid gold", "gold", 8.0);
	int avoidGold=rmCreateTypeDistanceConstraint("avoid gold", "gold", 30.0);
	int farAvoidGold=rmCreateTypeDistanceConstraint("far avoid gold", "gold", 40.0);

	// Food
	int foodZone=0;
	if(skew==1)
		foodZone=rmCreateBoxConstraint("food zone", 0.0, 0.15, 1.0, 0.15, 0.01);
	else
		foodZone=rmCreateBoxConstraint("food zone", 0.15, 0.0, 0.15, 1.0, 0.01);
	int avoidHerdable=rmCreateTypeDistanceConstraint("avoid herdable", "herdable", 40.0);
	int avoidPredator=rmCreateTypeDistanceConstraint("avoid predator", "animalPredator", 40.0);
	int mediumAvoidHunt=rmCreateTypeDistanceConstraint("avoid huntable by a bit", "huntable", 30.0);
	int shortAvoidHunt=rmCreateTypeDistanceConstraint("short avoid huntable", "huntable", 20.0);
	int avoidBonusHuntable=rmCreateClassDistanceConstraint("avoid bonus huntable", rmClassID("bonus huntable"),35.0);
	int shortFishVsFishID=rmCreateTypeDistanceConstraint("short fish v fish", "fish", 10.0);
	int longFishVsFishID=rmCreateTypeDistanceConstraint("long fish v fish", "fish", 15.0);
	int extraFishVsFishID=rmCreateTypeDistanceConstraint("extra fish v fish", "fish", 30.0);
	int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 20.0);
	int fishLand=rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
	int fishNearShore=rmCreateTerrainMaxDistanceConstraint("fish near shore", "water", true, 25.0);

	// Wood
	int forestConstraint=rmCreateClassDistanceConstraint("forest v forest", rmClassID("forest"), 22.0);
	int forestSettleConstraint=rmCreateClassDistanceConstraint("forest settle", rmClassID("starting settlement"), 20.0);

	// Buildings
	int avoidTower=rmCreateTypeDistanceConstraint("avoid tower", "tower", 25.0);
	int shortAvoidTower=rmCreateTypeDistanceConstraint("short avoid tower", "tower", 15.0);

	// Text
	rmSetStatusText("",0.9);

	// Define objects
	// Starting Settlement
	int startingSettlementID=rmCreateObjectDef("starting settlement");
	rmAddObjectDefItem(startingSettlementID, "Settlement Level 1", 1, 0.0);
	rmAddObjectDefToClass(startingSettlementID, rmClassID("starting settlement"));
	rmSetObjectDefMinDistance(startingSettlementID, 0.0);
	rmSetObjectDefMaxDistance(startingSettlementID, 0.0);

	// Towers
	int startingTowerID=rmCreateObjectDef("starting tower");
	rmAddObjectDefItem(startingTowerID, "tower", 1, 0.0);
	rmSetObjectDefMinDistance(startingTowerID, 22.0);
	rmSetObjectDefMaxDistance(startingTowerID, 24.0);
	rmAddObjectDefConstraint(startingTowerID, avoidTower);
	rmAddObjectDefConstraint(startingTowerID, farAvoidOcean);

	// Gold
	int startingGoldID=rmCreateObjectDef("starting gold");
	rmAddObjectDefItem(startingGoldID, "Gold mine small", 1, 0.0);
	rmSetObjectDefMinDistance(startingGoldID, 20.0);
	rmSetObjectDefMaxDistance(startingGoldID, 25.0);
	rmAddObjectDefConstraint(startingGoldID, mediumAvoidOcean);
	rmAddObjectDefConstraint(startingGoldID, shortAvoidAll);

	// Berries
	int startingFoodID=rmCreateObjectDef("close food");
	rmAddObjectDefItem(startingFoodID, "berry bush", rmRandInt(5,7), 4.0);
	rmSetObjectDefMinDistance(startingFoodID, 20.0);
	rmSetObjectDefMaxDistance(startingFoodID, 25.0);
	rmAddObjectDefConstraint(startingFoodID, shortAvoidAll);

	// Pigs
	int startingPigsID=rmCreateObjectDef("close pigs");
	rmAddObjectDefItem(startingPigsID, "pig", 4, 2.0);
	rmSetObjectDefMinDistance(startingPigsID, 25.0);
	rmSetObjectDefMaxDistance(startingPigsID, 30.0);
	rmAddObjectDefConstraint(startingPigsID, shortAvoidAll);
	rmAddObjectDefConstraint(startingPigsID, edgeConstraint);

	// Straggler trees
	int stragglerTreeID=rmCreateObjectDef("straggler tree");
	rmAddObjectDefItem(stragglerTreeID, "palm", 1, 0.0);
	rmSetObjectDefMinDistance(stragglerTreeID, 12.0);
	rmSetObjectDefMaxDistance(stragglerTreeID, 20.0);
	rmAddObjectDefConstraint(stragglerTreeID, shortAvoidGold);
	rmAddObjectDefConstraint(stragglerTreeID, shortAvoidAll);

	// Medium objects
	// Medium gold
	int mediumGoldID=rmCreateObjectDef("medium gold");
	rmAddObjectDefItem(mediumGoldID, "Gold mine", 1, 0.0);
	rmSetObjectDefMinDistance(mediumGoldID, 40.0);
	rmSetObjectDefMaxDistance(mediumGoldID, 60.0);
	rmAddObjectDefConstraint(mediumGoldID, avoidGold);
	rmAddObjectDefConstraint(mediumGoldID, edgeConstraint);
	rmAddObjectDefConstraint(mediumGoldID, startingSettleConstraint);
	rmAddObjectDefConstraint(mediumGoldID, farAvoidOcean);
	rmAddObjectDefConstraint(mediumGoldID, farCenterLineConstraint);

	// Water hippos
	int waterHippoID=rmCreateObjectDef("water hippos");
	rmAddObjectDefItem(waterHippoID, "hippo", rmRandInt(3,4), 2.0);
	rmSetObjectDefMinDistance(waterHippoID, 15.0);
	rmSetObjectDefMaxDistance(waterHippoID, 80.0);
	rmAddObjectDefConstraint(waterHippoID, shortAvoidTower);
	rmAddObjectDefConstraint(waterHippoID, nearShore);
	rmAddObjectDefConstraint(waterHippoID, mediumCenterLineConstraint);
	rmAddObjectDefConstraint(waterHippoID, mediumEdgeConstraint);

	// Medium hunt
	int mediumHuntID=rmCreateObjectDef("medium hunt");
	rmAddObjectDefItem(mediumHuntID, "gazelle", rmRandInt(3,4), 3.0);
	rmSetObjectDefMinDistance(mediumHuntID, 55.0);
	rmSetObjectDefMaxDistance(mediumHuntID, 60.0);
	rmAddObjectDefConstraint(mediumHuntID, avoidTower);
	rmAddObjectDefConstraint(mediumHuntID, mediumAvoidHunt);
	rmAddObjectDefConstraint(mediumHuntID, shortAvoidAll);
	rmAddObjectDefConstraint(mediumHuntID, edgeConstraint);
	rmAddObjectDefConstraint(mediumHuntID, mediumAvoidOcean);
	rmAddObjectDefConstraint(mediumHuntID, farCenterLineConstraint);

	// Medium pigs
	int mediumPigsID=rmCreateObjectDef("medium pigs");
	rmAddObjectDefItem(mediumPigsID, "pig", 2, 2.0);
	rmSetObjectDefMinDistance(mediumPigsID, 55.0);
	rmSetObjectDefMaxDistance(mediumPigsID, 65.0);
	rmAddObjectDefConstraint(mediumPigsID, avoidHerdable);
	rmAddObjectDefConstraint(mediumPigsID, shortAvoidAll);
	rmAddObjectDefConstraint(mediumPigsID, edgeConstraint);
	rmAddObjectDefConstraint(mediumPigsID, shortAvoidOcean);
	rmAddObjectDefConstraint(mediumPigsID, mediumCenterLineConstraint);

	// Medium predator
	int predatorID=rmCreateObjectDef("predator");
	rmAddObjectDefItem(predatorID, "lion", 2, 4.0);
	rmSetObjectDefMinDistance(predatorID, 60.0);
	rmSetObjectDefMaxDistance(predatorID, 70.0);
	rmAddObjectDefConstraint(predatorID, shortAvoidAll);
	rmAddObjectDefConstraint(predatorID, edgeConstraint);
	rmAddObjectDefConstraint(predatorID, farAvoidOcean);
	rmAddObjectDefConstraint(predatorID, avoidPredator);
	rmAddObjectDefConstraint(predatorID, startingSettleConstraint);

	// Far objects
	// Far gold
	int farGoldID=rmCreateObjectDef("far gold");
	rmAddObjectDefItem(farGoldID, "Gold mine", 1, 0.0);
	rmSetObjectDefMinDistance(farGoldID, 60.0);
	rmSetObjectDefMaxDistance(farGoldID, 100.0);
	rmAddObjectDefConstraint(farGoldID, farAvoidGold);
	rmAddObjectDefConstraint(farGoldID, edgeConstraint);
	rmAddObjectDefConstraint(farGoldID, avoidSettlement);
	rmAddObjectDefConstraint(farGoldID, startingSettleConstraint);
	rmAddObjectDefConstraint(farGoldID, farAvoidOcean);
	rmAddObjectDefConstraint(farGoldID, shortCenterLineConstraint);

	// Random hunt
	int randomHuntID=rmCreateObjectDef("random hunt");
	rmAddObjectDefToClass(randomHuntID, classBonusHuntable);
	if(rmRandFloat(0,1)>0.66)
	{
		rmAddObjectDefItem(randomHuntID, "gazelle", rmRandInt(4,6), 4.0);
		rmAddObjectDefItem(randomHuntID, "giraffe", rmRandInt(3,4), 4.0);
	}
	else if(rmRandFloat(0,1)>0.33)
	{
		rmAddObjectDefItem(randomHuntID, "gazelle", rmRandInt(3,4), 4.0);
		rmAddObjectDefItem(randomHuntID, "giraffe", rmRandInt(2,3), 4.0);
	}
	else
		rmAddObjectDefItem(randomHuntID, "giraffe", 2, 4.0);
	rmSetObjectDefMinDistance(randomHuntID, 55.0);
	rmSetObjectDefMaxDistance(randomHuntID, 75.0);
	rmAddObjectDefConstraint(randomHuntID, avoidTower);
	rmAddObjectDefConstraint(randomHuntID, shortAvoidHunt);
	rmAddObjectDefConstraint(randomHuntID, shortAvoidAll);
	rmAddObjectDefConstraint(randomHuntID, edgeConstraint);
	rmAddObjectDefConstraint(randomHuntID, farAvoidOcean);
	rmAddObjectDefConstraint(randomHuntID, avoidBonusHuntable);
	rmAddObjectDefConstraint(randomHuntID, farCenterLineConstraint);

	// Far buffalos
	int buffaloID=rmCreateObjectDef("buffalos");
	rmAddObjectDefItem(buffaloID, "water buffalo", rmRandInt(3,4), 2.0);
	rmSetObjectDefMinDistance(buffaloID, 60.0);
	rmSetObjectDefMaxDistance(buffaloID, 135.0);
	rmAddObjectDefConstraint(buffaloID, mediumCenterLineConstraint);
	rmAddObjectDefConstraint(buffaloID, mediumAvoidHunt);
	rmAddObjectDefConstraint(buffaloID, avoidBonusHuntable);
	rmAddObjectDefConstraint(buffaloID, edgeConstraint);
	rmAddObjectDefConstraint(buffaloID, shortAvoidAll);
	rmAddObjectDefConstraint(buffaloID, foodZone);
	rmAddObjectDefToClass(buffaloID, classBonusHuntable);

	// Far pigs
	int farPigsID=rmCreateObjectDef("far pigs");
	rmAddObjectDefItem(farPigsID, "pig", 2, 2.0);
	rmSetObjectDefMinDistance(farPigsID, 65.0);
	rmSetObjectDefMaxDistance(farPigsID, 95.0);
	rmAddObjectDefConstraint(farPigsID, avoidHerdable);
	rmAddObjectDefConstraint(farPigsID, shortAvoidAll);
	rmAddObjectDefConstraint(farPigsID, edgeConstraint);
	rmAddObjectDefConstraint(farPigsID, mediumAvoidOcean);

	// Random Trees
	int randomTreeID=rmCreateObjectDef("random tree");
	rmAddObjectDefItem(randomTreeID, "palm", 1, 0.0);
	rmSetObjectDefMinDistance(randomTreeID, 0.0);
	rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(randomTreeID, rmCreateTypeDistanceConstraint("random tree", "all", 4.0));
	rmAddObjectDefConstraint(randomTreeID, shortAvoidAll);
	rmAddObjectDefConstraint(randomTreeID, rmCreateClassDistanceConstraint("short avoid starting settlement", rmClassID("starting settlement"), 15.0));

	// Relics
	int relicID=rmCreateObjectDef("relics");
	rmAddObjectDefItem(relicID, "relic", 1, 0.0);
	rmSetObjectDefMinDistance(relicID, 70.0);
	rmSetObjectDefMaxDistance(relicID, rmXFractionToMeters(0.3));
	rmAddObjectDefConstraint(relicID, mediumCenterLineConstraint);
	rmAddObjectDefConstraint(relicID, rmCreateTypeDistanceConstraint("relic vs relic", "relic", 50.0));
	rmAddObjectDefConstraint(relicID, shortAvoidAll);
	rmAddObjectDefConstraint(relicID, mediumAvoidOcean);

	// Birds
	int farhawkID=rmCreateObjectDef("far hawks");
	rmAddObjectDefItem(farhawkID, "vulture", 1, 0.0);
	rmSetObjectDefMinDistance(farhawkID, 0.0);
	rmSetObjectDefMaxDistance(farhawkID, rmXFractionToMeters(0.5));

	// Text
	rmSetStatusText("",0.8);

	// Generic stuff
	// Player placement
	if(cNumberTeams < 3)
	{
		if(skew==1)
		{
			if(cNumberNonGaiaPlayers == 2)
				rmPlacePlayersLine(0.18, 0.58, 0.82, 0.58);
			else if(cNumberNonGaiaPlayers < 5)
			{
				rmSetPlacementTeam(0);
				rmPlacePlayersLine(0.225, 0.17, 0.225, 0.65, 0.01);
				rmSetPlacementTeam(1);
				rmPlacePlayersLine(0.775, 0.17, 0.775, 0.65, 0.01);
			}
			else if(cNumberNonGaiaPlayers < 7)
			{
				rmSetPlacementTeam(0);
				rmPlacePlayersLine(0.24, 0.15, 0.19, 0.77, 0.01);
				rmSetPlacementTeam(1);
				rmPlacePlayersLine(0.76, 0.15, 0.81, 0.77, 0.01);
			}
			else
			{
				rmSetPlacementTeam(0);
				rmPlacePlayersLine(0.25, 0.12, 0.18, 0.87, 0.01);
				rmSetPlacementTeam(1);
				rmPlacePlayersLine(0.75, 0.12, 0.82, 0.87, 0.01);
			}
		}
		else
		{
			if(cNumberNonGaiaPlayers == 2)
				rmPlacePlayersLine(0.59, 0.18, 0.59, 0.82);
			else
			{
				rmSetPlacementTeam(0);
				rmPlacePlayersLine(0.17, 0.225, 0.65, 0.225, 0.01);
				rmSetPlacementTeam(1);
				rmPlacePlayersLine(0.17, 0.775, 0.65, 0.775, 0.01);
			}
		}
	}
	else
		rmPlacePlayersLine(0.08, 0.45, 0.92, 0.45);
		// Impossible to get a good placement with 3+ teams


	// Divide map
	int divisionID=rmCreateArea("division");
	rmSetAreaSize(divisionID, 1, 1);
	rmSetAreaLocation(divisionID, 0.5, 0.5);
	rmAddAreaToClass(divisionID, rmClassID("center line"));
	rmSetAreaWarnFailure(divisionID, false);
	rmAddAreaConstraint(divisionID, divisionConstraint);
	rmBuildArea(divisionID);

	// Define peninsula constants
	int size1=0;
	int size2=0;
	int size3=0;
	if(cNumberNonGaiaPlayers == 2)
	{
		size1=0.64*sqrt(cNumberNonGaiaPlayers*playerTiles/0.9);
		size2=0.15*0.64*sqrt(cNumberNonGaiaPlayers*playerTiles/0.9);
		size3=0.46*0.64*sqrt(cNumberNonGaiaPlayers*playerTiles/0.9);
	}
	else if(cNumberNonGaiaPlayers < 5)
	{
		size1=0.7*sqrt(cNumberNonGaiaPlayers*playerTiles/0.9);
		size2=0.15*0.7*sqrt(cNumberNonGaiaPlayers*playerTiles/0.9);
		size3=0.35*0.7*sqrt(cNumberNonGaiaPlayers*playerTiles/0.9);
	}
	else
	{
		size1=0.7*sqrt(cNumberNonGaiaPlayers*playerTiles/0.9);
		size2=0.15*0.7*sqrt(cNumberNonGaiaPlayers*playerTiles/0.9);
		size3=0.28*0.7*sqrt(cNumberNonGaiaPlayers*playerTiles/0.9);
	}

	float loc1x=0.0;
	float loc1z=0.0;
	float loc2x=0.0;
	float loc2z=0.0;
	float loc3x=0.0;
	float loc3z=0.0;
	float loc4x=0.0;
	float loc4z=0.0;
	float loc5x=0.0;
	float loc5z=0.0;
	float loc6x=0.0;
	float loc6z=0.0;

	if(skew==1)
	{
		loc1x=0.0;
		loc1z=0.4;
		loc2x=0.3;
		loc2z=0.65;
		loc3x=0.0;
		loc3z=0.0;
		loc4x=1.0;
		loc4z=0.4;
		loc5x=0.7;
		loc5z=0.65;
		loc6x=1.0;
		loc6z=0.0;
	}
	else
	{
		loc1x=0.4;
		loc1z=0.0;
		loc2x=0.65;
		loc2z=0.7;
		loc3x=0.0;
		loc3z=0.0;
		loc4x=0.4;
		loc4z=1.0;
		loc5x=0.65;
		loc5z=0.7;
		loc6x=0.0;
		loc6z=1.0;
	}

	// Create southwestern peninsula
	// Part 1
	int island1ID=rmCreateArea("peninsula 1");
	rmSetAreaSize(island1ID, rmXMetersToFraction(size1), rmZMetersToFraction(size1));
	rmSetAreaLocation(island1ID, loc1x, loc1z);
	rmAddAreaToClass(island1ID, classLand);
	rmSetAreaWarnFailure(island1ID, false);
	rmSetAreaMinBlobs(island1ID, 1);
	rmSetAreaMaxBlobs(island1ID, 5);
	rmSetAreaMinBlobDistance(island1ID, 5.0);
	rmSetAreaMaxBlobDistance(island1ID, 10.0);
	rmSetAreaCoherence(island1ID, 0.6);
	rmSetAreaBaseHeight(island1ID, 2.0);
	rmSetAreaSmoothDistance(island1ID, 10.0);
	rmSetAreaHeightBlend(island1ID, 2.0);
	rmSetAreaTerrainType(island1ID, "SandA");
	rmAddAreaConstraint(island1ID, shallowConstraintSW);

	// Part 2
	int island2ID=rmCreateArea("peninsula 2");
	rmSetAreaSize(island2ID,rmXMetersToFraction(size2), rmZMetersToFraction(size2));
	rmSetAreaLocation(island2ID, loc2x, loc2z);
	rmAddAreaToClass(island2ID, classLand);
	rmSetAreaWarnFailure(island2ID, false);
	rmSetAreaMinBlobs(island2ID, 1);
	rmSetAreaMaxBlobs(island2ID, 5);
	rmSetAreaMinBlobDistance(island2ID, 5.0);
	rmSetAreaMaxBlobDistance(island2ID, 10.0);
	rmSetAreaCoherence(island2ID, 0.5);
	rmSetAreaBaseHeight(island2ID, 2.0);
	rmSetAreaSmoothDistance(island2ID, 10.0);
	rmSetAreaHeightBlend(island2ID, 2.0);
	rmSetAreaTerrainType(island2ID, "SandA");
	rmAddAreaConstraint(island2ID, shallowConstraintSW);

	// Part 3
	int island3ID=rmCreateArea("peninsula 3");
	rmSetAreaSize(island3ID, rmXMetersToFraction(size3), rmZMetersToFraction(size3));
	rmSetAreaLocation(island3ID, loc3x, loc3z);
	rmAddAreaToClass(island3ID, classLand);
	rmSetAreaWarnFailure(island3ID, false);
	rmSetAreaMinBlobs(island3ID, 1);
	rmSetAreaMaxBlobs(island3ID, 5);
	rmSetAreaMinBlobDistance(island3ID, 5.0);
	rmSetAreaMaxBlobDistance(island3ID, 10.0);
	rmSetAreaCoherence(island3ID, 0.5);
	rmSetAreaBaseHeight(island3ID, 2.0);
	rmSetAreaSmoothDistance(island3ID, 10.0);
	rmSetAreaHeightBlend(island3ID, 2.0);
	rmSetAreaTerrainType(island3ID, "SandA");
	rmAddAreaConstraint(island3ID, shallowConstraintSW);

	// Text
	rmSetStatusText("",0.7);

	// Create northeastern peninsula
	// Part 1
	int island4ID=rmCreateArea("peninsula 4");
	rmSetAreaSize(island4ID, rmXMetersToFraction(size1), rmZMetersToFraction(size1));
	rmSetAreaLocation(island4ID, loc4x, loc4z);
	rmAddAreaToClass(island4ID, classLand);
	rmSetAreaWarnFailure(island4ID, false);
	rmSetAreaMinBlobs(island4ID, 1);
	rmSetAreaMaxBlobs(island4ID, 5);
	rmSetAreaMinBlobDistance(island4ID, 5.0);
	rmSetAreaMaxBlobDistance(island4ID, 10.0);
	rmSetAreaCoherence(island4ID, 0.5);
	rmSetAreaBaseHeight(island4ID, 2.0);
	rmSetAreaSmoothDistance(island4ID, 10.0);
	rmSetAreaHeightBlend(island4ID, 2.0);
	rmSetAreaTerrainType(island4ID, "SandA");
	rmAddAreaConstraint(island4ID, shallowConstraintNE);

	// Part 2
	int island5ID=rmCreateArea("peninsula 5");
	rmSetAreaSize(island5ID, rmXMetersToFraction(size2), rmZMetersToFraction(size2));
	rmSetAreaLocation(island5ID, loc5x, loc5z);
	rmAddAreaToClass(island5ID, classLand);
	rmSetAreaWarnFailure(island5ID, false);
	rmSetAreaMinBlobs(island5ID, 1);
	rmSetAreaMaxBlobs(island5ID, 5);
	rmSetAreaMinBlobDistance(island5ID, 5.0);
	rmSetAreaMaxBlobDistance(island5ID, 10.0);
	rmSetAreaCoherence(island5ID, 0.5);
	rmSetAreaBaseHeight(island5ID, 2.0);
	rmSetAreaSmoothDistance(island5ID, 10.0);
	rmSetAreaHeightBlend(island5ID, 2.0);
	rmSetAreaTerrainType(island5ID, "SandA");
	rmAddAreaConstraint(island5ID, shallowConstraintNE);

	// Part 3
	int island6ID=rmCreateArea("peninsula 6");
	rmSetAreaSize(island6ID, rmXMetersToFraction(size3), rmZMetersToFraction(size3));
	rmSetAreaLocation(island6ID, loc6x, loc6z);
	rmAddAreaToClass(island6ID, classLand);
	rmSetAreaWarnFailure(island6ID, false);
	rmSetAreaMinBlobs(island6ID, 1);
	rmSetAreaMaxBlobs(island6ID, 5);
	rmSetAreaMinBlobDistance(island6ID, 5.0);
	rmSetAreaMaxBlobDistance(island6ID, 10.0);
	rmSetAreaCoherence(island6ID, 0.5);
	rmSetAreaBaseHeight(island6ID, 2.0);
	rmSetAreaSmoothDistance(island6ID, 10.0);
	rmSetAreaHeightBlend(island6ID, 2.0);
	rmSetAreaTerrainType(island6ID, "SandA");
	rmAddAreaConstraint(island6ID, shallowConstraintNE);

	rmBuildAllAreas();

	// Text
	rmSetStatusText("",0.6);

	// Oceans
	float ocean1x=0;
	float ocean1z=0;
	float ocean2x=0;
	float ocean2z=0;

	if(skew==1)
	{
		ocean1x=0.5;
		ocean1z=1.0;
		ocean2x=0.5;
		ocean2z=0.0;
	}
	else
	{
		ocean1x=1.0;
		ocean1z=0.5;
		ocean2x=0.0;
		ocean2z=0.5;
	}

	// Big ocean
	int ocean1ID=rmCreateArea("mediterranean");
	rmSetAreaSize(ocean1ID, 0.25, 0.25);
	rmSetAreaLocation(ocean1ID, ocean1x, ocean1z);
	rmAddAreaToClass(ocean1ID, classOcean);
	rmSetAreaWarnFailure(ocean1ID, false);
	rmSetAreaCoherence(ocean1ID, 1.0);
	rmSetAreaBaseHeight(ocean1ID, -3.0);
	rmSetAreaSmoothDistance(ocean1ID, 20.0);
	rmSetAreaHeightBlend(ocean1ID, 2.0);
	rmSetAreaWaterType(ocean1ID, "Egyptian Nile");
	rmAddAreaConstraint(ocean1ID, oceanAvoidsLand);
	rmAddAreaConstraint(ocean1ID, oceanConstraint);

	// Small ocean
	if(cNumberNonGaiaPlayers > 3)
	{
		int ocean2ID=rmCreateArea("nile");
		rmSetAreaSize(ocean2ID, 1.0, 1.0);
		rmSetAreaLocation(ocean2ID, ocean2x, ocean2z);
		rmAddAreaToClass(ocean2ID, classOcean);
		rmSetAreaWarnFailure(ocean2ID, false);
		rmSetAreaCoherence(ocean2ID, 1.0);
		rmSetAreaBaseHeight(ocean2ID, 2.0);
		rmSetAreaSmoothDistance(ocean2ID, 10);
		rmSetAreaHeightBlend(ocean2ID, 2.0);
		rmSetAreaWaterType(ocean2ID, "Egyptian Nile");
		rmAddAreaConstraint(ocean2ID, oceanAvoidsLand);
		rmAddAreaConstraint(ocean2ID, smallOceanConstraint);
	}

	rmBuildAllAreas();

	// Set up player areas.
	float playerFraction=rmAreaTilesToFraction(3500);
	for(i=1; <cNumberPlayers)
	{
		int id=rmCreateArea("Player"+i);
		rmSetPlayerArea(i, id);
		rmSetAreaSize(id, 0.05, 0.05);
		rmAddAreaToClass(id, classPlayer);
		rmSetAreaWarnFailure(id, false);
		rmSetAreaMinBlobs(id, 1);
		rmSetAreaMaxBlobs(id, 5);
		rmSetAreaMinBlobDistance(id, 5.0);
		rmSetAreaMaxBlobDistance(id, 10.0);
		rmSetAreaCoherence(id, 0.6);
		rmSetAreaBaseHeight(id, 1.0);
		rmSetAreaSmoothDistance(id, 10);
		rmSetAreaHeightBlend(id, 2);
		rmSetAreaLocPlayer(id, i);
		rmAddAreaConstraint(id, shortAvoidOcean);
	}

	rmBuildAllAreas();

	// Text
	rmSetStatusText("",0.5);

	// Settlement 1
	rmPlaceObjectDefPerPlayer(startingSettlementID, true);
	if(cNumberNonGaiaPlayers < 3)
		id=rmAddFairLoc("Settlement", false, false, rmRandFloat(55,65), rmRandFloat(70, 80), 30, 16);
	else
	{
		if(rmRandFloat(0,1)<0.5)
			id=rmAddFairLoc("Settlement", false, true, 60, 100, 40, 16);
		else
			id=rmAddFairLoc("Settlement", false, false, 60, 100, 40, 16);
	}
	rmAddFairLocConstraint(id, startingSettleConstraint);
	rmAddFairLocConstraint(id, settlementAvoidsOcean);

	// Settlement 2
	if(cNumberNonGaiaPlayers < 3)
	{
		if(rmRandFloat(0,1)<0.85)
			id=rmAddFairLoc("Settlement", true, true,  60, 110, 50, 80);
		else
			id=rmAddFairLoc("Settlement", false, false,  60, 130, 40, 30);
	}
	else
		id=rmAddFairLoc("Settlement", true, true,  60, 110, 60, 90);
	rmAddFairLocConstraint(id, startingSettleConstraint);
	rmAddFairLocConstraint(id, mediumCenterLineConstraint);
	rmAddFairLocConstraint(id, settlementAvoidsOcean);
	rmAddFairLocConstraint(id, settlementVsSettlement);

	if(rmPlaceFairLocs())
	{
		id=rmCreateObjectDef("far settlement");
		rmAddObjectDefItem(id, "Settlement", 1, 0.0);
		for(i=1; <cNumberPlayers)
		{
			for(j=0; <rmGetNumberFairLocs(i))
			{
				int settleArea = rmCreateArea("settlement area"+i +j, rmAreaID("Player"+i));
				rmSetAreaLocation(settleArea, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j));
				rmBuildArea(settleArea);
				rmPlaceObjectDefAtAreaLoc(id, i, settleArea);
			}
		}
	}

	// Text
	rmSetStatusText("",0.4);

	// Texture embellishment 1
	for(i=1; <cNumberPlayers*6)
	{
		int id1=rmCreateArea("beautification 1 "+i);
		rmSetAreaSize(id1, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(id1, "EgyptianRoadA");
		rmAddAreaConstraint(id1, mediumAvoidOcean);
		rmAddAreaConstraint(id1, shallowConstraintSW);
		rmSetAreaMinBlobs(id1, 1);
		rmSetAreaMaxBlobs(id1, 5);
		rmSetAreaWarnFailure(id1, false);
		rmSetAreaMinBlobDistance(id1, 16.0);
		rmSetAreaMaxBlobDistance(id1, 40.0);
		rmSetAreaCoherence(id1, 0.6);
		rmBuildArea(id1);
	}

	 for(i=1; <cNumberPlayers*6)
	{
		int id2=rmCreateArea("more beautification 2 "+i);
		rmSetAreaSize(id2, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(id2, "SandC");
		rmAddAreaConstraint(id2, mediumAvoidOcean);
		rmAddAreaConstraint(id2, shallowConstraintSW);
		rmSetAreaMinBlobs(id2, 1);
		rmSetAreaMaxBlobs(id2, 5);
		rmSetAreaWarnFailure(id2, false);
		rmSetAreaMinBlobDistance(id2, 16.0);
		rmSetAreaMaxBlobDistance(id2, 40.0);
		rmSetAreaCoherence(id2, 0.2);
		rmBuildArea(id2);
	}

	for(i=1; <cNumberPlayers*6)
	{
		int id3=rmCreateArea("even more beautification 3 "+i);
		rmSetAreaSize(id3, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(id3, "SandD");
		rmAddAreaConstraint(id3, mediumAvoidOcean);
		rmAddAreaConstraint(id3, shallowConstraintSW);
		rmSetAreaMinBlobs(id3, 1);
		rmSetAreaMaxBlobs(id3, 5);
		rmSetAreaWarnFailure(id3, false);
		rmSetAreaMinBlobDistance(id3, 16.0);
		rmSetAreaMaxBlobDistance(id3, 40.0);
		rmSetAreaCoherence(id3, 0.2);
		rmBuildArea(id3);
	}

	// Texture embellishment 2
	for(i=1; <cNumberPlayers*6)
	{
		id1=rmCreateArea("beautification 4 "+i);
		rmSetAreaSize(id1, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(id1, "EgyptianRoadA");
		rmAddAreaConstraint(id1, mediumAvoidOcean);
		rmAddAreaConstraint(id1, shallowConstraintNE);
		rmSetAreaMinBlobs(id1, 1);
		rmSetAreaMaxBlobs(id1, 5);
		rmSetAreaWarnFailure(id1, false);
		rmSetAreaMinBlobDistance(id1, 16.0);
		rmSetAreaMaxBlobDistance(id1, 40.0);
		rmSetAreaCoherence(id1, 0.6);
		rmBuildArea(id1);
	}

	 for(i=1; <cNumberPlayers*6)
	{
		id2=rmCreateArea("more beautification 5 "+i);
		rmSetAreaSize(id2, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(id2, "SandC");
		rmAddAreaConstraint(id2, mediumAvoidOcean);
		rmAddAreaConstraint(id2, shallowConstraintNE);
		rmSetAreaMinBlobs(id2, 1);
		rmSetAreaMaxBlobs(id2, 5);
		rmSetAreaWarnFailure(id2, false);
		rmSetAreaMinBlobDistance(id2, 16.0);
		rmSetAreaMaxBlobDistance(id2, 40.0);
		rmSetAreaCoherence(id2, 0.2);
		rmBuildArea(id2);
	}

	for(i=1; <cNumberPlayers*6)
	{
		id3=rmCreateArea("even more beautification 6 "+i);
		rmSetAreaSize(id3, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(id3, "SandD");
		rmAddAreaConstraint(id3, mediumAvoidOcean);
		rmAddAreaConstraint(id3, shallowConstraintNE);
		rmSetAreaMinBlobs(id3, 1);
		rmSetAreaMaxBlobs(id3, 5);
		rmSetAreaWarnFailure(id3, false);
		rmSetAreaMinBlobDistance(id3, 16.0);
		rmSetAreaMaxBlobDistance(id3, 40.0);
		rmSetAreaCoherence(id3, 0.2);
		rmBuildArea(id3);
	}

	// Text
	rmSetStatusText("",0.3);

	// Place close objects
	// Towers
	rmPlaceObjectDefPerPlayer(startingTowerID, true, 4);

	// Gold
	rmPlaceObjectDefPerPlayer(startingGoldID, false);

	// Food
	rmPlaceObjectDefPerPlayer(startingFoodID, false);

	// Pigs
	rmPlaceObjectDefPerPlayer(startingPigsID, true);

	// Straggler trees
	rmPlaceObjectDefPerPlayer(stragglerTreeID, false, rmRandInt(4, 5));

	// Medium
	// Gold
	rmPlaceObjectDefPerPlayer(mediumGoldID, false);

	// Water hippos
	rmPlaceObjectDefPerPlayer(waterHippoID, false);

	// Medium hunt
	rmPlaceObjectDefPerPlayer(mediumHuntID, false);

	// Medium pigs
	rmPlaceObjectDefPerPlayer(mediumPigsID, false);

	// Predator
	rmPlaceObjectDefPerPlayer(predatorID, false);

	// Far
	// Gold
	rmPlaceObjectDefPerPlayer(farGoldID, false, 2);

	// Random hunt
	if(rmRandFloat(0,1)>0.2)
		rmPlaceObjectDefPerPlayer(randomHuntID, false);

	// Buffalos
	if(cNumberNonGaiaPlayers == 2)
		rmPlaceObjectDefPerPlayer(buffaloID, false, rmRandInt(1,2));

	// Far Pigs
	rmPlaceObjectDefPerPlayer(farPigsID, false, 2);

	// Forest
	int failCount=0;
	int numTries=15*cNumberNonGaiaPlayers;
	for(i=0; <numTries)
	{
		int forestID=rmCreateArea("forest"+i);
		rmSetAreaSize(forestID, rmAreaTilesToFraction(50), rmAreaTilesToFraction(80));
		rmSetAreaWarnFailure(forestID, false);
		rmSetAreaForestType(forestID, "palm forest");
		rmAddAreaConstraint(forestID, forestSettleConstraint);
		rmAddAreaConstraint(forestID, avoidSettlement);
		rmAddAreaConstraint(forestID, shortAvoidAll);
		rmAddAreaConstraint(forestID, shortAvoidGold);
		rmAddAreaConstraint(forestID, forestConstraint);
		rmAddAreaConstraint(forestID, mediumAvoidOcean);
		rmAddAreaToClass(forestID, classForest);
		rmSetAreaCoherence(forestID, 0.6);
		rmSetAreaBaseHeight(forestID, 1.0);
		rmSetAreaSmoothDistance(forestID, 2);
		rmSetAreaHeightBlend(forestID, 2);
		rmSetAreaMinBlobs(forestID, 3);
		rmSetAreaMaxBlobs(forestID, 7);
		rmSetAreaMinBlobDistance(forestID, 16.0);
		rmSetAreaMaxBlobDistance(forestID, 40.0);
		rmSetAreaCoherence(forestID, 0.0);

		if(rmBuildArea(forestID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
	}

	// Text
	rmSetStatusText("",0.2);

	// Relics
	rmPlaceObjectDefPerPlayer(relicID, false);

	// Random trees
	rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 20*cNumberNonGaiaPlayers);

	// Hawks
	rmPlaceObjectDefPerPlayer(farhawkID, false, 2);

	// NW fish
	int northernFishID=rmCreateObjectDef("northern fish");
	rmAddObjectDefItem(northernFishID, "fish - salmon", 3, 8.0);
	rmSetObjectDefMinDistance(northernFishID, 0.0);
	rmSetObjectDefMaxDistance(northernFishID, 90.0);
	rmAddObjectDefConstraint(northernFishID, longFishVsFishID);
	rmAddObjectDefConstraint(northernFishID, fishNearShore);
	rmAddObjectDefConstraint(northernFishID, fishLand);
	rmAddObjectDefConstraint(northernFishID, oceanConstraint);
	rmAddObjectDefConstraint(northernFishID, tinyCenterLineConstraint);
	rmAddObjectDefConstraint(northernFishID, longEdgeConstraint);
	rmPlaceObjectDefPerPlayer(northernFishID, false, 4);

	// NW extra fish
		int extraFishID=rmCreateObjectDef("extra fish");
		rmAddObjectDefItem(extraFishID, "fish - salmon", 3, 8.0);
		rmSetObjectDefMinDistance(extraFishID, 0.0);
		rmSetObjectDefMaxDistance(extraFishID, rmXFractionToMeters(1.0));
		rmAddObjectDefConstraint(extraFishID, extraFishVsFishID);
		rmAddObjectDefConstraint(extraFishID, fishLand);
		rmAddObjectDefConstraint(extraFishID, oceanConstraint);
		rmAddObjectDefConstraint(extraFishID, edgeConstraint);
		if(cNumberNonGaiaPlayers > 5)
			rmPlaceObjectDefAtLoc(extraFishID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
		else if(cNumberNonGaiaPlayers > 3)
			rmPlaceObjectDefAtLoc(extraFishID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
		else
			rmPlaceObjectDefAtLoc(extraFishID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);


	// SE fish
	if(cNumberNonGaiaPlayers > 3)
	{
		int southernFishID=rmCreateObjectDef("southern fish");
		rmAddObjectDefItem(southernFishID, "fish - salmon", 3, 8.0);
		rmSetObjectDefMinDistance(southernFishID, 0.0);
		rmSetObjectDefMaxDistance(southernFishID, 125.0);
		rmAddObjectDefConstraint(southernFishID, shortFishVsFishID);
		rmAddObjectDefConstraint(southernFishID, fishLand);
		rmAddObjectDefConstraint(southernFishID, smallOceanConstraint);
		rmPlaceObjectDefPerPlayer(southernFishID, false, cNumberNonGaiaPlayers-2);
	}

	// Text
	rmSetStatusText("",0.1);

	// Embellishment
	int rockID=rmCreateObjectDef("rock small");
	rmAddObjectDefItem(rockID, "rock sandstone small", 3, 2.0);
	rmAddObjectDefItem(rockID, "rock limestone sprite", 4, 3.0);
	rmSetObjectDefMinDistance(rockID, 0.0);
	rmSetObjectDefMaxDistance(rockID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(rockID, shortAvoidAll);
	rmAddObjectDefConstraint(rockID, shortAvoidOcean);
	rmPlaceObjectDefAtLoc(rockID, 0, 0.5, 0.5, 5*cNumberNonGaiaPlayers);

	int rockID2=rmCreateObjectDef("rock sprite");
	rmAddObjectDefItem(rockID2, "rock sandstone sprite", 1, 0.0);
	rmSetObjectDefMinDistance(rockID2, 0.0);
	rmSetObjectDefMaxDistance(rockID2, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(rockID2, shortAvoidAll);
	rmAddObjectDefConstraint(rockID2, shortAvoidOcean);
	rmPlaceObjectDefAtLoc(rockID2, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);

	int papyrusID=rmCreateObjectDef("lone papyrus");
	rmAddObjectDefItem(papyrusID, "papyrus", 3, 2.0);
	rmSetObjectDefMinDistance(papyrusID, 0.0);
	rmSetObjectDefMaxDistance(papyrusID, 600);
	rmAddObjectDefConstraint(papyrusID, shortAvoidAll);
	rmAddObjectDefConstraint(papyrusID, nearShore);
	rmPlaceObjectDefAtLoc(papyrusID, 0, 0.5, 0.5, 6*cNumberNonGaiaPlayers);

	int papyrus2ID=rmCreateObjectDef("grouped papyrus");
	rmAddObjectDefItem(papyrus2ID, "papyrus", 5, 7.0);
	rmSetObjectDefMinDistance(papyrus2ID, 0.0);
	rmSetObjectDefMaxDistance(papyrus2ID, 600);
	rmAddObjectDefConstraint(papyrus2ID, shortAvoidAll);
	rmAddObjectDefConstraint(papyrus2ID, rmCreateTerrainMaxDistanceConstraint("papyrus near shore", "land", true, 4.0));
	rmPlaceObjectDefAtLoc(papyrus2ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);

	int lilyID=rmCreateObjectDef("pads");
	rmAddObjectDefItem(lilyID, "water lilly", 4, 2.0);
	rmSetObjectDefMinDistance(lilyID, 0.0);
	rmSetObjectDefMaxDistance(lilyID, 600);
	rmAddObjectDefConstraint(lilyID, shortAvoidAll);
	rmPlaceObjectDefAtLoc(lilyID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);

	int lily2ID=rmCreateObjectDef("more pads");
	rmAddObjectDefItem(lily2ID, "water lilly", 1, 0.0);
	rmSetObjectDefMinDistance(lily2ID, 0.0);
	rmSetObjectDefMaxDistance(lily2ID, 600);
	rmAddObjectDefConstraint(lily2ID, shortAvoidAll);
	rmPlaceObjectDefAtLoc(lily2ID, 0, 0.5, 0.5, 8*cNumberNonGaiaPlayers);

	int bushID=rmCreateObjectDef("big bush patch");
	rmAddObjectDefItem(bushID, "bush", 4, 3.0);
	rmSetObjectDefMinDistance(bushID, 0.0);
	rmSetObjectDefMaxDistance(bushID, 600);
	rmAddObjectDefConstraint(bushID, shortAvoidAll);
	rmPlaceObjectDefAtLoc(bushID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);

	int bush2ID=rmCreateObjectDef("small bush patch");
	rmAddObjectDefItem(bush2ID, "bush", 3, 2.0);
	rmAddObjectDefItem(bush2ID, "rock sandstone sprite", 1, 2.0);
	rmSetObjectDefMinDistance(bush2ID, 0.0);
	rmSetObjectDefMaxDistance(bush2ID, 600);
	rmAddObjectDefConstraint(bush2ID, shortAvoidAll);
	rmPlaceObjectDefAtLoc(bush2ID, 0, 0.5, 0.5, 8*cNumberNonGaiaPlayers);

	int riverBushID=rmCreateObjectDef("bushs by river");
	rmAddObjectDefItem(riverBushID, "bush", 3, 3.0);
	rmAddObjectDefItem(riverBushID, "grass", 7, 8.0);
	rmSetObjectDefMinDistance(riverBushID, 0.0);
	rmSetObjectDefMaxDistance(riverBushID, 600);
	rmAddObjectDefConstraint(riverBushID, shortAvoidAll);
	rmAddObjectDefConstraint(riverBushID, nearShore);
	rmPlaceObjectDefAtLoc(riverBushID, 0, 0.5, 0.5, 5*cNumberNonGaiaPlayers);

	// Text
	rmSetStatusText("",0.01);

	// Triggers
	// Disable bolt for a minute
	int zeusPlayer=0;
	for(i=1; <cNumberPlayers)
	{
		if(rmGetPlayerCiv(i) == cCivZeus)
		{
			zeusPlayer=1;
			rmCreateTrigger("disable bolt"+i);
			rmSetTriggerActive(true);
			rmSetTriggerPriority(5);
			rmAddTriggerCondition("Timer");
			rmSetTriggerConditionParamInt("Param1", 1);
			rmAddTriggerEffect("Player Kill All God Powers");
			rmSetTriggerEffectParamInt("Player", i);

			rmCreateTrigger("grant bolt"+i);
			rmSetTriggerActive(true);
			rmSetTriggerPriority(5);
			rmAddTriggerCondition("Timer");
			rmSetTriggerConditionParamInt("Param1", 60);
			rmAddTriggerEffect("Grant God Power");
			rmSetTriggerEffectParamInt("PlayerID", i);
			rmSetTriggerEffectParam("PowerName", "bolt");
			rmSetTriggerEffectParamInt("Count", 1);
		}
	}

	// Notify players 1
	if(cNumberTeams > 2)
	{
		rmCreateTrigger("team notification");
		rmSetTriggerPriority(5);
		rmSetTriggerActive(true);
		rmAddTriggerCondition("Timer");
		rmAddTriggerEffect("Send Spoofed Chat");
		rmSetTriggerEffectParam("Message", "RebelsRising: This map has not been optimized for 4v4+ and FFA. No balance guaranteed - play at your own risk!", false);
		rmSetTriggerEffectParam("PlayerID", ""+0);
	}
	else if(cNumberNonGaiaPlayers > 6)
	{
		rmCreateTrigger("player notification");
		rmSetTriggerPriority(5);
		rmSetTriggerActive(true);
		rmAddTriggerCondition("Timer");
		rmAddTriggerEffect("Send Spoofed Chat");
		rmSetTriggerEffectParam("Message", "RebelsRising: This map has not been optimized for 4v4+ and FFA. No balance guaranteed - play at your own risk!", false);
		rmSetTriggerEffectParam("PlayerID", ""+0);
	}

	// Notify players 2
	if(zeusPlayer==1)
	{
		rmCreateTrigger("bolt notification");
		rmSetTriggerPriority(5);
		rmSetTriggerActive(true);
		rmAddTriggerCondition("Timer");
		rmAddTriggerEffect("Send Spoofed Chat");
		rmSetTriggerEffectParam("Message", "RebelsRising: Zeus' Bolt power has been disabled for the first minute.", false);
		rmSetTriggerEffectParam("PlayerID", ""+0);
	}
}

// Painted Desert
void painteddesert(void)
{
	// Text
	rmSetStatusText("",1.0);

	// Set size
	int playerTiles=9600;
	int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	int skew=rmRandInt(1,2);
	if(cNumberNonGaiaPlayers > 4)
	{
		if(skew==1)
		{
			rmSetMapSize(size, size*1.1);
			rmEchoInfo("Map size="+size+"m x "+size*1.1+"m");
		}
		else
		{
			rmSetMapSize(size*1.1, size);
			rmEchoInfo("Map size="+size*1.1+"m x "+size+"m");
		}
	}
	else
	{
		rmSetMapSize(size, size);
		rmEchoInfo("Map size="+size+"m x "+size+"m");
	}

	// Init map
	rmSetSeaLevel(-1.0);
	rmTerrainInitialize("SandC", 0.0);
	rmSetLightingSet("Alfheim");

	// Define clssses
	int classCliff=rmDefineClass("cliff");
	int classPlayer=rmDefineClass("player");
	int classForest=rmDefineClass("forest");
	rmDefineClass("starting settlement");
	rmDefineClass("center line");

	// Constraints
	// General
	int divisionConstraint=0;
	if(skew==1)
		divisionConstraint=rmCreateBoxConstraint("divide map", 0.48, 0.0, 0.52, 1.0, 0.01);
	else
		divisionConstraint=rmCreateBoxConstraint("divide map", 0.0, 0.48, 1.0, 0.52, 0.01);
	int edgeConstraint=rmCreateBoxConstraint("edge constraint", rmXTilesToFraction(8), rmZTilesToFraction(8), 1.0-rmXTilesToFraction(8), 1.0-rmZTilesToFraction(8));
	int shortAvoidAll=rmCreateTypeDistanceConstraint("short avoid all", "all", 3.0);
	int shortCenterLineConstraint=rmCreateClassDistanceConstraint("stay a bit away from center line", rmClassID("center line"), 12.5);
	int mediumCenterLineConstraint=rmCreateClassDistanceConstraint("stay away from center line", rmClassID("center line"), 20.0);
	int farCenterLineConstraint=rmCreateClassDistanceConstraint("stay far away from center line", rmClassID("center line"), 80.0);
	int avoidPlayer=rmCreateClassDistanceConstraint("avoid player areas", classPlayer, 10.0);

	// Terrain
	int waterNWConstraint=0;
	int waterSEConstraint=0;
	if(skew==1)
	{
		waterNWConstraint=rmCreateBoxConstraint("water NW limit", 0.0, 0.9, 1.0, 1.0, 0.01);
		waterSEConstraint=rmCreateBoxConstraint("water SE limit", 0.0, 0.0, 1.0, 0.1, 0.01);
	}
	else
	{
		waterNWConstraint=rmCreateBoxConstraint("water NW limit", 0.9, 0.0, 1.0, 1.0, 0.01);
		waterSEConstraint=rmCreateBoxConstraint("water SE limit", 0.0, 0.0, 0.1, 1.0, 0.01);
	}
	int farCliffConstraint=rmCreateClassDistanceConstraint("long avoid cliff", rmClassID("cliff"), 30.0);
	int mediumCliffConstraint=rmCreateClassDistanceConstraint("medium avoid cliff", rmClassID("cliff"), 10.0);
	int shortCliffConstraint=rmCreateClassDistanceConstraint("short avoid cliff", rmClassID("cliff"), 5.0);
	int cliffPlayerConstraint=rmCreateClassDistanceConstraint("cliffs stay away from players", classPlayer, 5.0);
	int cliffEdgeConstraint=rmCreateBoxConstraint("cliffs avoid edge of the map", rmXTilesToFraction(32), rmZTilesToFraction(32), 1.0-rmXTilesToFraction(32), 1.0-rmZTilesToFraction(32));
	int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "land", false, 4.0);

	// Settlements
	int startingSettleConstraint=rmCreateClassDistanceConstraint("avoid starting settlement", rmClassID("starting settlement"), 30.0);
	int shortStartingSettleConstraint=rmCreateClassDistanceConstraint("short avoid starting settlement", rmClassID("starting settlement"), 20.0);
	int settlementVsSettlement=rmCreateTypeDistanceConstraint("TCs avoid TCs", "AbstractSettlement", 50.0);
	int avoidSettlement=rmCreateTypeDistanceConstraint("avoid TCs", "AbstractSettlement", 15.0);

	// Gold
	int shortAvoidGold=rmCreateTypeDistanceConstraint("short avoid gold", "gold", 8.0);
	int avoidGold=rmCreateTypeDistanceConstraint("avoid gold", "gold", 30.0);
	int farAvoidGold=rmCreateTypeDistanceConstraint("far avoid gold", "gold", 40.0);

	// Food
	int avoidHunt=rmCreateTypeDistanceConstraint("avoid huntable", "huntable", 40.0);
	int shortAvoidFood=rmCreateTypeDistanceConstraint("short avoid huntable", "food", 8.0);
	int avoidHerdable=rmCreateTypeDistanceConstraint("avoid herdable", "herdable", 40.0);
	int avoidPredator=rmCreateTypeDistanceConstraint("avoid predator", "animalPredator", 40.0);

	// Wood
	int shortForestConstraint=rmCreateClassDistanceConstraint("short avoid forest", rmClassID("forest"), 5.0);
	int mediumForestConstraint=rmCreateClassDistanceConstraint("medium avoid forest", rmClassID("forest"), 12.5);
	int farForestConstraint=rmCreateClassDistanceConstraint("far avoid forest", rmClassID("forest"), 20.0);
	int forestSettleConstraint=rmCreateClassDistanceConstraint("forest settle", rmClassID("starting settlement"), 20.0);

	// Buildings
	int avoidBuildings=rmCreateTypeDistanceConstraint("avoid buildings", "Building", 15.0);
	int avoidTower=rmCreateTypeDistanceConstraint("avoid tower", "tower", 25.0);
	int shortAvoidTower=rmCreateTypeDistanceConstraint("short avoid tower", "tower", 10.0);

	// Text
	rmSetStatusText("",0.9);

	// Define objects
	// Starting settlement
	int startingSettlementID=rmCreateObjectDef("Starting settlement");
	rmAddObjectDefItem(startingSettlementID, "Settlement Level 1", 1, 0.0);
	rmAddObjectDefToClass(startingSettlementID, rmClassID("starting settlement"));
	rmSetObjectDefMinDistance(startingSettlementID, 0.0);
	rmSetObjectDefMaxDistance(startingSettlementID, 0.0);

	// Towers
	int startingTowerID=rmCreateObjectDef("starting tower");
	rmAddObjectDefItem(startingTowerID, "tower", 1, 0.0);
	rmSetObjectDefMinDistance(startingTowerID, 22.0);
	rmSetObjectDefMaxDistance(startingTowerID, 24.0);
	rmAddObjectDefConstraint(startingTowerID, avoidTower);

	// Gold
	int startingGoldID=rmCreateObjectDef("starting gold");
	rmAddObjectDefItem(startingGoldID, "Gold mine small", 1, 0.0);
	rmSetObjectDefMinDistance(startingGoldID, 20.0);
	rmSetObjectDefMaxDistance(startingGoldID, 25.0);
	rmAddObjectDefConstraint(startingGoldID, shortAvoidAll);
	rmAddObjectDefConstraint(startingGoldID, shortAvoidTower);

	// Hunt
	int startingRhinoID=rmCreateObjectDef("starting rhinos");
	rmAddObjectDefItem(startingRhinoID, "Rhinocerous", 2, 3.0);
	rmSetObjectDefMinDistance(startingRhinoID, 27.5);
	rmSetObjectDefMaxDistance(startingRhinoID, 27.5);
	rmAddObjectDefConstraint(startingRhinoID, shortAvoidAll);

	// Berries
	int startingFoodID=rmCreateObjectDef("close food");
	rmAddObjectDefItem(startingFoodID, "berry bush", rmRandInt(5,7), 4.0);
	rmSetObjectDefMinDistance(startingFoodID, 20.0);
	rmSetObjectDefMaxDistance(startingFoodID, 25.0);
	rmAddObjectDefConstraint(startingFoodID, shortAvoidAll);
	rmAddObjectDefConstraint(startingFoodID, shortAvoidGold);

	// Pigs
	int startingPigsID=rmCreateObjectDef("close pigs");
	rmAddObjectDefItem(startingPigsID, "pig", 2, 2.0);
	rmSetObjectDefMinDistance(startingPigsID, 25.0);
	rmSetObjectDefMaxDistance(startingPigsID, 30.0);
	rmAddObjectDefConstraint(startingPigsID, shortAvoidAll);

	// Straggler trees
	int stragglerTreeID=rmCreateObjectDef("straggler tree");
	rmAddObjectDefItem(stragglerTreeID, "palm", 1, 0.0);
	rmSetObjectDefMinDistance(stragglerTreeID, 12.0);
	rmSetObjectDefMaxDistance(stragglerTreeID, 20.0);
	rmAddObjectDefConstraint(stragglerTreeID, shortAvoidGold);
	rmAddObjectDefConstraint(stragglerTreeID, shortAvoidAll);

	// Medium objects
	// Medium gold
	int mediumGoldID=rmCreateObjectDef("medium gold");
	rmAddObjectDefItem(mediumGoldID, "Gold mine", 1, 0.0);
	rmSetObjectDefMinDistance(mediumGoldID, 50.0);
	rmSetObjectDefMaxDistance(mediumGoldID, 65.0);
	rmAddObjectDefConstraint(mediumGoldID, edgeConstraint);
	rmAddObjectDefConstraint(mediumGoldID, mediumForestConstraint);
	rmAddObjectDefConstraint(mediumGoldID, farCenterLineConstraint);
	rmAddObjectDefConstraint(mediumGoldID, avoidSettlement);
	rmAddObjectDefConstraint(mediumGoldID, mediumCliffConstraint);
	rmAddObjectDefConstraint(mediumGoldID, avoidGold);
	rmAddObjectDefConstraint(mediumGoldID, startingSettleConstraint);

	// Gazelles
	int gazelleID=rmCreateObjectDef("gazelles");
	rmAddObjectDefItem(gazelleID, "gazelle", rmRandInt(6,7), 3.0);
	rmSetObjectDefMinDistance(gazelleID, 70.0);
	rmSetObjectDefMaxDistance(gazelleID, 80.0);
	rmAddObjectDefConstraint(gazelleID, shortAvoidAll);
	rmAddObjectDefConstraint(gazelleID, edgeConstraint);
	rmAddObjectDefConstraint(gazelleID, farCenterLineConstraint);
	rmAddObjectDefConstraint(gazelleID, avoidHunt);
	rmAddObjectDefConstraint(gazelleID, shortCliffConstraint);
	rmAddObjectDefConstraint(gazelleID, startingSettleConstraint);

	// Giraffes
	int giraffeID=rmCreateObjectDef("giraffes");
	rmAddObjectDefItem(giraffeID, "giraffe", rmRandInt(3,5), 3.0);
	rmSetObjectDefMinDistance(giraffeID, 60.0);
	rmSetObjectDefMaxDistance(giraffeID, 70.0);
	rmAddObjectDefConstraint(giraffeID, shortAvoidAll);
	rmAddObjectDefConstraint(giraffeID, edgeConstraint);
	if(cNumberNonGaiaPlayers == 2)
		rmAddObjectDefConstraint(giraffeID, shortCenterLineConstraint);
	else
		rmAddObjectDefConstraint(giraffeID, farCenterLineConstraint);
	rmAddObjectDefConstraint(giraffeID, avoidHunt);
	rmAddObjectDefConstraint(giraffeID, mediumCliffConstraint);

	// Rhinos
	int rhinoID=rmCreateObjectDef("rhinos");
	rmAddObjectDefItem(rhinoID, "rhinocerous", rmRandInt(2,3), 3.0);
	rmSetObjectDefMinDistance(rhinoID, 60.0);
	rmSetObjectDefMaxDistance(rhinoID, 70.0);
	rmAddObjectDefConstraint(rhinoID, shortAvoidAll);
	rmAddObjectDefConstraint(rhinoID, cliffEdgeConstraint);
	rmAddObjectDefConstraint(rhinoID, avoidHunt);
	rmAddObjectDefConstraint(rhinoID, mediumCliffConstraint);
	rmAddObjectDefConstraint(rhinoID, startingSettleConstraint);

	// Medium pigs
	int mediumPigsID=rmCreateObjectDef("medium pigs");
	rmAddObjectDefItem(mediumPigsID, "pig", 2, 2.0);
	rmSetObjectDefMinDistance(mediumPigsID, 55.0);
	rmSetObjectDefMaxDistance(mediumPigsID, 65.0);
	rmAddObjectDefConstraint(mediumPigsID, avoidHerdable);
	rmAddObjectDefConstraint(mediumPigsID, shortAvoidAll);
	rmAddObjectDefConstraint(mediumPigsID, edgeConstraint);
	rmAddObjectDefConstraint(mediumPigsID, shortCliffConstraint);
	rmAddObjectDefConstraint(mediumPigsID, mediumCenterLineConstraint);

	// Predators
	int predatorID=rmCreateObjectDef("predator");
	rmAddObjectDefItem(predatorID, "lion", 2, 4.0);
	rmSetObjectDefMinDistance(predatorID, 65.0);
	rmSetObjectDefMaxDistance(predatorID, 80.0);
	rmAddObjectDefConstraint(predatorID, shortAvoidAll);
	rmAddObjectDefConstraint(predatorID, edgeConstraint);
	rmAddObjectDefConstraint(predatorID, avoidPredator);
	rmAddObjectDefConstraint(predatorID, shortCliffConstraint);
	rmAddObjectDefConstraint(predatorID, avoidPlayer);

	// Far objects
	// Far gold
	int farGoldID=rmCreateObjectDef("far gold");
	rmAddObjectDefItem(farGoldID, "Gold mine", 1, 0.0);
	if(cNumberNonGaiaPlayers < 5)
	{
		rmSetObjectDefMinDistance(farGoldID, 60.0);
		rmSetObjectDefMaxDistance(farGoldID, 100.0);
	}
	else
	{
		rmSetObjectDefMinDistance(farGoldID, 80.0);
		rmSetObjectDefMaxDistance(farGoldID, 120.0);
	}
	rmAddObjectDefConstraint(farGoldID, edgeConstraint);
	rmAddObjectDefConstraint(farGoldID, farAvoidGold);
	rmAddObjectDefConstraint(farGoldID, avoidSettlement);
	rmAddObjectDefConstraint(farGoldID, mediumForestConstraint);
	rmAddObjectDefConstraint(farGoldID, mediumCliffConstraint);
	rmAddObjectDefConstraint(farGoldID, startingSettleConstraint);
	if(cNumberNonGaiaPlayers == 2)
		rmAddObjectDefConstraint(farGoldID, mediumCenterLineConstraint);

	// Far pigs
	int farPigsID=rmCreateObjectDef("far pigs");
	rmAddObjectDefItem(farPigsID, "pig", 2, 2.0);
	rmSetObjectDefMinDistance(farPigsID, 80.0);
	rmSetObjectDefMaxDistance(farPigsID, 110.0);
	rmAddObjectDefConstraint(farPigsID, avoidHerdable);
	rmAddObjectDefConstraint(farPigsID, shortAvoidAll);
	rmAddObjectDefConstraint(farPigsID, edgeConstraint);
	rmAddObjectDefConstraint(farPigsID, shortCliffConstraint);
	rmAddObjectDefConstraint(farPigsID, shortForestConstraint);

	// Random Trees
	int randomTreeID=rmCreateObjectDef("random tree");
	rmAddObjectDefItem(randomTreeID, "palm", 1, 0.0);
	rmSetObjectDefMinDistance(randomTreeID, 0.0);
	rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(randomTreeID, rmCreateTypeDistanceConstraint("random tree", "all", 4.0));
	rmAddObjectDefConstraint(randomTreeID, shortAvoidAll);
	rmAddObjectDefConstraint(randomTreeID, shortCliffConstraint);
	rmAddObjectDefConstraint(randomTreeID, shortStartingSettleConstraint);

	// Relics
	int relicID=rmCreateObjectDef("relics");
	rmAddObjectDefItem(relicID, "relic", 1, 0.0);
	rmSetObjectDefMinDistance(relicID, 70.0);
	rmSetObjectDefMaxDistance(relicID, rmXFractionToMeters(0.3));
	rmAddObjectDefConstraint(relicID, rmCreateTypeDistanceConstraint("relic vs relic", "relic", 50.0));
	rmAddObjectDefConstraint(relicID, shortAvoidAll);
	rmAddObjectDefConstraint(relicID, shortCliffConstraint);
	rmAddObjectDefConstraint(relicID, edgeConstraint);
	rmAddObjectDefConstraint(relicID, startingSettleConstraint);

	// Birds
	int farhawkID=rmCreateObjectDef("far hawks");
	rmAddObjectDefItem(farhawkID, "vulture", 1, 0.0);
	rmSetObjectDefMinDistance(farhawkID, 0.0);
	rmSetObjectDefMaxDistance(farhawkID, rmXFractionToMeters(0.5));

	// Text
	rmSetStatusText("",0.8);

	// Player placement
	if(cNumberTeams < 3)
	{
		if(cNumberNonGaiaPlayers == 2)
		{
			if(skew==1)
				rmPlacePlayersLine(0.2, 0.5, 0.8, 0.5);
			else
				rmPlacePlayersLine(0.5, 0.2, 0.5, 0.8);
		}
		else if(cNumberNonGaiaPlayers < 5)
		{
			if(skew==1)
			{
				if(rmRandFloat(0,1)<0.5)
				{
					rmSetPlacementTeam(0);
					rmPlacePlayersLine(0.225, 0.325, 0.225, 0.675, 0.01);
					rmSetPlacementTeam(1);
					rmPlacePlayersLine(0.775, 0.325, 0.775, 0.675, 0.01);
				}
				else
				{
					rmSetPlacementTeam(0);
					rmPlacePlayersLine(0.775, 0.325, 0.775, 0.675, 0.01);
					rmSetPlacementTeam(1);
					rmPlacePlayersLine(0.225, 0.325, 0.225, 0.675, 0.01);
				}
			}
			else
			{
				if(rmRandFloat(0,1)<0.5)
				{
					rmSetPlacementTeam(0);
					rmPlacePlayersLine(0.325, 0.225, 0.675, 0.225, 0.01);
					rmSetPlacementTeam(1);
					rmPlacePlayersLine(0.325, 0.775, 0.675, 0.775, 0.01);
				}
				else
				{
					rmSetPlacementTeam(0);
					rmPlacePlayersLine(0.325, 0.775, 0.675, 0.775, 0.01);
					rmSetPlacementTeam(1);
					rmPlacePlayersLine(0.325, 0.225, 0.675, 0.225, 0.01);
				}
			}
		}
		else
		{
			if(skew==1)
			{
				if(rmRandFloat(0,1)<0.5)
				{
					rmSetPlacementTeam(0);
					rmSetPlacementSection(0.63, 0.87);
					rmPlacePlayersCircular(0.31, 0.31, rmDegreesToRadians(2.0));
					rmSetPlacementTeam(1);
					rmSetPlacementSection(0.13, 0.37);
					rmPlacePlayersCircular(0.31, 0.31, rmDegreesToRadians(2.0));
				}
				else
				{
					rmSetPlacementTeam(0);
					rmSetPlacementSection(0.13, 0.37);
					rmPlacePlayersCircular(0.31, 0.31, rmDegreesToRadians(2.0));
					rmSetPlacementTeam(1);
					rmSetPlacementSection(0.63, 0.87);
					rmPlacePlayersCircular(0.31, 0.31, rmDegreesToRadians(2.0));
				}
			}
			else
			{
				if(rmRandFloat(0,1)<0.5)
				{
					rmSetPlacementTeam(0);
					rmSetPlacementSection(0.38, 0.62);
					rmPlacePlayersCircular(0.31, 0.31, rmDegreesToRadians(2.0));
					rmSetPlacementTeam(1);
					rmSetPlacementSection(0.88, 0.12);
					rmPlacePlayersCircular(0.31, 0.31, rmDegreesToRadians(2.0));
				}
				else
				{
					rmSetPlacementTeam(0);
					rmSetPlacementSection(0.88, 0.12);
					rmPlacePlayersCircular(0.31, 0.31, rmDegreesToRadians(2.0));
					rmSetPlacementTeam(1);
					rmSetPlacementSection(0.38, 0.62);
					rmPlacePlayersCircular(0.31, 0.31, rmDegreesToRadians(2.0));
				}
			}
		}
	}
	else
		rmPlacePlayersSquare(0.3, 0.3, rmDegreesToRadians(5.0));
		// Impossible to get a fair placement with 3+ teams

	// Divide map
	int divisionID=rmCreateArea("division");
	rmSetAreaSize(divisionID, 1, 1);
	rmSetAreaLocation(divisionID, 0.5, 0.5);
	rmAddAreaToClass(divisionID, rmClassID("center line"));
	rmSetAreaWarnFailure(divisionID, false);
	rmAddAreaConstraint(divisionID, divisionConstraint);
	rmBuildArea(divisionID);

	// Set up player areas
	float playerFraction=rmAreaTilesToFraction(1600);
	for(h=1; <cNumberPlayers)
	{
		int id=rmCreateArea("Player"+h);
		rmSetPlayerArea(h, id);
		rmSetAreaSize(id, 0.9*playerFraction, 1.1*playerFraction);
		rmAddAreaToClass(id, classPlayer);
		rmSetAreaWarnFailure(id, false);
		rmSetAreaMinBlobs(id, 1);
		rmSetAreaMaxBlobs(id, 1);
		rmSetAreaCoherence(id, 1.0);
		rmSetAreaLocPlayer(id, h);
	}

	rmBuildAllAreas();

	// Text
	rmSetStatusText("",0.7);

	// Water
	// NW
	int waterNW=rmCreateArea("water NW");
	rmSetAreaSize(waterNW, 1.0, 1.0);
	if(skew==1)
		rmSetAreaLocation(waterNW, 0.5, 1);
	else
		rmSetAreaLocation(waterNW, 1, 0.5);
	rmSetAreaWarnFailure(waterNW, false);
	rmSetAreaWaterType(waterNW, "Egyptian Nile");
	rmAddAreaConstraint(waterNW, waterNWConstraint);
	rmSetAreaBaseHeight(waterNW, -1.0);
	rmSetAreaSmoothDistance(waterNW, 10.0);
	rmSetAreaHeightBlend(waterNW, 2.0);
	rmBuildArea(waterNW);

	// SE
	int waterSW=rmCreateArea("water SW");
	rmSetAreaSize(waterSW, 1.0, 1.0);
	if(skew==1)
		rmSetAreaLocation(waterSW, 0.5, 0.0);
	else
		rmSetAreaLocation(waterSW, 0.0, 0.5);
	rmSetAreaWarnFailure(waterSW, false);
	rmSetAreaWaterType(waterSW, "Egyptian Nile");
	rmAddAreaConstraint(waterSW, waterSEConstraint);
	rmSetAreaBaseHeight(waterSW, -1.0);
	rmSetAreaSmoothDistance(waterSW, 10.0);
	rmSetAreaHeightBlend(waterSW, 2.0);
	rmBuildArea(waterSW);

	// Side forests
	int forestID=0;
	int numTries=11;
	int failCount=0;

	// NW
	for(l=1; <numTries)
	{
		forestID=rmCreateArea("forest NW"+l);
		if(cNumberNonGaiaPlayers == 2)
			rmSetAreaSize(forestID, 0.0075, 0.0075);
		else if(cNumberNonGaiaPlayers < 5)
			rmSetAreaSize(forestID, 0.0072, 0.0072);
		else
			rmSetAreaSize(forestID, 0.006, 0.006);
		if(skew==1)
			rmSetAreaLocation(forestID, 0.1*l-0.05, 0.9);
		else
			rmSetAreaLocation(forestID, 0.9, 0.1*l-0.05);
		rmSetAreaWarnFailure(forestID, false);
		rmSetAreaForestType(forestID, "palm forest");
		rmSetAreaBaseHeight(forestID, 0.0);
		rmAddAreaToClass(forestID, classForest);
		rmSetAreaSmoothDistance(forestID, 10.0);
		rmSetAreaHeightBlend(forestID, 2.0);
		rmBuildArea(forestID);
	}

	// SE
	for(m=1; <numTries)
	{
		forestID=rmCreateArea("forest SE"+m);
		if(cNumberNonGaiaPlayers == 2)
			rmSetAreaSize(forestID, 0.0075, 0.0075);
		else if(cNumberNonGaiaPlayers < 5)
			rmSetAreaSize(forestID, 0.0072, 0.0072);
		else
			rmSetAreaSize(forestID, 0.006, 0.006);
		if(skew==1)
			rmSetAreaLocation(forestID, 0.1*m-0.05, 0.1);
		else
			rmSetAreaLocation(forestID, 0.1, 0.1*m-0.05);
		rmSetAreaWarnFailure(forestID, false);
		rmSetAreaForestType(forestID, "palm forest");
		rmSetAreaBaseHeight(forestID, 0.0);
		rmAddAreaToClass(forestID, classForest);
		rmSetAreaSmoothDistance(forestID, 10.0);
		rmSetAreaHeightBlend(forestID, 2.0);
		rmBuildArea(forestID);
	}

	// Text
	rmSetStatusText("",0.6);

	// Settlement 1
	rmPlaceObjectDefPerPlayer(startingSettlementID, true);
	if(cNumberNonGaiaPlayers < 3)
	{
		id=rmAddFairLoc("Settlement", false, true, 60, 80, 24, 16);
		rmAddFairLocConstraint(id, shortForestConstraint);
	}
	else if(cNumberNonGaiaPlayers < 5)
	{
		if(rmRandFloat(0,1)<0.5)
			id=rmAddFairLoc("Settlement", false, true, 40, 75, 24, 16);
		else
			id=rmAddFairLoc("Settlement", false, false, 60, 80, 36, 16);
		rmAddFairLocConstraint(id, mediumForestConstraint);
	}
	else
	{
		id=rmAddFairLoc("Settlement", false, false, 55, 75, 36, 20);
		rmAddFairLocConstraint(id, mediumForestConstraint);
	}
	rmAddFairLocConstraint(id, startingSettleConstraint);

	if(rmPlaceFairLocs())
	{
		id=rmCreateObjectDef("close settlement");
		rmAddObjectDefItem(id, "Settlement", 1, 0.0);
		for(i=1; <cNumberPlayers)
		{
			for(j=0; <rmGetNumberFairLocs(i))
			{
				int settleArea = rmCreateArea("close settlement area"+i +j, rmAreaID("Player"+i));
				rmSetAreaLocation(settleArea, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j));
				rmBuildArea(settleArea);
				rmPlaceObjectDefAtAreaLoc(id, i, settleArea);
			}
		}
	}

	rmResetFairLocs();

	// Settlement 2
	if(cNumberNonGaiaPlayers < 3)
	{
		if(rmRandFloat(0,1)<0.85)
			id=rmAddFairLoc("Settlement", true, false,  70, 85, 30, 24);
		else
			id=rmAddFairLoc("Settlement", false, false, 60, 80, 10, 24);
		rmAddFairLocConstraint(id, mediumCenterLineConstraint);
	}
	else if(cNumberNonGaiaPlayers < 5)
	{
		if(rmRandFloat(0,1)<0.5)
			id=rmAddFairLoc("Settlement", true, false,  70, 100, 70, 40);
		else
			id=rmAddFairLoc("Settlement", true, true,  70, 100, 70, 100);
	}
	else
	{
		if(rmRandFloat(0,1)<0.5)
			id=rmAddFairLoc("Settlement", true, false,  70, 90, 60, 40);
		else
			id=rmAddFairLoc("Settlement", true, true,  70, 100, 90, 60);
	}
	rmAddFairLocConstraint(id, startingSettleConstraint);
	rmAddFairLocConstraint(id, mediumForestConstraint);
	rmAddFairLocConstraint(id, settlementVsSettlement);

	if(rmPlaceFairLocs())
	{
		id=rmCreateObjectDef("far settlement");
		rmAddObjectDefItem(id, "Settlement", 1, 0.0);
		for(i=1; <cNumberPlayers)
		{
			for(j=0; <rmGetNumberFairLocs(i))
			{
				int farSettleArea = rmCreateArea("far settlement area"+i +j, rmAreaID("Player"+i));
				rmSetAreaLocation(farSettleArea, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j));
				rmBuildArea(farSettleArea);
				rmPlaceObjectDefAtAreaLoc(id, i, farSettleArea);
			}
		}
	}

	// Text
	rmSetStatusText("",0.5);

	// Cliffs
	if(cNumberNonGaiaPlayers < 3)
		numTries=3*cNumberNonGaiaPlayers+1;
	else
		numTries=2*cNumberNonGaiaPlayers+1;
	failCount=0;
	for(k=0; <numTries)
	{
		int cliffID=rmCreateArea("cliff"+k);
		rmSetAreaWarnFailure(cliffID, false);
		rmSetAreaSize(cliffID, rmAreaTilesToFraction(120), rmAreaTilesToFraction(150));
		rmSetAreaCliffType(cliffID, "Egyptian");
		rmAddAreaToClass(cliffID, classCliff);
		rmSetAreaMinBlobs(cliffID, 2);
		rmSetAreaMaxBlobs(cliffID, 2);
		rmSetAreaCliffEdge(cliffID, 1.0, 1.0, 0.0, 1.0, 0);
		rmSetAreaCliffPainting(cliffID, true, true, true, 1.5, true);
		rmSetAreaCliffHeight(cliffID, 7, 1.0, 1.0);
		rmSetAreaMinBlobDistance(cliffID, 16.0);
		rmSetAreaMaxBlobDistance(cliffID, 20.0);
		rmSetAreaCoherence(cliffID, 0.25);
		rmSetAreaSmoothDistance(cliffID, 8);
		rmSetAreaHeightBlend(cliffID, 2);
		rmAddAreaConstraint(cliffID, avoidBuildings);
		rmAddAreaConstraint(cliffID, cliffPlayerConstraint);
		rmAddAreaConstraint(cliffID, cliffEdgeConstraint);
		rmAddAreaConstraint(cliffID, farCliffConstraint);
		rmAddAreaConstraint(cliffID, farForestConstraint);
		rmAddAreaConstraint(cliffID, shortCenterLineConstraint);

		if(rmBuildArea(cliffID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
	}

	// Text
	rmSetStatusText("",0.4);

	// Texture embellishment
	for(z=1; <cNumberPlayers*15)
	{
		int id1=rmCreateArea("beautification"+z);
		rmSetAreaSize(id1, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(id1, "SandB");
		rmAddAreaConstraint(id1, shortForestConstraint);
		rmAddAreaConstraint(id1, shortAvoidImpassableLand);
		rmSetAreaMinBlobs(id1, 1);
		rmSetAreaMaxBlobs(id1, 5);
		rmSetAreaWarnFailure(id1, false);
		rmSetAreaMinBlobDistance(id1, 16.0);
		rmSetAreaMaxBlobDistance(id1, 40.0);
		rmSetAreaCoherence(id1, 0.6);
		rmBuildArea(id1);
	}

	 for(z=1; <cNumberPlayers*10)
	{
		int id2=rmCreateArea("more beautification"+z);
		rmSetAreaSize(id2, rmAreaTilesToFraction(60), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(id2, "EgyptianRoadA");
		rmAddAreaConstraint(id2, shortForestConstraint);
		rmAddAreaConstraint(id2, shortAvoidImpassableLand);
		rmSetAreaMinBlobs(id2, 1);
		rmSetAreaMaxBlobs(id2, 5);
		rmSetAreaWarnFailure(id2, false);
		rmSetAreaMinBlobDistance(id2, 16.0);
		rmSetAreaMaxBlobDistance(id2, 40.0);
		rmSetAreaCoherence(id2, 0.4);
		rmBuildArea(id2);
	}

	// Place close objects
	// Towers
	rmPlaceObjectDefPerPlayer(startingTowerID, true, 4);

	// Gold
	rmPlaceObjectDefPerPlayer(startingGoldID, false);

	// Hunt
	rmPlaceObjectDefPerPlayer(startingRhinoID, false);

	// Berries
	rmPlaceObjectDefPerPlayer(startingFoodID, false);

	// Pigs
	rmPlaceObjectDefPerPlayer(startingPigsID, true);

	// Text
	rmSetStatusText("",0.3);

	// Player forest 1
	failCount=0;
	numTries=cNumberPlayers;
	for(l=1; <numTries)
	{
		forestID=rmCreateArea("first player forest"+l, rmAreaID("Player"+l));
		rmSetAreaSize(forestID, rmAreaTilesToFraction(20), rmAreaTilesToFraction(20));
		rmSetAreaWarnFailure(forestID, false);
		rmSetAreaForestType(forestID, "palm forest");
		rmAddAreaConstraint(forestID, shortAvoidAll);
		rmAddAreaConstraint(forestID, shortAvoidGold);
		rmAddAreaConstraint(forestID, shortCliffConstraint);
		rmAddAreaConstraint(forestID, avoidSettlement);
		rmAddAreaConstraint(forestID, shortAvoidFood);
		rmAddAreaConstraint(forestID, shortStartingSettleConstraint);
		rmAddAreaToClass(forestID, classForest);
		rmSetAreaCoherence(forestID, 0.6);
		rmSetAreaBaseHeight(forestID, 1.0);
		rmSetAreaSmoothDistance(forestID, 2);
		rmSetAreaHeightBlend(forestID, 2);
		rmSetAreaMinBlobs(forestID, 3);
		rmSetAreaMaxBlobs(forestID, 4);
		rmSetAreaMinBlobDistance(forestID, 16.0);
		rmSetAreaMaxBlobDistance(forestID, 30.0);
		rmSetAreaCoherence(forestID, 0.0);

		if(rmBuildArea(forestID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
	}

	// Player forest 2
	failCount=0;
	numTries=cNumberPlayers;
	for(m=1; <numTries)
	{
		forestID=rmCreateArea("second player forest"+m, rmAreaID("Player"+m));
		rmSetAreaSize(forestID, rmAreaTilesToFraction(20), rmAreaTilesToFraction(20));
		rmSetAreaWarnFailure(forestID, false);
		rmSetAreaForestType(forestID, "palm forest");
		rmAddAreaConstraint(forestID, shortAvoidAll);
		rmAddAreaConstraint(forestID, shortAvoidGold);
		rmAddAreaConstraint(forestID, shortCliffConstraint);
		rmAddAreaConstraint(forestID, avoidSettlement);
		rmAddAreaConstraint(forestID, mediumForestConstraint);
		rmAddAreaConstraint(forestID, shortAvoidFood);
		rmAddAreaConstraint(forestID, shortStartingSettleConstraint);
		rmAddAreaToClass(forestID, classForest);
		rmSetAreaCoherence(forestID, 0.6);
		rmSetAreaBaseHeight(forestID, 1.0);
		rmSetAreaSmoothDistance(forestID, 2);
		rmSetAreaHeightBlend(forestID, 2);
		rmSetAreaMinBlobs(forestID, 3);
		rmSetAreaMaxBlobs(forestID, 4);
		rmSetAreaMinBlobDistance(forestID, 16.0);
		rmSetAreaMaxBlobDistance(forestID, 30.0);
		rmSetAreaCoherence(forestID, 0.0);

		if(rmBuildArea(forestID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
	}

	// Center player forest
	if(cNumberNonGaiaPlayers > 4)
	{
		failCount=0;
		for(n=1; <3)
		{
			forestID=rmCreateArea("bonus forest"+n);
			rmSetAreaSize(forestID, rmAreaTilesToFraction(60), rmAreaTilesToFraction(70));
			if(skew==1)
			{
				if(n==1)
					rmSetAreaLocation(forestID, 0.0, 0.5);
				else
					rmSetAreaLocation(forestID, 1.0, 0.5);
			}
			else
			{
				if(n==1)
					rmSetAreaLocation(forestID, 0.5, 0.0);
				else
					rmSetAreaLocation(forestID, 0.5, 1.0);
			}
			rmSetAreaWarnFailure(forestID, false);
			rmSetAreaForestType(forestID, "palm forest");
			rmSetAreaCoherence(forestID, 0.6);
			rmSetAreaBaseHeight(forestID, 1.0);
			rmSetAreaSmoothDistance(forestID, 2);
			rmSetAreaHeightBlend(forestID, 2);
			rmSetAreaMinBlobs(forestID, 3);
			rmSetAreaMaxBlobs(forestID, 4);
			rmSetAreaMinBlobDistance(forestID, 16.0);
			rmSetAreaMaxBlobDistance(forestID, 30.0);
			rmSetAreaCoherence(forestID, 0.0);

			if(rmBuildArea(forestID)==false)
			{
				// Stop trying once we fail 3 times in a row.
				failCount++;
				if(failCount==3)
					break;
			}
			else
				failCount=0;
		}
	}

	// Text
	rmSetStatusText("",0.2);

	// Straggler trees
	rmPlaceObjectDefPerPlayer(stragglerTreeID, false, rmRandInt(4,6));

	// Medium objects
	// Gold
	rmPlaceObjectDefPerPlayer(mediumGoldID, false);

	// Gazelles
	if(cNumberNonGaiaPlayers == 2)
		rmPlaceObjectDefPerPlayer(gazelleID, false, 2);
	else
		rmPlaceObjectDefPerPlayer(gazelleID, false);

	// Giraffes
	rmPlaceObjectDefPerPlayer(giraffeID, false);

	// Rhinos
	rmPlaceObjectDefPerPlayer(rhinoID, false);

	// Medium Pigs
	rmPlaceObjectDefPerPlayer(mediumPigsID, false);

	// Predators
	rmPlaceObjectDefPerPlayer(predatorID, false);

	// Far objects
	// Gold
	rmPlaceObjectDefPerPlayer(farGoldID, false, 2);

	// Far Pigs
	rmPlaceObjectDefPerPlayer(farPigsID, false);

	// Relics
	rmPlaceObjectDefPerPlayer(relicID, false);

	// Random trees
	rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 25*cNumberNonGaiaPlayers);

	// Hawks
	rmPlaceObjectDefPerPlayer(farhawkID, false, 2);

	// Text
	rmSetStatusText("",0.1);

	// Decoration
	int bushID=rmCreateObjectDef("big bush patch");
	rmAddObjectDefItem(bushID, "bush", 4, 3.0);
	rmSetObjectDefMinDistance(bushID, 0.0);
	rmSetObjectDefMaxDistance(bushID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(bushID, shortAvoidAll);
	rmPlaceObjectDefAtLoc(bushID, 0, 0.5, 0.5, 5*cNumberNonGaiaPlayers);

	int bush2ID=rmCreateObjectDef("small bush patch");
	rmAddObjectDefItem(bush2ID, "bush", 3, 2.0);
	rmAddObjectDefItem(bush2ID, "rock sandstone sprite", 1, 2.0);
	rmSetObjectDefMinDistance(bush2ID, 0.0);
	rmSetObjectDefMaxDistance(bush2ID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(bush2ID, shortAvoidAll);
	rmPlaceObjectDefAtLoc(bush2ID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);

	int grassID=rmCreateObjectDef("grass");
	rmAddObjectDefItem(grassID, "grass", 1, 0.0);
	rmSetObjectDefMinDistance(grassID, 0.0);
	rmSetObjectDefMaxDistance(grassID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(grassID, shortAvoidAll);
	rmPlaceObjectDefAtLoc(grassID, 0, 0.5, 0.5, 30*cNumberNonGaiaPlayers);

	int sandDrift=rmCreateObjectDef("blowing sand");
	rmAddObjectDefItem(sandDrift, "sand drift patch", 1, 0.0);
	rmSetObjectDefMinDistance(sandDrift, 0.0);
	rmSetObjectDefMaxDistance(sandDrift, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(sandDrift, shortAvoidAll);
	rmAddObjectDefConstraint(sandDrift, edgeConstraint);
	rmAddObjectDefConstraint(sandDrift, rmCreateTypeDistanceConstraint("drift vs drift", "sand drift dune", 25.0));
	rmAddObjectDefConstraint(sandDrift, avoidBuildings);
	rmPlaceObjectDefAtLoc(sandDrift, 0, 0.5, 0.5, 6*cNumberNonGaiaPlayers);

	int column=rmCreateObjectDef("broken columns");
	rmAddObjectDefItem(column, "columns broken", 1, 0.0);
	rmSetObjectDefMinDistance(column, 0.0);
	rmSetObjectDefMaxDistance(column, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(column, shortAvoidAll);
	rmAddObjectDefConstraint(column, edgeConstraint);
	rmAddObjectDefConstraint(column, avoidBuildings);
	rmPlaceObjectDefAtLoc(column, 0, 0.5, 0.5, 6*cNumberNonGaiaPlayers);

	// Text
	rmSetStatusText("",0.01);

	// Notify players
	if(cNumberTeams > 2)
	{
		rmCreateTrigger("team notification");
		rmSetTriggerPriority(5);
		rmSetTriggerActive(true);
		rmAddTriggerCondition("Timer");
		rmAddTriggerEffect("Send Spoofed Chat");
		rmSetTriggerEffectParam("Message", "RebelsRising: This map has not been optimized for 4v4+ and FFA. No balance guaranteed - play at your own risk!", false);
		rmSetTriggerEffectParam("PlayerID", ""+0);
	}
	else if(cNumberNonGaiaPlayers > 6)
	{
		rmCreateTrigger("player notification");
		rmSetTriggerPriority(5);
		rmSetTriggerActive(true);
		rmAddTriggerCondition("Timer");
		rmAddTriggerEffect("Send Spoofed Chat");
		rmSetTriggerEffectParam("Message", "RebelsRising: This map has not been optimized for 4v4+ and FFA. No balance guaranteed - play at your own risk!", false);
		rmSetTriggerEffectParam("PlayerID", ""+0);
	}
}

// Sacred Pond
void sacredpond(void)
{
	// Text
	rmSetStatusText("",1.0);

	// Set size
	int playerTiles=7500;
	int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles/0.9);
	rmEchoInfo("Map size="+size+"m x "+size+"m");
	rmSetMapSize(size, size);

	// Set up default water.
	rmSetSeaLevel(0.0);

	// Init map
	rmTerrainInitialize("SandD");
	rmSetLightingSet("Dawn");

	// Define classes
	int classBonusHuntable=rmDefineClass("bonus huntable");
	int classBaboon=rmDefineClass("class baboon");
	int classElev=rmDefineClass("elevation");
	int classForest=rmDefineClass("forest");
	rmDefineClass("starting settlement");
	rmDefineClass("center");

	// Constraints
	// General
	int centerConstraint=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), 15.0);
	int farCenterConstraint=rmCreateClassDistanceConstraint("stay far away from center", rmClassID("center"), 30.0);
	int edgeConstraint=rmCreateBoxConstraint("edge of map", rmXTilesToFraction(8), rmZTilesToFraction(8), 1.0-rmXTilesToFraction(8), 1.0-rmZTilesToFraction(8));
	int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "land", false, 10.0);
	int elevConstraint=rmCreateClassDistanceConstraint("elev avoid elev", rmClassID("elevation"), 10.0);
	int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

	// Settlement
	int settlementAvoidsForest=rmCreateClassDistanceConstraint("settlement avoids center forest", rmClassID("forest"), 17.5);
	int settlementAvoidsShore=rmCreateTerrainDistanceConstraint("settlement avoids center lake", "water", true, 17.5);
	int settlementAvoidsSettlement=rmCreateTypeDistanceConstraint("TCs avoid TCs by long distance", "AbstractSettlement", 60.0);
	int shortAvoidSettlement=rmCreateTypeDistanceConstraint("objects avoid TC by short distance", "AbstractSettlement", 20.0);
	int farAvoidSettlement=rmCreateTypeDistanceConstraint("objects avoid TCs by long distance", "AbstractSettlement", 50.0);
	int farStartingSettleConstraint=rmCreateClassDistanceConstraint("objects avoid player TCs", rmClassID("starting settlement"), 50.0);

	// Shore
	int forestShoreMin=rmCreateTerrainDistanceConstraint("center forest min", "water", true, 8.0);
	int forestShoreMax=rmCreateTerrainMaxDistanceConstraint("center forest max", "water", true, 20.0);
	int shoreForestConstraint=rmCreateClassDistanceConstraint("forest v forest center", rmClassID("forest"), 12.5);
	int nearShore=rmCreateTerrainMaxDistanceConstraint("near shore", "land", true, 4.0);
	int nearWater=rmCreateTerrainMaxDistanceConstraint("near water", "water", true, 5.0);

	// Gold
	int avoidGold=rmCreateTypeDistanceConstraint("avoid gold", "gold", 50.0);
	int shortAvoidGold=rmCreateTypeDistanceConstraint("short avoid gold", "gold", 10.0);

	// Food
	int avoidHerdable=rmCreateTypeDistanceConstraint("avoid herdable", "herdable", 30.0);
	int avoidPredator=rmCreateTypeDistanceConstraint("avoid predator", "animalPredator", 20.0);
	int avoidFood=rmCreateTypeDistanceConstraint("avoid other food sources", "food", 30.0);
	int avoidBonusHuntable=rmCreateClassDistanceConstraint("avoid bonus huntable", classBonusHuntable, 40.0);
	int avoidHuntable=rmCreateTypeDistanceConstraint("avoid huntable", "huntable", 40.0);
	int avoidBaboon=rmCreateClassDistanceConstraint("baboon v baboon", classBaboon, 100.0);
	int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 16.0);
	int fishLand=rmCreateTerrainDistanceConstraint("fish land", "land", true, 7.0);

	// Forest
	int forestConstraint=rmCreateClassDistanceConstraint("forest v forest", rmClassID("forest"), 25.0);
	int forestSettleConstraint=rmCreateClassDistanceConstraint("forest settle", rmClassID("starting settlement"), 20.0);
	int avoidForest=rmCreateClassDistanceConstraint("avoid forest", rmClassID("forest"), 10.0);

	// Buildings
	int avoidTower=rmCreateTypeDistanceConstraint("towers avoid towers", "tower", 25.0);
	int shortAvoidBuildings=rmCreateTypeDistanceConstraint("short avoid buildings", "Building", 10.0);
	int avoidBuildings=rmCreateTypeDistanceConstraint("avoid buildings", "Building", 20.0);

	// Embellishment
	int driftVsDrift=rmCreateTypeDistanceConstraint("drift vs drift", "sand drift dune", 25.0);

	// Text
	rmSetStatusText("",0.9);

	// Define objects
	// Starting TC
	int startingSettlementID=rmCreateObjectDef("starting settlement");
	rmAddObjectDefItem(startingSettlementID, "Settlement Level 1", 1, 0.0);
	rmAddObjectDefToClass(startingSettlementID, rmClassID("starting settlement"));
	rmSetObjectDefMinDistance(startingSettlementID, 0.0);
	rmSetObjectDefMaxDistance(startingSettlementID, 0.0);

	// Towers
	int startingTowerID=rmCreateObjectDef("Starting tower");
	rmAddObjectDefItem(startingTowerID, "tower", 1, 0.0);
	rmSetObjectDefMinDistance(startingTowerID, 20.0);
	rmSetObjectDefMaxDistance(startingTowerID, 28.0);
	rmAddObjectDefConstraint(startingTowerID, avoidTower);
	rmAddObjectDefConstraint(startingTowerID, centerConstraint);

	// Gold
	int startingGoldID=rmCreateObjectDef("Starting gold");
	rmAddObjectDefItem(startingGoldID, "Gold mine small", 1, 0.0);
	rmSetObjectDefMinDistance(startingGoldID, 20.0);
	rmSetObjectDefMaxDistance(startingGoldID, 20.0);
	rmAddObjectDefConstraint(startingGoldID, centerConstraint);
	rmAddObjectDefConstraint(startingGoldID, avoidAll);

	// Goats
	int closeGoatsID=rmCreateObjectDef("close goats");
	rmAddObjectDefItem(closeGoatsID, "goat", rmRandInt(2,3), 2.0);
	rmSetObjectDefMinDistance(closeGoatsID, 25.0);
	rmSetObjectDefMaxDistance(closeGoatsID, 30.0);
	rmAddObjectDefConstraint(closeGoatsID, centerConstraint);
	rmAddObjectDefConstraint(closeGoatsID, avoidAll);

	// Berries
	int closeBerriesID=rmCreateObjectDef("close Chickens");
	rmAddObjectDefItem(closeBerriesID, "berry bush", rmRandInt(7,8), 4.0);
	rmSetObjectDefMinDistance(closeBerriesID, 20.0);
	rmSetObjectDefMaxDistance(closeBerriesID, 25.0);
	rmAddObjectDefConstraint(closeBerriesID, centerConstraint);
	rmAddObjectDefConstraint(closeBerriesID, avoidAll);
	rmAddObjectDefConstraint(closeBerriesID, shortAvoidGold);

	// Starting hunt
	int closeZebraID=rmCreateObjectDef("close zebra");
	if(rmRandFloat(0,1)<0.5)
		rmAddObjectDefItem(closeZebraID, "zebra", rmRandInt(4,5), 2.0);
	else
		rmAddObjectDefItem(closeZebraID, "gazelle", rmRandInt(5,6), 2.0);
	rmSetObjectDefMinDistance(closeZebraID, 20.0);
	rmSetObjectDefMaxDistance(closeZebraID, 28.0);
	rmAddObjectDefConstraint(closeZebraID, centerConstraint);
	rmAddObjectDefConstraint(closeZebraID, shortAvoidBuildings);
	rmAddObjectDefConstraint(closeZebraID, avoidForest);
	rmAddObjectDefConstraint(closeZebraID, shortAvoidGold);

	// Straggler trees
	int stragglerTreeID=rmCreateObjectDef("straggler tree");
	rmAddObjectDefItem(stragglerTreeID, "palm", 1, 0.0);
	rmSetObjectDefMinDistance(stragglerTreeID, 12.0);
	rmSetObjectDefMaxDistance(stragglerTreeID, 15.0);
	rmAddObjectDefConstraint(stragglerTreeID, shortAvoidGold);

	// Medium Objects
	// gold avoids gold and Settlements
	int mediumGoldID=rmCreateObjectDef("medium gold");
	rmAddObjectDefItem(mediumGoldID, "Gold mine", 1, 0.0);
	rmSetObjectDefMinDistance(mediumGoldID, 40.0);
	rmSetObjectDefMaxDistance(mediumGoldID, 60.0);
	rmAddObjectDefConstraint(mediumGoldID, avoidGold);
	rmAddObjectDefConstraint(mediumGoldID, edgeConstraint);
	rmAddObjectDefConstraint(mediumGoldID, shortAvoidSettlement);
	rmAddObjectDefConstraint(mediumGoldID, centerConstraint);
	rmAddObjectDefConstraint(mediumGoldID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(mediumGoldID, avoidAll);

	int mediumGoatsID=rmCreateObjectDef("medium Goats");
	rmAddObjectDefItem(mediumGoatsID, "goat", 2, 4.0);
	rmSetObjectDefMinDistance(mediumGoatsID, 50.0);
	rmSetObjectDefMaxDistance(mediumGoatsID, 70.0);
	rmAddObjectDefConstraint(mediumGoatsID, centerConstraint);
	rmAddObjectDefConstraint(mediumGoatsID, avoidHerdable);
	rmAddObjectDefConstraint(mediumGoatsID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(mediumGoatsID, avoidAll);

	// Far Objects
	// gold avoids gold, Settlements and TCs
	int farGoldID=rmCreateObjectDef("far gold");
	rmAddObjectDefItem(farGoldID, "Gold mine", 1, 0.0);
	rmSetObjectDefMinDistance(farGoldID, 80.0);
	rmSetObjectDefMaxDistance(farGoldID, 120.0);
	rmAddObjectDefConstraint(farGoldID, avoidGold);
	rmAddObjectDefConstraint(farGoldID, edgeConstraint);
	rmAddObjectDefConstraint(farGoldID, centerConstraint);
	rmAddObjectDefConstraint(farGoldID, shortAvoidSettlement);
	rmAddObjectDefConstraint(farGoldID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(farGoldID, avoidAll);

	// Goats avoid TCs and other herds
	int farGoatsID=rmCreateObjectDef("far Goats");
	rmAddObjectDefItem(farGoatsID, "goat", 2, 4.0);
	rmSetObjectDefMinDistance(farGoatsID, 80.0);
	rmSetObjectDefMaxDistance(farGoatsID, 150.0);
	rmAddObjectDefConstraint(farGoatsID, centerConstraint);
	rmAddObjectDefConstraint(farGoatsID, avoidHerdable);
	rmAddObjectDefConstraint(farGoatsID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(farGoatsID, avoidAll);

	// Pick lions or bears as predators
	int farPredatorID=rmCreateObjectDef("far predator");
	if(rmRandFloat(0,1)<0.5)
		rmAddObjectDefItem(farPredatorID, "lion", 2, 4.0);
	else
		rmAddObjectDefItem(farPredatorID, "hyena", 2, 4.0);
	rmSetObjectDefMinDistance(farPredatorID, 50.0);
	rmSetObjectDefMaxDistance(farPredatorID, 100.0);
	rmAddObjectDefConstraint(farPredatorID, avoidPredator);
	rmAddObjectDefConstraint(farPredatorID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(farPredatorID, centerConstraint);
	rmAddObjectDefConstraint(farPredatorID, avoidAll);
	rmAddObjectDefConstraint(farPredatorID, avoidFood);

	// Berries avoid TCs
	int farBerriesID=rmCreateObjectDef("far berries");
	rmAddObjectDefItem(farBerriesID, "berry bush", rmRandInt(8,10), 4.0);
	rmSetObjectDefMinDistance(farBerriesID, 20.0);
	rmSetObjectDefMaxDistance(farBerriesID, rmXFractionToMeters(0.3));
	rmAddObjectDefConstraint(farBerriesID, centerConstraint);
	rmAddObjectDefConstraint(farBerriesID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(farBerriesID, shortAvoidGold);
	rmAddObjectDefConstraint(farBerriesID, shortAvoidSettlement);
	rmAddObjectDefConstraint(farBerriesID, forestConstraint);
	rmAddObjectDefConstraint(farBerriesID, avoidFood);
	rmAddObjectDefConstraint(farBerriesID, edgeConstraint);

	// Bonus hunt avoids other hunt
	int bonusHuntableID=rmCreateObjectDef("bonus huntable");
	float bonusChance=rmRandFloat(0, 1);
	if(bonusChance<0.5)
	{
		rmAddObjectDefItem(bonusHuntableID, "giraffe", rmRandInt(2,3), 2.0);
		rmAddObjectDefItem(bonusHuntableID, "gazelle", rmRandInt(2,3), 3.0);
	}
	else
		rmAddObjectDefItem(bonusHuntableID, "giraffe", rmRandInt(3,4), 2.0);
	rmSetObjectDefMinDistance(bonusHuntableID, rmXFractionToMeters(0.1));
	rmSetObjectDefMaxDistance(bonusHuntableID, rmXFractionToMeters(0.3));
	rmAddObjectDefConstraint(bonusHuntableID, avoidBonusHuntable);
	rmAddObjectDefConstraint(bonusHuntableID, avoidHuntable);
	rmAddObjectDefToClass(bonusHuntableID, classBonusHuntable);
	rmAddObjectDefConstraint(bonusHuntableID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(bonusHuntableID, centerConstraint);
	rmAddObjectDefConstraint(bonusHuntableID, avoidAll);
	rmAddObjectDefConstraint(bonusHuntableID, avoidFood);
	rmAddObjectDefConstraint(bonusHuntableID, edgeConstraint);

	int moreBonusHuntableID=rmCreateObjectDef("more bonus huntable");
	rmAddObjectDefItem(moreBonusHuntableID, "elephant", 2, 5.0);
	rmSetObjectDefMinDistance(moreBonusHuntableID, rmXFractionToMeters(0.15));
	rmSetObjectDefMaxDistance(moreBonusHuntableID, rmXFractionToMeters(0.35));
	rmAddObjectDefConstraint(moreBonusHuntableID, avoidBonusHuntable);
	rmAddObjectDefConstraint(moreBonusHuntableID, avoidHuntable);
	rmAddObjectDefToClass(moreBonusHuntableID, classBonusHuntable);
	rmAddObjectDefConstraint(moreBonusHuntableID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(moreBonusHuntableID, centerConstraint);
	rmAddObjectDefConstraint(moreBonusHuntableID, avoidAll);
	rmAddObjectDefConstraint(moreBonusHuntableID, avoidFood);
	rmAddObjectDefConstraint(moreBonusHuntableID, edgeConstraint);

	// Baboons
	int baboonID=rmCreateObjectDef("baboons");
	rmAddObjectDefItem(baboonID, "baboon", rmRandInt(6,7), 4.0);
	rmSetObjectDefMinDistance(baboonID, rmXFractionToMeters(0.5));
	rmSetObjectDefMaxDistance(baboonID, rmXFractionToMeters(0.5));
	rmAddObjectDefToClass(baboonID, classBaboon);
	rmAddObjectDefConstraint(baboonID, avoidBaboon);
	rmAddObjectDefConstraint(baboonID, farStartingSettleConstraint);
	rmAddObjectDefConstraint(baboonID, centerConstraint);
	rmAddObjectDefConstraint(baboonID, avoidAll);
	rmAddObjectDefConstraint(baboonID, avoidFood);
	rmAddObjectDefConstraint(baboonID, edgeConstraint);

	// Player Fish
	int playerFishID=rmCreateObjectDef("owned fish");
	rmAddObjectDefItem(playerFishID, "fish - perch", 3, 8.0);
	rmSetObjectDefMinDistance(playerFishID, 0.0);
	rmSetObjectDefMaxDistance(playerFishID, rmXFractionToMeters(0.3));
	rmAddObjectDefConstraint(playerFishID, fishVsFishID);
	rmAddObjectDefConstraint(playerFishID, fishLand);

	// More Fish
	int fishID=rmCreateObjectDef("fish");
	rmAddObjectDefItem(fishID, "fish - mahi", 3, 8.0);
	rmSetObjectDefMinDistance(fishID, 0.0);
	rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(fishID, fishVsFishID);
	rmAddObjectDefConstraint(fishID, fishLand);

	int moreFishID=rmCreateObjectDef("more fish");
	rmAddObjectDefItem(moreFishID, "fish - mahi", 2, 4.0);
	rmSetObjectDefMinDistance(moreFishID, 0.0);
	rmSetObjectDefMaxDistance(moreFishID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(moreFishID, fishVsFishID);
	rmAddObjectDefConstraint(moreFishID, fishLand);

	// Random Trees
	int randomTreeID=rmCreateObjectDef("random tree");
	rmAddObjectDefItem(randomTreeID, "palm", 1, 0.0);
	rmSetObjectDefMinDistance(randomTreeID, 0.0);
	rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(randomTreeID, rmCreateTypeDistanceConstraint("random tree", "all", 4.0));
	rmAddObjectDefConstraint(randomTreeID, shortAvoidSettlement);
	rmAddObjectDefConstraint(randomTreeID, centerConstraint);
	rmAddObjectDefConstraint(randomTreeID, avoidAll);

	// Birds
	int farhawkID=rmCreateObjectDef("far hawks");
	rmAddObjectDefItem(farhawkID, "vulture", 1, 0.0);
	rmSetObjectDefMinDistance(farhawkID, 0.0);
	rmSetObjectDefMaxDistance(farhawkID, rmXFractionToMeters(0.5));

	// Relics avoid TCs
	int relicID=rmCreateObjectDef("relic");
	rmAddObjectDefItem(relicID, "relic", 1, 0.0);
	rmSetObjectDefMinDistance(relicID, 60.0);
	rmSetObjectDefMaxDistance(relicID, 150.0);
	rmAddObjectDefConstraint(relicID, edgeConstraint);
	rmAddObjectDefConstraint(relicID, rmCreateTypeDistanceConstraint("relic vs relic", "relic", 70.0));
	rmAddObjectDefConstraint(relicID, farAvoidSettlement);
	rmAddObjectDefConstraint(relicID, centerConstraint);
	rmAddObjectDefConstraint(relicID, avoidAll);

	// Text
	rmSetStatusText("",0.8);

	// Start to generate the main terrain
	// Create a center water area
	int centerID=rmCreateArea("center");
	rmSetAreaSize(centerID, 0.105, 0.105);
	rmSetAreaLocation(centerID, 0.5, 0.5);
	rmSetAreaWaterType(centerID, "Egyptian Nile");
	rmAddAreaToClass(centerID, rmClassID("center"));
	rmSetAreaBaseHeight(centerID, 0.0);
	rmSetAreaSmoothDistance(centerID, 50);
	rmSetAreaCoherence(centerID, 0.05);
	rmBuildArea(centerID);

	// Center forest
	int failCount=0;
	int numTries=8*cNumberNonGaiaPlayers;
	for(i=0; <numTries)
	{
		int forestID=rmCreateArea("forest"+i);
		rmSetAreaSize(forestID, rmAreaTilesToFraction(30+10*cNumberNonGaiaPlayers), rmAreaTilesToFraction(30+10*cNumberNonGaiaPlayers));
		rmSetAreaWarnFailure(forestID, false);
		rmSetAreaForestType(forestID, "palm forest");
		rmAddAreaConstraint(forestID, shoreForestConstraint);
	  rmAddAreaConstraint(forestID, forestShoreMax);
	  rmAddAreaConstraint(forestID, forestShoreMin);
		rmAddAreaToClass(forestID, classForest);
		rmSetAreaCoherence(forestID, 1.0);

		if(rmBuildArea(forestID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
	}

	// Text
	rmSetStatusText("",0.7);

	// Place Players
	if(cNumberNonGaiaPlayers == 2)
	{
		int startpos = rmRandInt(1,4);
	  if(startpos == 1)
	  {
			rmPlacePlayer(1, rmRandFloat(0.17,0.23), rmRandFloat(0.17,0.23));
			rmPlacePlayer(2, rmRandFloat(0.77,0.83), rmRandFloat(0.77,0.83));
		}
	  else if(startpos == 2)
	  {
			rmPlacePlayer(1, rmRandFloat(0.77,0.83), rmRandFloat(0.77,0.83));
			rmPlacePlayer(2, rmRandFloat(0.17,0.23), rmRandFloat(0.17,0.23));
		}
	  else if(startpos == 3)
	  {
			rmPlacePlayer(1, rmRandFloat(0.17,0.23), rmRandFloat(0.77,0.83));
			rmPlacePlayer(2, rmRandFloat(0.77,0.83), rmRandFloat(0.17,0.23));
		}
	  else if(startpos == 4)
	  {
			rmPlacePlayer(1, rmRandFloat(0.77,0.83), rmRandFloat(0.17,0.23));
			rmPlacePlayer(2, rmRandFloat(0.17,0.23), rmRandFloat(0.77,0.83));
		}
	}
	else
	{
		rmSetTeamSpacingModifier(0.85);
		rmPlacePlayersCircular(0.4, 0.4, rmDegreesToRadians(5.0));
	}

	// Starting TC
	rmPlaceObjectDefPerPlayer(startingSettlementID, true);

	// Settlements
	if(cNumberNonGaiaPlayers == 2)
	{
		// Settlement 1
	  int id=rmAddFairLoc("Settlement", false, true, 70, 80, 50, 16);
	  rmAddFairLocConstraint(id, settlementAvoidsForest);
		rmAddFairLocConstraint(id, settlementAvoidsShore);

		if(rmPlaceFairLocs())
		{
			id=rmCreateObjectDef("close settlement");
			rmAddObjectDefItem(id, "Settlement", 1, 0.0);
			for(i=1; <cNumberPlayers)
			{
				for(j=0; <rmGetNumberFairLocs(i))
					rmPlaceObjectDefAtLoc(id, i, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j), 1);
			}
		}

		rmResetFairLocs();

		// Settlement 2
		id=rmAddFairLoc("Settlement", true, false, 85, 115, 50, 16);
		rmAddFairLocConstraint(id, farStartingSettleConstraint);
		rmAddFairLocConstraint(id, settlementAvoidsSettlement);
		rmAddFairLocConstraint(id, settlementAvoidsForest);
		rmAddFairLocConstraint(id, settlementAvoidsShore);

		if(rmPlaceFairLocs())
		{
			id=rmCreateObjectDef("far settlement");
			rmAddObjectDefItem(id, "Settlement", 1, 0.0);
			for(i=1; <cNumberPlayers)
			{
				for(j=0; <rmGetNumberFairLocs(i))
				{
				int bonusSettleArea = rmCreateArea("bonus settlement area"+i +j);
					rmSetAreaLocation(bonusSettleArea, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j));
					rmBuildArea(bonusSettleArea);
				 rmPlaceObjectDefAtAreaLoc(id, i, bonusSettleArea);
				}
			}
		}
	}
	else
	{
		id=rmAddFairLoc("Settlement", false, true, 55, 70, 50, 16);
		id=rmAddFairLoc("Settlement", true, false, 70, 100, 50, 16);

		rmAddFairLocConstraint(id, settlementAvoidsForest);
		rmAddFairLocConstraint(id, settlementAvoidsShore);
		rmAddFairLocConstraint(id, settlementAvoidsSettlement);

		if(rmPlaceFairLocs())
		{
			id=rmCreateObjectDef("far settlement2");
			rmAddObjectDefItem(id, "Settlement", 1, 0.0);
			for(i=1; <cNumberPlayers)
			{
				for(j=0; <rmGetNumberFairLocs(i))
					rmPlaceObjectDefAtLoc(id, i, rmFairLocXFraction(i, j), rmFairLocZFraction(i, j), 1);
			}
		}
	}

	// Text
	rmSetStatusText("",0.6);

	// Elevation
	numTries=10*cNumberNonGaiaPlayers;
	failCount=0;
	for(i=0; <numTries)
	{
		int elevID=rmCreateArea("elev"+i);
		rmSetAreaSize(elevID, rmAreaTilesToFraction(100), rmAreaTilesToFraction(200));
		rmSetAreaWarnFailure(elevID, false);
		rmAddAreaConstraint(elevID, avoidBuildings);
		rmAddAreaConstraint(elevID, centerConstraint);
		rmAddAreaConstraint(elevID, avoidImpassableLand);
		rmAddAreaConstraint(elevID, forestConstraint);
		if(rmRandFloat(0.0, 1.0)<0.5)
			rmSetAreaTerrainType(elevID, "SandD");
		rmSetAreaBaseHeight(elevID, rmRandFloat(3.0, 6.0));
		rmSetAreaHeightBlend(elevID, 2);
		rmAddAreaToClass(elevID, classElev);
		rmSetAreaMinBlobs(elevID, 1);
		rmSetAreaMaxBlobs(elevID, 5);
		rmSetAreaMinBlobDistance(elevID, 16.0);
		rmSetAreaMaxBlobDistance(elevID, 40.0);
		rmSetAreaCoherence(elevID, 0.0);

		if(rmBuildArea(elevID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==6)
				break;
		}
		else
			failCount=0;
	}

	// Wrinkles
	numTries=20*cNumberNonGaiaPlayers;
	failCount=0;
	for(i=0; <numTries)
	{
		elevID=rmCreateArea("wrinkle"+i);
		rmSetAreaSize(elevID, rmAreaTilesToFraction(15), rmAreaTilesToFraction(120));
		rmSetAreaWarnFailure(elevID, false);
		rmSetAreaBaseHeight(elevID, rmRandFloat(2.0, 3.0));
		rmSetAreaMinBlobs(elevID, 1);
		rmSetAreaMaxBlobs(elevID, 3);
		if(rmRandFloat(0.0, 1.0)<0.5)
			rmSetAreaTerrainType(elevID, "SandD");
		rmSetAreaMinBlobDistance(elevID, 16.0);
		rmSetAreaMaxBlobDistance(elevID, 20.0);
		rmSetAreaCoherence(elevID, 0.0);
		rmAddAreaToClass(elevID, classElev);
		rmAddAreaConstraint(elevID, forestConstraint);
		rmAddAreaConstraint(elevID, centerConstraint);
		rmAddAreaConstraint(elevID, avoidBuildings);
		rmAddAreaConstraint(elevID, avoidImpassableLand);
		rmAddAreaConstraint(elevID, elevConstraint);

		if(rmBuildArea(elevID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==10)
				break;
		}
		else
			failCount=0;
	}

	// Text
	rmSetStatusText("",0.5);

	// Texture embellishment
	for(i=1; <cNumberPlayers*10)
	{
		int id1=rmCreateArea("beautification"+i);
		rmSetAreaSize(id1, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(id1, "EgyptianRoadA");
		rmAddAreaConstraint(id1, centerConstraint);
		rmAddAreaConstraint(id1, forestConstraint);
		rmSetAreaMinBlobs(id1, 1);
		rmSetAreaMaxBlobs(id1, 5);
		rmSetAreaWarnFailure(id1, false);
		rmSetAreaMinBlobDistance(id1, 16.0);
		rmSetAreaMaxBlobDistance(id1, 40.0);
		rmSetAreaCoherence(id1, 0.6);

		rmBuildArea(id1);
	}

	 for(i=1; <cNumberPlayers*12)
	{
		int id2=rmCreateArea("more beautification"+i);
		rmSetAreaSize(id2, rmAreaTilesToFraction(50), rmAreaTilesToFraction(100));
		rmSetAreaTerrainType(id2, "SandB");
		rmAddAreaConstraint(id2, centerConstraint);
		rmAddAreaConstraint(id2, forestConstraint);
		rmSetAreaMinBlobs(id2, 1);
		rmSetAreaMaxBlobs(id2, 5);
		rmSetAreaWarnFailure(id2, false);
		rmSetAreaMinBlobDistance(id2, 16.0);
		rmSetAreaMaxBlobDistance(id2, 40.0);
		rmSetAreaCoherence(id2, 0.2);

		rmBuildArea(id2);
	}

	// Text
	rmSetStatusText("",0.4);

	// Place stuff
	// Towers
	rmPlaceObjectDefPerPlayer(startingTowerID, true, 4);

	// Straggler trees
	rmPlaceObjectDefPerPlayer(stragglerTreeID, false, rmRandInt(4,7));

	// Gold
	rmPlaceObjectDefPerPlayer(startingGoldID, false);

	// Zebra
	rmPlaceObjectDefPerPlayer(closeZebraID, false);

	// Berries
	rmPlaceObjectDefPerPlayer(closeBerriesID, true);

	// Goats
	rmPlaceObjectDefPerPlayer(closeGoatsID, true);

	// Medium things
	// Gold
	rmPlaceObjectDefPerPlayer(mediumGoldID, false);

	// Goats
	for(i=1; <cNumberPlayers)
		rmPlaceObjectDefAtLoc(mediumGoatsID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i), 1);

	// Far things
	// Gold
	rmPlaceObjectDefPerPlayer(farGoldID, false, rmRandInt(2,3));

	// Bonus huntable
	for(i=1; <cNumberPlayers)
		rmPlaceObjectDefAtLoc(bonusHuntableID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i), 1);
	for(i=1; <cNumberPlayers)
		rmPlaceObjectDefAtLoc(moreBonusHuntableID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i), 1);

	// Berries
	for(i=1; <cNumberPlayers)
		rmPlaceObjectDefAtLoc(farBerriesID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i), 1);

	// Goats
	for(i=1; <cNumberPlayers)
		rmPlaceObjectDefAtLoc(farGoatsID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i), 1);

	// Predators
	rmPlaceObjectDefPerPlayer(farPredatorID, false, 1);

	// Baboons
	if(cNumberNonGaiaPlayers < 3)
	{
		for(i=1; <cNumberPlayers)
			rmPlaceObjectDefAtLoc(baboonID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i), 1);
	}

	// Fish
	rmPlaceObjectDefPerPlayer(playerFishID, false);
	rmPlaceObjectDefPerPlayer(fishID, false);
	rmPlaceObjectDefPerPlayer(moreFishID, false);

	// Text
	rmSetStatusText("",0.3);

	// Forest
	int forestCount=9*cNumberNonGaiaPlayers;
	failCount=0;
	for(i=0; <forestCount)
	{
		int forest1ID=rmCreateArea("forest0"+i);
		rmSetAreaSize(forest1ID, rmAreaTilesToFraction(25), rmAreaTilesToFraction(100));
		rmSetAreaWarnFailure(forest1ID, false);
		rmSetAreaForestType(forest1ID, "palm forest");
		rmAddAreaConstraint(forest1ID, forestSettleConstraint);
		rmAddAreaConstraint(forest1ID, avoidAll);
		rmAddAreaConstraint(forest1ID, forestConstraint);
		rmAddAreaConstraint(forest1ID, centerConstraint);
		rmAddAreaToClass(forest1ID, classForest);
		rmSetAreaMinBlobs(forest1ID, 1);
		rmSetAreaMaxBlobs(forest1ID, 4);
		rmSetAreaMinBlobDistance(forest1ID, 22.0);
		rmSetAreaMaxBlobDistance(forest1ID, 32.0);
		rmSetAreaCoherence(forest1ID, 0.1);
		if(rmBuildArea(forest1ID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==3)
				break;
		}
		else
			failCount=0;
	}

	// Relics
	rmPlaceObjectDefPerPlayer(relicID, false, 1);

	// Random trees
	rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);

	// Hawks
	rmPlaceObjectDefPerPlayer(farhawkID, false, 2);

	// Text
	rmSetStatusText("",0.2);

	// Decoration
	int bushID=rmCreateObjectDef("big bush patch");
	rmAddObjectDefItem(bushID, "bush", 4, 3.0);
	rmSetObjectDefMinDistance(bushID, 0.0);
	rmSetObjectDefMaxDistance(bushID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(bushID, avoidAll);
	rmAddObjectDefConstraint(bushID, centerConstraint);
	rmPlaceObjectDefAtLoc(bushID, 0, 0.5, 0.5, 5*cNumberNonGaiaPlayers);

	int bush2ID=rmCreateObjectDef("small bush patch");
	rmAddObjectDefItem(bush2ID, "bush", 3, 2.0);
	rmAddObjectDefItem(bush2ID, "rock sandstone sprite", 1, 2.0);
	rmSetObjectDefMinDistance(bush2ID, 0.0);
	rmSetObjectDefMaxDistance(bush2ID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(bush2ID, avoidAll);
	rmAddObjectDefConstraint(bush2ID, centerConstraint);
	rmPlaceObjectDefAtLoc(bush2ID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);

	int grassID=rmCreateObjectDef("grass");
	rmAddObjectDefItem(grassID, "grass", 1, 0.0);
	rmSetObjectDefMinDistance(grassID, 0.0);
	rmSetObjectDefMaxDistance(grassID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(grassID, avoidAll);
	rmAddObjectDefConstraint(grassID, centerConstraint);
	rmPlaceObjectDefAtLoc(grassID, 0, 0.5, 0.5, 30*cNumberNonGaiaPlayers);

	int sandDrift=rmCreateObjectDef("blowing sand");
	rmAddObjectDefItem(sandDrift, "sand drift patch", 1, 0.0);
	rmSetObjectDefMinDistance(sandDrift, 0.0);
	rmSetObjectDefMaxDistance(sandDrift, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(sandDrift, avoidAll);
	rmAddObjectDefConstraint(sandDrift, centerConstraint);
	rmAddObjectDefConstraint(sandDrift, edgeConstraint);
	rmAddObjectDefConstraint(sandDrift, driftVsDrift);
	rmAddObjectDefConstraint(sandDrift, avoidBuildings);
	rmPlaceObjectDefAtLoc(sandDrift, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);

	int column=rmCreateObjectDef("broken columns");
	rmAddObjectDefItem(column, "columns broken", 1, 0.0);
	rmSetObjectDefMinDistance(column, 0.0);
	rmSetObjectDefMaxDistance(column, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(column, avoidAll);
	rmAddObjectDefConstraint(column, centerConstraint);
	rmAddObjectDefConstraint(column, edgeConstraint);
	rmAddObjectDefConstraint(column, avoidBuildings);
	rmPlaceObjectDefAtLoc(column, 0, 0.5, 0.5, 6*cNumberNonGaiaPlayers);

	// Text
	rmSetStatusText("",0.1);

	// Water Decoration
	int papyrusID=rmCreateObjectDef("lone papyrus");
	rmAddObjectDefItem(papyrusID, "papyrus", 2, 2.0);
	rmSetObjectDefMinDistance(papyrusID, 0.0);
	rmSetObjectDefMaxDistance(papyrusID, 600);
	rmAddObjectDefConstraint(papyrusID, avoidAll);
	rmAddObjectDefConstraint(papyrusID, nearShore);
	rmPlaceObjectDefAtLoc(papyrusID, 0, 0.5, 0.5, 6*cNumberNonGaiaPlayers);

	int papyrus2ID=rmCreateObjectDef("grouped papyrus");
	rmAddObjectDefItem(papyrus2ID, "papyrus", 3, 7.0);
	rmSetObjectDefMinDistance(papyrus2ID, 0.0);
	rmSetObjectDefMaxDistance(papyrus2ID, 600);
	rmAddObjectDefConstraint(papyrus2ID, avoidAll);
	rmAddObjectDefConstraint(papyrus2ID, nearShore);
	rmPlaceObjectDefAtLoc(papyrus2ID, 0, 0.5, 0.5, 4*cNumberNonGaiaPlayers);

	int lilyID=rmCreateObjectDef("water lilly");
	rmAddObjectDefItem(lilyID, "water lilly", 1, 0.0);
	rmSetObjectDefMinDistance(lilyID, 0.0);
	rmSetObjectDefMaxDistance(lilyID, 600);
	rmAddObjectDefConstraint(lilyID, avoidAll);
	rmPlaceObjectDefAtLoc(lilyID, 0, 0.5, 0.5, 8*cNumberNonGaiaPlayers);

	int riverBushID=rmCreateObjectDef("bushs by river");
	rmAddObjectDefItem(riverBushID, "bush", 3, 3.0);
	rmAddObjectDefItem(riverBushID, "grass", 7, 8.0);
	rmSetObjectDefMinDistance(riverBushID, 0.0);
	rmSetObjectDefMaxDistance(riverBushID, 600);
	rmAddObjectDefConstraint(riverBushID, avoidAll);
	rmAddObjectDefConstraint(riverBushID, nearWater);
	rmPlaceObjectDefAtLoc(riverBushID, 0, 0.5, 0.5, 5*cNumberNonGaiaPlayers);

	// Text
	rmSetStatusText("",0.01);

	// Triggers
	// Disable bolt for a minute
	int zeusPlayer=0;
	for(i=1; <cNumberPlayers)
	{
		if(rmGetPlayerCiv(i) == cCivZeus)
		{
			zeusPlayer=1;
			rmCreateTrigger("disable bolt"+i);
			rmSetTriggerActive(true);
			rmSetTriggerPriority(5);
			rmAddTriggerCondition("Timer");
			rmSetTriggerConditionParamInt("Param1", 1);
			rmAddTriggerEffect("Player Kill All God Powers");
			rmSetTriggerEffectParamInt("Player", i);

			rmCreateTrigger("grant bolt"+i);
			rmSetTriggerActive(true);
			rmSetTriggerPriority(5);
			rmAddTriggerCondition("Timer");
			rmSetTriggerConditionParamInt("Param1", 60);
			rmAddTriggerEffect("Grant God Power");
			rmSetTriggerEffectParamInt("PlayerID", i);
			rmSetTriggerEffectParam("PowerName", "bolt");
			rmSetTriggerEffectParamInt("Count", 1);
		}
	}

	// Notify players 1
	if(cNumberTeams > 2)
	{
		rmCreateTrigger("team notification");
		rmSetTriggerPriority(5);
		rmSetTriggerActive(true);
		rmAddTriggerCondition("Timer");
		rmAddTriggerEffect("Send Spoofed Chat");
		rmSetTriggerEffectParam("Message", "RebelsRising: This map has not been optimized for 4v4+ and FFA. No balance guaranteed - play at your own risk!", false);
		rmSetTriggerEffectParam("PlayerID", ""+0);
	}
	else if(cNumberNonGaiaPlayers > 6)
	{
		rmCreateTrigger("player notification");
		rmSetTriggerPriority(5);
		rmSetTriggerActive(true);
		rmAddTriggerCondition("Timer");
		rmAddTriggerEffect("Send Spoofed Chat");
		rmSetTriggerEffectParam("Message", "RebelsRising: This map has not been optimized for 4v4+ and FFA. No balance guaranteed - play at your own risk!", false);
		rmSetTriggerEffectParam("PlayerID", ""+0);
	}

	// Notify players 2
	if(zeusPlayer==1)
	{
		rmCreateTrigger("bolt notification");
		rmSetTriggerPriority(5);
		rmSetTriggerActive(true);
		rmAddTriggerCondition("Timer");
		rmAddTriggerEffect("Send Spoofed Chat");
		rmSetTriggerEffectParam("Message", "RebelsRising: Zeus' Bolt power has been disabled for the first minute.", false);
		rmSetTriggerEffectParam("PlayerID", ""+0);
	}
}

// Main init
void main(void)
{
	int randomMap = rmRandInt(1,6);
	if (randomMap==1)
		arabia();
	else if (randomMap==2)
		bluelagoon();
	else if (randomMap==3)
		frozenwastes();
	else if (randomMap==4)
		niledelta();
	else if (randomMap==5)
		painteddesert();
	else if (randomMap==6)
		sacredpond();
}